static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "hcal.h"

/*
add_city.c - Add a city to the cities by using the city mlist
*/

#if defined (PROTOTYPES)
int add_city(void) {
#else
int add_city() {
#endif
	city_t		*cptr;
	cur_mlist_t	*mptr;
	char		 temp[20];

	if (!menu_city)
		menu_city = mk_menu(menu_list_city);
	cur_menu_reset(menu_city);

	if (!cur_menu_ask("Add a City",menu_city,NULL))
		return 0;

	dirty = YES;
	tdirty = YES;
	/* get city */
	mptr = menu_city;
	cptr = findadd_city(mptr->s_answer,NULL);
	mptr = mptr->next;
	/* Latitude */
	if (mptr->s_answer[0] == ' ')
		mptr->s_answer[0] = '0';
	if (mptr->s_answer[3] == ' ')
		mptr->s_answer[3] = '0';
	if (mptr->s_answer[6] == ' ')
		mptr->s_answer[6] = '0';
	cptr->latdeg = ((mptr->s_answer[0]-'0') * 10) + mptr->s_answer[1] - '0';
	cptr->latmin = ((mptr->s_answer[3]-'0') * 10) + mptr->s_answer[4] - '0';
	cptr->latsec = ((mptr->s_answer[6]-'0') * 10) + mptr->s_answer[7] - '0';
	if (mptr->s_answer[9] == 'S') {
		cptr->latdeg = -cptr->latdeg;
		cptr->latmin = -cptr->latmin;
		cptr->latsec = -cptr->latsec;
	}
	mptr = mptr->next;
	/* Longitude */
	if (mptr->s_answer[0] == ' ')
		mptr->s_answer[0] = '0';
	if (mptr->s_answer[1] == ' ')
		mptr->s_answer[1] = '0';
	if (mptr->s_answer[4] == ' ')
		mptr->s_answer[4] = '0';
	if (mptr->s_answer[7] == ' ')
		mptr->s_answer[7] = '0';
	cptr->longdeg = ((mptr->s_answer[0] - '0') * 100) +
		((mptr->s_answer[1] - '0') * 10) + mptr->s_answer[2] - '0';
	cptr->longmin = ((mptr->s_answer[4] - '0') * 10) +
		mptr->s_answer[5] - '0';
	cptr->longsec = ((mptr->s_answer[7] - '0') * 10) +
		mptr->s_answer[8] - '0';
	if (mptr->s_answer[10] == 'E') {
		cptr->longdeg = -cptr->longdeg;
		cptr->longmin = -cptr->longmin;
		cptr->longsec = -cptr->longsec;
	}
	mptr = mptr->next;
	/* Timezone */
	cptr->tzone = mptr->i_answer;
	mptr = mptr->next;
	/* m dst start */
	if (*mptr->s_answer) {
		cptr->dst_start_month = mptr->i_answer - 1;
		mptr = mptr->next;
		/* w dst start */
		if (mptr->i_answer > 4)
			cptr->dst_start_day = 4 - mptr->i_answer;
		else
			cptr->dst_start_day = mptr->i_answer;
		mptr = mptr->next;
		/* m dst end */
		cptr->dst_end_month = mptr->i_answer - 1;
		mptr = mptr->next;
		/* w dst end */
		if (mptr->i_answer > 4)
			cptr->dst_end_day = 4 - mptr->i_answer;
		else
			cptr->dst_end_day = mptr->i_answer;
		if (cptr->dst_start_month == 12 ||
			cptr->dst_end_month == 12 ||
			cptr->dst_start_day == -4  || cptr->dst_end_day == -4)
			cptr->dst_start_month = -1;
	}
	else
		cptr->dst_start_month = -1;
	return 1;
}

/*
add_item.c - Add a general item to a calendar date.
*/

#if defined (PROTOTYPES)
int add_item(void) {
#else
int add_item() {
#endif
	info_t		*iptr;
	cur_mlist_t	*mptr;

	if (!menu_general)
		menu_general = mk_menu(menu_list_general);
	cur_menu_reset(menu_general);
	if (!cur_menu_ask("Enter a General Item",menu_general,size_verify))
		return 0;
	dirty = YES;
	mptr = menu_general;
	iptr = (info_t *)new(sizeof(info_t));
	add_to_day(day + mptr->i_answer,iptr);
	mptr = mptr->next;
	iptr->bold = mptr->i_answer - 1;
	mptr = mptr->next;
	iptr->time.word1 = mptr->i_answer;
	iptr->time.word2 = mptr->i_lower;
	mptr = mptr->next;
	iptr->calendar = mk_string(mptr->s_answer);
	mptr = mptr->next;
	iptr->schedule = mk_string(mptr->s_answer);
	if (iptr->calendar)
		iptr->items = break_up(menu_general->i_answer,&iptr->time,iptr->calendar,iptr->bold,NULL);
	return 1;
}
/*
add_jdate.c - Add jdate information to a calendar date
*/

#if defined (PROTOTYPES)
int add_jdate(int date) {
#else
int add_jdate(date) int date; {
#endif
	cur_mlist_t	*mptr;
	day_data_t	*tday;
	char		 temp[20];

	if (!menu_jdate)
		menu_jdate = mk_menu(menu_list_jdate);
	cur_menu_reset(menu_jdate);
	sprintf(temp,"%s %d",month[current_month],date);
	cur_mlist_set(menu_jdate,temp,0);

	if (!cur_menu_ask("Add the Jdate",menu_jdate,NULL))
		return 0;

	dirty = YES;

	mptr = menu_jdate;
	tday = day + date;
	mptr = mptr->next;
	tday->jmonth = mk_string(mptr->s_answer);
	mptr = mptr->next;
	tday->jday = mptr->i_answer;
	mptr = mptr->next;
	tday->jyear = mptr->i_answer;
	return 1;
	}
/*
add_misc.c - Ask to add information that should already be precalculated
				by the program
*/

static char *warning[] = {
	"This menu is for adding miscellaenous information to the calendar.",
	"This calendar information is automatically calculated and should",
	"be already on the calendar.  If it is not there normally this",
	"indicates a problem in the program, and the program should be",
	"corrected.  This routine is included in case this happens, and to",
	"allow accidental deletes to be corrected.",
	"",
	"This information is :",
	"",
	"Hebrew Date - Hebrew date information",
	"Shabbath    - Add a Shabbath to the system",
	"Holiday     - Make the postscript highlight the date",
	"Candles     - Set a candle/Havdalah lighting time",
	"Chanukah    - Have a Chanukiah icon placed in the date",
	"Omer        - Have an Omer icon placed in the date",
	NULL,
	};

#if defined (PROTOTYPES)
int add_misc(void) {
#else
int add_misc() {
#endif
	cur_alist_t *list;

	cur_text_dsp(warning);
	list = NULL;
	list = cur_alist_add(list,TYPE_JDATE,NULL);
	list = cur_alist_add(list,TYPE_SHABBAT,NULL);
	list = cur_alist_add(list,TYPE_HOLIDAY,NULL);
	list = cur_alist_add(list,TYPE_CANDLES,NULL);
	list = cur_alist_add(list,TYPE_CHANUKAH,NULL);
	list = cur_alist_add(list,TYPE_OMER,NULL);
	list = cur_alist_add(list,TYPE_QUIT,NULL);
	cur_alist_ask("Pick type of item to add",list,1,NULL,mprc_misc,
			mprt_misc);
	cur_alist_free(list);
}
/*
add_mitzvah.c - add a bar mitzvah to a Friday/Shabbat
*/

#if defined (PROTOTYPES)
int add_mitzvah(void) {
#else
int add_mitzvah() {
#endif
	cur_mlist_t	*mptr;
	mitzvah_t	*mitz;

	if (!menu_mitzvah)
		menu_mitzvah = mk_menu(menu_list_mitzvah);
	cur_menu_reset(menu_mitzvah);
	if (!cur_menu_ask("Enter a Bar Mitzvah",menu_mitzvah,NULL))
		return 0;
	dirty = YES;
	mitz = (mitzvah_t *)new(sizeof(mitzvah_t));
	day[menu_mitzvah->i_answer].mitzvah = mitz;
	mptr = menu_mitzvah->next;
	mitz->type = mptr->i_answer - 1;
	mptr = mptr->next;
	mitz->place = mptr->i_answer;
	mptr = mptr->next;
	mitz->who = mk_string(mptr->s_answer);
	mptr = mptr->next;
	if (mptr->s_answer && *mptr->s_answer)
		mitz->schedule = mk_string(mptr->s_answer);
	else
		mitz->schedule = NULL;
	return 1;
}
/*
add_shabbat.c - Add shabbath information to a date (reached via add_misc)
*/

#if defined (PROTOTYPES)
int add_shabbat(void) {
#else
int add_shabbat() {
#endif
	cur_mlist_t	*mptr;
	day_data_t	*tday;

	if (!menu_shabbat)
		menu_shabbat = mk_menu(menu_list_shabbat);
	cur_menu_reset(menu_shabbat);

	if (!cur_menu_ask("Add the Shabbat",menu_shabbat,NULL))
		return 0;

	dirty = YES;

	mptr = menu_shabbat;
	tday = day + mptr->i_answer;
	tday->shabbat = (shabbat_t *)new(sizeof(shabbat_t));
	mptr = mptr->next;
	tday->shabbat->autogenerated = NO;
	tday->shabbat->name = mk_string(mptr->s_answer);
	mptr = mptr->next;
	tday->shabbat->torah = mk_string(mptr->s_answer);
	mptr = mptr->next;
	tday->shabbat->prophet = mk_string(mptr->s_answer);
	mptr = mptr->next;
	tday->shabbat->schedule = mk_string(mptr->s_answer);
	return 1;
	}
/*
edit_city.c - Edit the information for a City
*/

#if defined (PROTOTYPES)
int edit_city(city_t *city) {
#else
int edit_city(city) city_t *city; {
#endif
	int		 incr;
	cur_mlist_t	*mptr;
	char		 temp[20];

	if (!menu_city)
		menu_city = mk_menu(menu_list_city);
	cur_menu_reset(menu_city);

	mptr = menu_city;
	menu_city->enterable = NO;
	cur_mlist_set(mptr,city->name,0);
	mptr = mptr->next;
	if (city->latdeg < 0 || city->latmin < 0 || city->latsec < 0)
		sprintf(temp,"%2.2d:%2.2d:%2.2d S",-city->latdeg,-city->latmin,
			-city->latsec);
	else
		sprintf(temp,"%2.2d:%2.2d:%2.2d N",city->latdeg,city->latmin,
			city->latsec);
	cur_mlist_set(mptr,temp,0);
	mptr = mptr->next;
	if (city->longdeg < 0 || city->longmin < 0 || city->longsec < 0)
		sprintf(temp,"%2.2d:%2.2d:%2.2d E",-city->longdeg,
			-city->longmin,-city->longsec);
	else
		sprintf(temp,"%2.2d:%2.2d:%2.2d W",city->longdeg,
			city->longmin,city->longsec);
	cur_mlist_set(mptr,temp,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,NULL,city->tzone);
	mptr = mptr->next;
	if (city->dst_start_month >= 0)
		cur_mlist_set(mptr,month[city->dst_start_month],0);
	else
		mptr->l_answer = NULL;
	mptr = mptr->next;
	if (city->dst_start_month >= 0) {
		if (city->dst_start_day < 0)
			cur_mlist_set(mptr,weekth[4 - city->dst_start_day],0);
		else
			cur_mlist_set(mptr,weekth[city->dst_start_day],0);
	}
	else
		mptr->l_answer = NULL;
	mptr = mptr->next;
	if (city->dst_start_month >= 0)
		cur_mlist_set(mptr,month[city->dst_end_month],0);
	else
		mptr->l_answer = NULL;
	mptr = mptr->next;
	if (city->dst_start_month >= 0) {
		if (city->dst_end_day < 0)
			cur_mlist_set(mptr,weekth[4 - city->dst_end_day],0);
		else
			cur_mlist_set(mptr,weekth[city->dst_end_day],0);
	}
	else
		mptr->l_answer = NULL;

	if (!cur_menu_ask("Edit the City",menu_city,NULL)) {
		menu_city->enterable = YES;
		return 0;
	}

	menu_city->enterable = YES;
	dirty = YES;
	tdirty = YES;

	mptr = menu_city->next;
	/* Latitude */
	city->latdeg = ((mptr->s_answer[0] - '0') * 10) +
			mptr->s_answer[1] - '0';
	city->latmin = ((mptr->s_answer[3] - '0') * 10) +
			mptr->s_answer[4] - '0';
	city->latsec = ((mptr->s_answer[6] - '0') * 10) +
			mptr->s_answer[7] - '0';
	if (mptr->s_answer[9] == 'S') {
		city->latdeg = -city->latdeg;
		city->latmin = -city->latmin;
		city->latsec = -city->latsec;
	}
	mptr = mptr->next;
	/* Longitude */
	if (mptr->s_answer[0] == ' ')
		mptr->s_answer[0] = '0';
	if (mptr->s_answer[1] == ' ')
		mptr->s_answer[1] = '0';
	if (mptr->s_answer[4] == ' ')
		mptr->s_answer[4] = '0';
	if (mptr->s_answer[7] == ' ')
		mptr->s_answer[7] = '0';
	city->longdeg = ((mptr->s_answer[0] - '0') * 100) +
		((mptr->s_answer[1] - '0') * 10) + mptr->s_answer[2] - '0';
	city->longmin = ((mptr->s_answer[4] - '0') * 10) +
		mptr->s_answer[5] - '0';
	city->longsec = ((mptr->s_answer[7] - '0') * 10) +
		mptr->s_answer[8] - '0';
	if (mptr->s_answer[10] == 'E') {
		city->longdeg = -city->longdeg;
		city->longmin = -city->longmin;
		city->longsec = -city->longsec;
	}
	mptr = mptr->next;
	/* Timezone */
	city->tzone = mptr->i_answer;
	mptr = mptr->next;
	/* m dst start */
	if (*mptr->s_answer) {
		city->dst_start_month = mptr->i_answer - 1;
		mptr = mptr->next;
		/* w dst start */
		if (mptr->i_answer > 4)
			city->dst_start_day = 4 - mptr->i_answer;
		else
			city->dst_start_day = mptr->i_answer;
		mptr = mptr->next;
		/* m dst end */
		city->dst_end_month = mptr->i_answer - 1;
		mptr = mptr->next;
		/* w dst end */
		if (mptr->i_answer > 4)
			city->dst_end_day = 4 - mptr->i_answer;
		else
			city->dst_end_day = mptr->i_answer;
		if (city->dst_start_month == 12 ||
				city->dst_end_month == 12 ||
				city->dst_start_day == -4 ||
				city->dst_end_day == -4)
			city->dst_start_month = -1;
	}
	return 1;
}
/*
edit_item.c - Edit a general item on a date
*/

#if defined (PROTOTYPES)
int edit_item(int date,info_t *iptr) {
#else
int edit_item(date,iptr) int date;info_t *iptr; {
#endif
	int		 items;
	cur_mlist_t	*mptr;
	char		 temp[20];

	if (!menu_general)
		menu_general = mk_menu(menu_list_general);
	cur_menu_reset(menu_general);

	items = iptr->items;
	iptr->items = 0;
	mptr = menu_general;
	menu_general->enterable = NO;
	sprintf(temp,"%s %d",month[current_month],date);
	cur_mlist_set(mptr,temp,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,NULL,iptr->bold + 1);
	mptr = mptr->next;
	mlist_set_time(date,mptr,&iptr->time);
	mptr = mptr->next;
	cur_mlist_set(mptr,iptr->calendar,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,iptr->schedule,0);

	if (!cur_menu_ask("Edit General Item",menu_general,size_verify)) {
		menu_general->enterable = YES;
		iptr->items = items;
		return 0;
	}

	menu_general->enterable = YES;
	dirty = YES;

	mptr = menu_general->next;
	iptr->bold = mptr->i_answer - 1;
	mptr = mptr->next;
	iptr->time.word1 = mptr->i_answer;
	iptr->time.word2 = mptr->i_lower;
	mptr = mptr->next;
	if (iptr->calendar)
		free(iptr->calendar);
	iptr->calendar = mk_string(mptr->s_answer);
	mptr = mptr->next;
	if (iptr->schedule)
		free(iptr->schedule);
	iptr->schedule = mk_string(mptr->s_answer);

	if (iptr->calendar)
		iptr->items = break_up(date,&iptr->time,iptr->calendar,iptr->bold,NULL);

	return 1;
}
/*
edit_jdate.c - Edit Jdate information
*/

#if defined (PROTOTYPES)
int edit_jdate(int date,day_data_t *tday) {
#else
int edit_jdate(date,tday) int date;day_data_t *tday; {
#endif
	cur_mlist_t	*mptr;
	char		 temp[20];

	if (!menu_jdate)
		menu_jdate = mk_menu(menu_list_jdate);
	cur_menu_reset(menu_jdate);

	mptr = menu_jdate;
	sprintf(temp,"%s %d",month[current_month],date);
	cur_mlist_set(mptr,temp,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,tday->jmonth,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,NULL,tday->jday);
	mptr = mptr->next;
	cur_mlist_set(mptr,NULL,tday->jyear);

	if (!cur_menu_ask("Edit the Jewish Date",menu_jdate,NULL))
		return 0;

	dirty = YES;

	mptr = menu_jdate->next;
	if (tday->jmonth)
		free(tday->jmonth);
	tday->jmonth = mk_string(mptr->s_answer);
	mptr = mptr->next;
	tday->jday = mptr->i_answer;
	mptr = mptr->next;
	tday->jyear = mptr->i_answer;
	return 1;
}
/*
edit_minyan.c - Edit minyan information
*/

#if defined (PROTOTYPES)
void edit_minyan(void) {
#else
void edit_minyan() {
#endif
	int		 current;
	int		 dow;
	cur_alist_t	*list;
	int		 loop;
	day_data_t	*this_day;

	list = NULL;
	for (loop = 0;loop < 9;loop++)
		list = cur_alist_add(list,TYPE_MINYANW + loop,
				(void *)(minyan + loop));
	list = cur_alist_add(list,TYPE_QUIT,NULL);
	for (loop = 1,dow = first_week_day;
			loop <= numdays;
			loop++,dow = (dow == 6 ? 0 : dow + 1)) {
		this_day = day + loop;
		list = cur_alist_add(list,TYPE_MINYAND + loop,(void *)this_day);
	}
	current = 1;
	asking = YES;
	while (asking)
		current = cur_alist_ask(
				"Day To Edit         Shaharit   Mincha     Mariv",
				list,current,NULL,mprc_minyan,mprt_minyan);
	cur_alist_free(list);
	asking = YES;
}
/*
edit_mitzvah.c - Edit Bar mitzvah information
*/

#if defined (PROTOTYPES)
int edit_mitzvah(int date,day_data_t *tday) {
#else
int edit_mitzvah(date,tday) int date;day_data_t *tday; {
#endif
	cur_mlist_t	*mptr;
	char		 temp[20];
	mitzvah_t	*mitz;

	if (!menu_mitzvah)
		menu_mitzvah = mk_menu(menu_list_mitzvah);
	cur_menu_reset(menu_mitzvah);

	mitz = tday->mitzvah;
	mptr = menu_mitzvah;
	mptr->enterable = NO;
	sprintf(temp,"%s %d",month[current_month],date);
	cur_mlist_set(mptr,temp,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,mitztypes[mitz->type],0);
	mptr = mptr->next;
	cur_mlist_set(mptr,NULL,mitz->place);
	mptr = mptr->next;
	cur_mlist_set(mptr,mitz->who,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,mitz->schedule,0);

	if (!cur_menu_ask("Edit Bar Mitzvah",menu_mitzvah,NULL)) {
		menu_mitzvah->enterable = YES;
		return 0;
	}

	menu_mitzvah->enterable = YES;
	dirty = YES;

	mptr = menu_mitzvah->next;
	mitz->type = mptr->i_answer - 1;
	mptr = mptr->next;
	mitz->place = mptr->i_answer;
	mptr = mptr->next;
	if (!mitz->who || strcmp(mitz->who,mptr->s_answer) != 0) {
		if (mitz->who)
			free(mitz->who);
		mitz->who = mk_string(mptr->s_answer);
	}
	mptr = mptr->next;
	if (!mitz->schedule || strcmp(mitz->schedule,mptr->s_answer) != 0) {
		if (mitz->schedule)
			free(mitz->schedule);
		mitz->schedule = mk_string(mptr->s_answer);
	}
	return 1;
}
/*
edit_shabbat.c - Edit shabbath information
*/
#if defined (PROTOTYPES)
int edit_shabbat(int date,day_data_t *tday) {
#else
int edit_shabbat(date,tday) int date;day_data_t *tday; {
#endif
	int		 changed = NO;
	cur_mlist_t	*mptr;
	char		 temp[20];
	shabbat_t	*shab;

	if (!menu_shabbat)
		menu_shabbat = mk_menu(menu_list_shabbat);
	cur_menu_reset(menu_shabbat);

	shab = tday->shabbat;
	mptr = menu_shabbat;
	mptr->enterable = NO;
	sprintf(temp,"%s %d",month[current_month],date);
	cur_mlist_set(mptr,temp,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,shab->name,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,shab->torah,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,shab->prophet,0);
	mptr = mptr->next;
	cur_mlist_set(mptr,shab->schedule,0);

	if (!cur_menu_ask("Edit the Shabbat",menu_shabbat,NULL)) {
		menu_shabbat->enterable = YES;
		return 0;
	}

	menu_shabbat->enterable = YES;
	dirty = YES;

	mptr = menu_shabbat->next;
	if (!shab->name || strcmp(shab->name,mptr->s_answer) != 0) {
		changed = YES;
		if (shab->name)
			free(shab->name);
		shab->name = mk_string(mptr->s_answer);
	}
	mptr = mptr->next;
	if (!shab->torah || strcmp(shab->torah,mptr->s_answer) != 0) {
		changed = YES;
		if (shab->torah)
			free(shab->torah);
		shab->torah = mk_string(mptr->s_answer);
	}
	mptr = mptr->next;
	if (!shab->prophet || strcmp(shab->prophet,mptr->s_answer) != 0) {
		changed = YES;
		if (shab->prophet)
			free(shab->prophet);
		shab->prophet = mk_string(mptr->s_answer);
	}
	mptr = mptr->next;
	if (!shab->schedule || strcmp(shab->schedule,mptr->s_answer) != 0) {
		changed = YES;
		if (shab->schedule)
			free(shab->schedule);
		shab->schedule = mk_string(mptr->s_answer);
	}
	if (changed)
		shab->autogenerated = NO;
	return 1;
}
/*
modify_candles.c - Modify candle lighting times
*/

#if defined (PROTOTYPES)
void modify_candles(int date) {
#else
void modify_candles(date) int date; {
#endif
	day_data_t	*tday;
	int		 type;

	tday = day + date;
	if (!menu_candles)
		menu_candles = mk_menu(menu_list_candles);
	switch (tday->candles.word1) {
		case TIME_CANDLES_EARLY:
			type = 1;
			break;
		case TIME_CANDLES_LATE:
			type = 2;
			break;
		case TIME_CANDLES_HAVDALAH:
			type = 3;
			break;
		default:
			type = 4;
			break;
	}
	cur_mlist_set(menu_candles, NULL, type);
	if (cur_menu_ask("Edit Candles",menu_candles,NULL)) {
		changed_all = YES;
		switch (menu_candles->i_answer) {
			case 1:
				tday->candles.word1 = TIME_CANDLES_EARLY;
				break;
			case 2:
				tday->candles.word1 = TIME_CANDLES_LATE;
				break;
			case 3:
				tday->candles.word1 = TIME_CANDLES_HAVDALAH;
				break;
			case 4:
				tday->candles.word1 = 0;
				break;
		}
	}
	return;
}
