static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "cur.h"
#include <signal.h>
#include <ctype.h>
/*
flushinp.c - These routine are not always provided in curses. These provide
		stubbs.
*/

#if defined(LYNUX) || defined(SUN)
void flushinp() {}
void beep() { putchar(007); }
#endif

/*
catch_int.c - This routine catches user interupts in order for curses to exit
		gracefully
*/

#if defined(PROTOTYPES)
void catch_int(int dummy) {
#else
void catch_int(dummy) int dummy; {
#endif
	signal(SIGINT,SIG_IGN);
	if (cur_ask_y_n("Do you want to quit","Quit")) {
		finalize();
		exit(0);
	}
	signal(SIGINT,catch_int);
}

/*
cur_alist_ask.c - This routine asks for a selection in alist 'list'.
*/

#if defined(PROTOTYPES)
int cur_alist_ask(char *title,cur_alist_t *list,int current,char *actions,
		int action(int,int,void *),
		char *print(int,void *,char *)) {
#else
int cur_alist_ask(title,list,current,actions,action,print) 
char *title; cur_alist_t *list;int current;char *actions;
int (*action)();char *(*print)();
{
#endif
	int		 ch;
	int		 count;
	int		 litem;
	int		 linenum;
	cur_alist_t	*llptr;
	int		 loop;
	int		 loop2;
	cur_alist_t	*lptr;
	int		 more;
	int		 size;
	int		 sitem;
	int		 status;
	char		 string[100];
	int		 titem;
	WINDOW		*window;

	for (llptr = NULL,lptr = list,count = 0;lptr;
			llptr = lptr,lptr = lptr->next,count++)
		;
	size = count + 4;
	titem = 1;
	if (size > LINES - 3) {
		size = LINES - 3;
		titem = count - (size - 4) + 3;
	}
	window = newwin(size, 60, 3, (COLS - 60) / 2);
	if (current == 0)
		current = 1;
	for (loop = 1,lptr = list;loop < current;loop++,lptr = lptr->next)
		;
	sitem = current;
	if (sitem < size - 6)
		sitem = 1;
	status = CUR_ALIST_CONTINUE;
	while (status == CUR_ALIST_CONTINUE || status == CUR_ALIST_REDRAW) {
		box(window, '|', '-');
		mvwaddch(window, 0,0, '+');
		mvwaddch(window, 0, 60 - 1, '+');
		mvwaddch(window, size - 1,  0, '+');
		mvwaddch(window, size - 1, 60 - 1, '+');
		mvwaddstr(window,1,4,title);
		for (loop = 1;loop < 60;loop++)
			mvwaddch(window,2,loop,'-');
		mvwaddch(window,2,0,'+');
		mvwaddch(window,2,60 - 1,'+');
		more = 1;
		while (more) {
			if (sitem > titem)
				sitem = titem;
			for (loop = 3;loop < size -1;loop++)
				for (loop2 = 1;loop2 < 60 -1;loop2++)
					mvwaddch(window,loop,loop2,' ');
			for (loop = 1,llptr = list;loop < sitem;
					loop++,llptr = llptr->next)
				;
			litem = sitem;
			if (sitem != 1) {
				mvwaddstr(window,3,3,"More ...");
				linenum = 5;
			}
			else
				linenum = 3;
			while (linenum < size - 1 && (linenum < size - 3 ||
					litem > count - 2)) {
				if (llptr == lptr)
					wstandout(window);
				print(llptr->type,llptr->data,string);
				string[50] = '\0';
				mvwaddstr(window,linenum,4,string);
				if (llptr == lptr)
					wstandend(window);
				llptr = llptr->next;
				linenum++;
				litem++;
			}
			if (litem < count)
				mvwaddstr(window,size - 2,3,"More ...");
			wrefresh(window);
			flushinp();
			ch = cur_getc();
			switch (ch) {
				case 27:
					more = 0;
					lptr = NULL;
					break;
				case -1 :
					break;
				case KEY_DOWN :
					if (lptr->next) {
						lptr = lptr->next;
						current++;
						if (litem != count && current
								> litem - 3) {
							if (sitem == 1)
								sitem = 4;
							else
								sitem++;
						}
					}
					else
						beep();
					break;
				case KEY_NPAGE :
					for (loop = 0;lptr->next && loop <
							size - 6; loop++) {
						lptr = lptr->next;
						current++;
						if (litem != count && current >
								litem - 3) {
							if (sitem == 1)
								sitem = 4;
							else
								sitem++;
						}
					}
					break;
				case KEY_PPAGE :
					for (loop = 0;lptr->last && loop < 
							size - 6; loop++) {
						lptr = lptr->last;
						current--;
						if (sitem != 1 && current 
								< sitem + 2) {
							if (sitem == 4)
								sitem = 1;
							else
								sitem--;
						}
					}
					break;
				case KEY_UP :
					if (lptr->last) {
						lptr = lptr->last;
						current--;
						if (sitem != 1 && current < 
								sitem + 2) {
							if (sitem == 4)
								sitem = 1;
							else
								sitem--;
						}
					}
					else
						beep();
					break;
				case '\n':
				case ' ':
					more = 0;
					break;
					/* fall through */
				default :
					if (actions && strchr(actions,ch))
						more = 0;
					break;
			}
		}
		if (lptr)
			status = action(ch,lptr->type,lptr->data);
		else
			status = CUR_ALIST_END;
	}
	cur_rm_window(window);
	return current;
}

/*
cur_ask_num_lud.c - Ask the question 'string1' and expect a numeric answer
		between 'lower' and 'upper'. 'default_v' is the default.
			If an improper value is input, reask 'string2'
*/

#if defined(PROTOTYPES)
int cur_ask_num_lud(char *string1, char *string2, int lower, int upper,
		int default_v) {
#else
int cur_ask_num_lud(string1,string2,lower,upper,default_v)
char *string1; char *string2; int lower; int upper; int default_v; {
#endif
	int	 ch;
	int	 length;
	int	 more;
	int	 number;
	int	 place;
	char	 temp[200];
	WINDOW	*window;

	sprintf(temp,"%s (%d)?",string1,default_v);
	length = strlen(temp) + 10;
	place = length - 7;
	window = newwin(5, length, 6, (COLS / 2) - (length / 2));
	wclear(window);
	box(window, '|', '-');
	waddch(window, '+');
	mvwaddch(window, 0, length, '+');
	mvwaddch(window, 5,  0, '+');
	mvwaddch(window, 5, length, '+');
	mvwaddstr(window, 2, 2, temp);
	wrefresh(window);
	number = 0;
	flushinp();
	more = NO;
	while (isdigit(ch = cur_getc()) || ch == '\b') {
		if (isdigit(ch)) {
			more = YES;
			number = number * 10 + ch - '0';
			mvwaddch(window, 2, place++,ch);
			wrefresh(window);
		} else {
			number = number / 10;
			if (place > length - 7) {
				mvwaddch(window, 2, --place,' ');
				wrefresh(window);
			}
		}
	}
	if (!more)
		number = default_v;
	cur_rm_window(window);
	while (ch != '\n' || number < lower || number > upper) {
		sprintf(temp,"Please enter number between %d and %d. %s (%d)?",
				lower,upper,string2,default_v);
		length = strlen(temp) + 10;
		place = length - 7;
		window = newwin(5, length, 6, (COLS / 2) - (length / 2));
		wclear(window);
		box(window, '|', '-');
		waddch(window, '+');
		mvwaddch(window, 0, length, '+');
		mvwaddch(window, 5,  0, '+');
		mvwaddch(window, 5, length, '+');
		mvwaddstr(window, 2, 2, temp);
		wrefresh(window);
		number = 0;
		flushinp();
		more = NO;
		while (isdigit(ch = cur_getc()) || ch == '\b') {
			if (isdigit(ch)) {
				more = YES;
				number = number * 10 + ch - '0';
				mvwaddch(window, 2, place++,ch);
				wrefresh(window);
			} else {
				number = number / 10;
				if (place > length - 7) {
					mvwaddch(window, 2, --place,' ');
					wrefresh(window);
				}
			}
		}
		if (!more)
			number = default_v;
		cur_rm_window(window);
	}
	touchwin(stdscr);
	refresh();
	return(number);
}

/*
cur_ask_y_n.c - Ask the yes/no question 'string1'. If an improper response
				reask using string2
*/

#if defined(PROTOTYPES)
int cur_ask_y_n(char *string1,char *string2) {
#else
int cur_ask_y_n(string1,string2) char *string1;char *string2; {
#endif
	int	 ch;
	int	 more;
	int	 length;
	char	 temp[200];
	WINDOW	*window;

	sprintf(temp,"%s?",string1);
	window = cur_msg_box(temp);
	flushinp();
	ch = cur_getc();
	if (isupper(ch))
		ch = tolower(ch);
	cur_rm_window(window);
	while (ch != 'y' && ch != 'n') {
		sprintf(temp,
		"Please answer 'y', 'n', or 'c' (10 sec clear).  %s?",string2);
		window = cur_msg_box(temp);
		flushinp();
		ch = cur_getc();
		if (isupper(ch))
			ch = tolower(ch);
		cur_rm_window(window);
		if (ch == 'c')
			sleep(10);
	}
	touchwin(stdscr);
	refresh();
	if (ch == 'n')
		return(0);
	return(1);
}

/*
cur_getc.c - Front end for curses function getch, when getch does not work
*/

#if defined(PROTOTYPES)
int cur_getc(void) {
#else
int cur_getc() {
#endif
	int        ch;

	flushinp();
#if defined(AIX)
	ch = getch();
	if (ch == KEY_BACKSPACE || ch == KEY_DC)
	  ch == '\b';
	/* fprintf(stderr,"%d '%c' = %d\n",0,ch,ch); */
#else
	ch = getchar();
	/* fprintf(stderr,"%d '%c' = %d\n",1,ch,ch); */
	if (ch == 27) {
		ch = getchar();
		/* fprintf(stderr,"%d '%c' = %d\n",2,ch,ch); */
		if (ch == '[') {
			ch = getchar();
			/* fprintf(stderr,"%d '%c' = %d\n",3,ch,ch); */
			if (ch == 'B')
				ch = KEY_DOWN;
			else if (ch == 'A')
				ch = KEY_UP;
			else if (ch == 'C')
				ch = KEY_LEFT;
			else if (ch == 'D')
				ch = KEY_RIGHT;
			else if (ch == '6')
				ch = KEY_NPAGE;
			else if (ch == '5')
				ch = KEY_PPAGE;
			else
				ch = 27;
		}
		else
			ch = 27;
	}
	else if (ch == 127)
		ch = '\b';
#endif
	return(ch);
}

/*
cur_menu_ask.c - ask cur_mlist 'menu'.
*/

static int		 entries;
static int		 height;
static int		 item;
static cur_mlist_t	*mitem;
static cur_mlist_t	*mbuttons = NULL;
static cur_mlist_t	*mfirst;
static int		 max;
static int		 place;
static int		 size;
static int		 top_item;
static int		 width;
WINDOW *cur_mlist_window;


#if defined(PROTOTYPES)
int cur_menu_button(int value) {
#else
int cur_menu_button(value) int value; {
#endif
	return(0);
}

#if defined(PROTOTYPES)
static void add_char(int ch) {
#else
static void add_char(ch) int ch; {
#endif
	int slen;
	char *sptr;

	mitem->edited = YES;
	if (mitem->type == CUR_MENU_BUTTON || mitem->type == CUR_MENU_DATA)
		return;
	if (mitem->s_answer != '\0') {
		if (place == 0)
			*mitem->s_answer = '\0';
		slen = strlen(mitem->s_answer) + 1;
		if (slen + 1 >= mitem->s_answer_size) {
			mitem->s_answer_size += 256;
			mitem->s_answer = (char *)realloc(mitem->s_answer,
					mitem->s_answer_size);
		}
		for (sptr = mitem->s_answer + slen;
				sptr > mitem->s_answer + place;sptr--)
			*sptr = *(sptr - 1);
		*sptr = ch;
	} else {
		mitem->s_answer = (char *)malloc(256);
		mitem->s_answer_size = 256;
		mitem->s_answer[0] = ch;
		mitem->s_answer[1] = '\0';
	}
	place++;
}

#if defined(PROTOTYPES)
static void advance_item(void) {
#else
static void advance_item() {
#endif
	if (!mitem->edited || cur_mlist_verify_item(mitem)) {
		place = 0;
		if (mitem->type != CUR_MENU_DATA)
			mitem->edited = NO;
		if (mitem->next) {
			mitem = mitem->next;
			item++;
		} else {
			mitem = mfirst;
			item = 1;
		}
	}
}

#if defined(PROTOTYPES)
static void recede_item(void) {
#else
static void recede_item() {
#endif
	if (!mitem->edited || cur_mlist_verify_item(mitem)) {
		place = 0;
		if (mitem->type != CUR_MENU_DATA)
			mitem->edited = NO;
		if (mitem->last) {
			mitem = mitem->last;
			item--;
		} else {
			mitem = mbuttons->next;
			item = max + 2;
		}
	}
}

#if defined(PROTOTYPES)
static void advance_place(void) {
#else
static void advance_place() {
#endif
	if (mitem->type == CUR_MENU_BUTTON || mitem->type == CUR_MENU_DATA)
		return;
	if (mitem != mbuttons && mitem != mbuttons->next &&
			*(mitem->s_answer + place))
		place++;
	return;
}

#if defined(PROTOTYPES)
static void recede_place(void) {
#else
static void recede_place() {
#endif
	if (mitem->type == CUR_MENU_BUTTON || mitem->type == CUR_MENU_DATA)
		return;
	if (place > 0)
		place--;
	return;
}

#if defined(PROTOTYPES)
static void draw_it(char *title,cur_mlist_t *menu) {
#else
static void draw_it(title,menu) char *title;cur_mlist_t *menu; {
#endif
	int		 cline;
	int		 loop;
	int		 loop2;
	int		 line_num;
	cur_mlist_t	*mptr;
	int		 nplace;
	int		 pch;
	char		 string[100];
	int		 swidth;

	swidth = width - 28;
	for (loop = 1;loop < width - 1;loop++)
		for (loop2 = 1;loop2 < size;loop2++)
			mvwaddch(cur_mlist_window,loop2,loop,' ');
	box(cur_mlist_window, '|', '-');
	mvwaddch(cur_mlist_window, 0,0,  '+');
	mvwaddch(cur_mlist_window, 0, width - 1, '+');
	mvwaddch(cur_mlist_window, size - 1,  0, '+');
	mvwaddch(cur_mlist_window, size - 1, width - 1, '+');
	mvwaddstr(cur_mlist_window,1,(width  - strlen(title)) / 2,title);
	for (loop = 1;loop < width - 1;loop++)
		mvwaddch(cur_mlist_window,2,loop,'-');
	mvwaddch(cur_mlist_window,2,0,'+');
	mvwaddch(cur_mlist_window,2,width - 1,'+');
	mvwaddstr(cur_mlist_window,3,3,
 "<cr> - go to next item     ' ' - press button (if on button)");
	mvwaddstr(cur_mlist_window,4,3,
 "<tb>' - get next list item  '?' - show list   '^L' to redraw");
	for (loop = 1;loop < width - 1;loop++)
		mvwaddch(cur_mlist_window,5,loop,'-');
	mvwaddch(cur_mlist_window,5,0,'+');
	mvwaddch(cur_mlist_window,5,width - 1,'+');
	for (mptr = menu,loop = 1;
			mptr != mbuttons && loop < entries && loop < item;
			mptr = mptr->next,loop++)
		;
	line_num = 6;
	top_item = loop;
	mvwaddch(cur_mlist_window,5,25,'+');
	if (mptr == mfirst->next)
		mptr = mfirst;
	if (mptr != mfirst) {
		mvwaddstr(cur_mlist_window,6,3,"More ...");
		line_num = 8;
	}
	while (mptr != mbuttons && line_num < size - 2) {
		sprintf(string,"%20s : |",mptr->name);
		mvwaddstr(cur_mlist_window,line_num,2,string);
		if (mptr == mitem) {
			cline = line_num;
			wstandout(cur_mlist_window);
		}
		nplace = place;
		if ((mptr->type == CUR_MENU_BUTTON && *mptr->s_answer)
				 || mptr->type == CUR_MENU_DATA) {
			pch = '\0';
			mvwaddstr(cur_mlist_window,line_num,27,"PRESS");
			if (mptr == mitem)
				wstandend(cur_mlist_window);
			mvwaddch(cur_mlist_window,line_num - 1,33,'+');
			mvwaddch(cur_mlist_window,line_num ,33,'|');
		}
		else {
			int sw = strlen(mptr->s_answer);
			int s_end = sw;
			int s_begin = 0;
			int off = 0;

			pch = mptr->s_answer[place];

			if (sw > swidth) {
				if (place <= swidth - 12) {
					mvwaddstr(cur_mlist_window,line_num,width - 3,
							" <");
					s_end = swidth - 2;
				} else {
					mvwaddstr(cur_mlist_window,line_num,27,"> ");
					off = 2;
					s_begin = place - (swidth - 12);
					nplace = 29 + swidth - 12;
					if (sw - s_begin < swidth - 1)
						s_end = sw;
					else {
						s_end = s_begin + swidth - 4;
						mvwaddstr(cur_mlist_window,line_num,
								width - 3," <");
					}
				}
			}
			else
				s_end = sw;
			for (loop = s_begin;loop < s_end;loop++) {
				if (mptr == mitem && loop == place)
					wstandend(cur_mlist_window);
				mvwaddch(cur_mlist_window,line_num,loop+27+ off - s_begin,
						mptr->s_answer[loop]);
				if (mptr == mitem && loop == place)
					wstandout(cur_mlist_window);
			}
		}
		if (mptr == mitem) {
			wstandend(cur_mlist_window);
			if (*mptr->s_answer && pch)
				mvwaddch(cur_mlist_window,line_num,27 + nplace,pch);
		}
		line_num++;
		mvwaddch(cur_mlist_window,line_num,25,'+');
		if ((mptr->type == CUR_MENU_BUTTON && !*mptr->s_answer) ||
				mptr->type == CUR_MENU_DATA) {
			if (!mptr->next || (mptr->next &&
					((mptr->next->type == CUR_MENU_BUTTON &&
					!*mptr->next->s_answer) ||
					 mptr->next->type == CUR_MENU_DATA)))
				for (loop = 26;loop < 33;loop++)
					mvwaddch(cur_mlist_window,line_num,loop,'-');
			else
				for (loop = 26;loop < width - 1;loop++)
					mvwaddch(cur_mlist_window,line_num,loop,'-');
				mvwaddch(cur_mlist_window,line_num,33,'+');
		}
		else
			for (loop = 26;loop < width - 1;loop++)
				mvwaddch(cur_mlist_window,line_num,loop,'-');
		line_num++;
		mptr = mptr->next;
		loop++;
	}
	if (mptr != mbuttons || line_num > size - 4)
		mvwaddstr(cur_mlist_window,size - 2,3,"More ...");
	else {
		mvwaddstr(cur_mlist_window,size - 4,width - 30,"+--------+");
		mvwaddch(cur_mlist_window,size - 3,width - 30,'|');
		mvwaddch(cur_mlist_window,size - 3,width - 21,'|');
		if (mitem == mbuttons->next) {
			wstandout(cur_mlist_window);
			cline = size - 3;
			nplace = width - 52;
		}
		mvwaddstr(cur_mlist_window,size - 3,width - 28,"CANCEL");
		if (mitem == mbuttons->next)
			wstandend(cur_mlist_window);
		mvwaddstr(cur_mlist_window,size - 2,width - 30,"+--------+");
		mvwaddstr(cur_mlist_window,size - 4,20,"+--------+");
		mvwaddch(cur_mlist_window,size - 3,20,'|');
		mvwaddch(cur_mlist_window,size - 3,29,'|');
		if (mitem == mbuttons) {
			wstandout(cur_mlist_window);
			cline = size - 3;
			nplace = -2;
		}
		mvwaddstr(cur_mlist_window,size - 3,22,"ACCEPT");
		if (mitem == mbuttons)
			wstandend(cur_mlist_window);
		mvwaddstr(cur_mlist_window,size - 2,20,"+--------+");
	}
	wmove(cur_mlist_window,cline,27 + nplace);
	wrefresh(cur_mlist_window);
}

#if defined(PROTOTYPES)
int cur_menu_ask(char*title,cur_mlist_t *menu,int cur_mverify(cur_mlist_t *)) {
#else
int cur_menu_ask(title,menu,cur_mverify)
char* title;cur_mlist_t *menu;int (*cur_mverify)(); {
#endif
	int		 ch;
	cur_mlist_t	*mpptr;
	cur_mlist_t	*mptr;
	int		 retval;

	height = 10;
	max = 1;
	width = COLS - 6;
	if (!mbuttons) {
		mbuttons = cur_menu_parse("accept:b::e:r:n");
		mbuttons = cur_mlist_add(mbuttons,
				cur_menu_parse("cancel:b::e:r:n"));
	}
	for (mpptr = NULL,mptr = menu;mptr;mpptr = mptr,mptr = mptr->next) {
		height += 2;
		max += 1;
	}
	mpptr->next = mbuttons;
	mbuttons->last = mpptr;
	mfirst = menu;
	if (height <= LINES - 1) {
		entries = 0;
		size = height;
	}
	else {
		size = LINES - 1;
		entries = max - ((size - 11) / 2);
	}
	cur_mlist_window = newwin(size, width, 1, 3);
	item = 1;
	mitem = mfirst;
	place = 0;
re_loop:
	retval = -1;
	while (retval == -1) {
		draw_it(title,menu);
		flushinp();
		ch = cur_getc();
		switch (ch) {
			case '\n':
				advance_item();
				break;
			case -1 :
				break;
			case 27 :
				retval = 0;
				break;
			case KEY_UP :
				recede_item();
				break;
			case KEY_DOWN :
				advance_item();
				break;
			case KEY_LEFT :
				if (mitem->enterable)
					advance_place();
				break;
			case KEY_RIGHT :
				if (mitem->enterable)
					recede_place();
				break;
			case 12 :
				wclear(cur_mlist_window);
				wrefresh(cur_mlist_window);
				break;
			case ' ' :
				if (!mitem->enterable)
					cur_msg_win("Item is not editable");
				else if (mitem == mbuttons)
					retval = 1;
				else if (mitem == mbuttons->next)
					retval = 0;
				else if (mitem->type == CUR_MENU_BUTTON) {
					retval = cur_menu_button(mitem->default_value.i);
					wclear(cur_mlist_window);
					mitem->edited = YES;
				}
				else if (mitem->type == CUR_MENU_DATA) {
					char	 string[30];
					char	*editor;

					sprintf(string,
		"Entering the editor to retreive answer for '%s'",
							mitem->name);
					cur_msg_win(string);
					if (editor = getenv("EDITOR"))
						sprintf(string,"%s %s",editor,
							mitem->s_answer);
					else
						sprintf(string,"/usr/bin/vi %s",
							mitem->s_answer);
					system(string);
					wclear(cur_mlist_window);
					mitem->edited = YES;
				}
				else
					add_char(ch);
				break;
			case '?':
				if (!mitem->enterable)
					cur_msg_win("Item is not editable");
				else if (mitem->type == CUR_MENU_LIST ||
						mitem->type == CUR_MENU_OLIST) {
					mitem->l_answer =
cur_slist_ask(mitem->list,mitem->i_answer,&mitem->i_answer,&mitem->s_answer,
		&mitem->s_answer_size,mitem->type == CUR_MENU_OLIST);
					wclear(cur_mlist_window);
					mitem->edited = YES;
				}
				else
					add_char(ch);
				break;
			case '\b':
				if (!mitem->enterable)
					cur_msg_win("Item is not editable");
				else if (place <= 0 ||
						mitem->type == CUR_MENU_DATA ||
						mitem->type == CUR_MENU_BUTTON)
					beep();
				else {
					char *aptr;
					mitem->edited = YES;
					for (aptr = mitem->s_answer + place - 1;
							*aptr;aptr++)
						*aptr = *(aptr + 1);
					place--;
				}
				break;
			case '\t':
				if (!mitem->enterable)
					cur_msg_win("Item is not editable");
				else if (mitem->type == CUR_MENU_LIST || mitem->type == CUR_MENU_OLIST) {
					mitem->edited = YES;
					if (!mitem->l_answer) {
						mitem->l_answer = mitem->list;
						mitem->i_answer = 1;
					}
					else if (mitem->l_answer->next) {
						mitem->l_answer =
							mitem->l_answer->next;
						mitem->i_answer++;
					}
					else {
						mitem->l_answer = mitem->list;
						mitem->i_answer = 1;
					}
					if (strlen(mitem->l_answer->string) +
						    1 < mitem->s_answer_size) {
						mitem->s_answer_size += 80;
						mitem->s_answer = realloc(
							mitem->s_answer,
							mitem->s_answer_size);
					}
					strcpy(mitem->s_answer,
						    mitem->l_answer->string);
				}
				else if (mitem == mbuttons)
					retval = 1;
				else if (mitem == mbuttons->next)
					retval = 0;
				else if (mitem->type == CUR_MENU_BUTTON) {
					mitem->edited = YES;
					retval = cur_menu_button(
							mitem->default_value.i);
					wclear(cur_mlist_window);
				}
				else if (mitem->type == CUR_MENU_DATA) {
					char string[30];
					char *editor;

					mitem->edited = YES;
					if (editor = getenv("EDITOR"))
						sprintf("%s %s",editor,
							    mitem->s_answer);
					else
						sprintf("/usr/bin/vi %s",
							    mitem->s_answer);
					system(string);
					wclear(cur_mlist_window);
				}
				else {
					cur_msg_win(
			"Tab characters not accetable input");
					wclear(cur_mlist_window);
				}
				break;
			default :
				if (!mitem->enterable)
					cur_msg_win("Item is not editable");
				else if (!isgraph(ch)) {
					cur_msg_win(
			"Non-graphical character entered - not processed");
					wclear(cur_mlist_window);
				}
				else
					add_char(ch);
		}
		wrefresh(cur_mlist_window);
	}
	if (retval && !cur_mlist_verify_all(mfirst,cur_mverify))
		goto re_loop;
	cur_rm_window(cur_mlist_window);
	mbuttons->last->next = NULL;
	mbuttons->last = NULL;
	return(retval);
}

#define CUR_MENU_DATA   5
#define CUR_MENU_BUTTON 6

/*
cur_msg_box.c - Create and display a message box containing string. Return the
				pointer to that message box.
*/

#if defined(PROTOTYPES)
WINDOW *cur_msg_box(char *string) {
#else
WINDOW *cur_msg_box(string) char *string; {
#endif
	int	length;
	WINDOW *askwin;

	length = strlen(string) + 4;
	if (length > COLS)
		length = COLS;
	askwin = newwin(5, length, 6, (COLS - length) / 2);
	wclear(askwin);
	box(askwin, '|', '-');
	waddch(askwin, '+');
	mvwaddch(askwin, 0, length - 1, '+');
	mvwaddch(askwin, 4,  0, '+');
	mvwaddch(askwin, 4, length - 1, '+');
	mvwaddstr(askwin, 2, 2, string);
	wrefresh(askwin);
	return(askwin);
}

#if defined(PROTOTYPES)
void cur_msg_win(char *string) {
#else
void cur_msg_win(string) char *string; {
#endif
	int	 ch;
	char	 temp[120];
	WINDOW	*window;

	sprintf(temp,"%s (any key to clear)",string);
	window = cur_msg_box(temp);
	flushinp();
	ch = cur_getc();
	cur_rm_window(window);
	return;
}

/*
cur_rm_window.c - Remove a window from the curses screen
*/

#if defined(PROTOTYPES)
void cur_rm_window(WINDOW *window) {
#else
void cur_rm_window(window) WINDOW *window; {
#endif
	delwin(window);
	touchwin(stdscr);
	refresh();
}


/*
cur_slist_ask.c - ask The user to choose an item in an slist 'list'.
*/

static cur_slist_t *other = NULL;

#if defined(PROTOTYPES)
cur_slist_t *cur_slist_ask(cur_slist_t *list,int current,int *chosen,
		char **value,int *len,int optional) {
#else
cur_slist_t *cur_slist_ask(list,current,chosen,value,len,optional)
cur_slist_t *list;int current;int *chosen;
		char **value;int *len;int optional; {
#endif
	int		 ch;
	int		 count;
	int		 linenum;
	cur_slist_t	*llptr;
	int		 loop;
	int		 loop2;
	cur_slist_t	*lptr;
	int		 more;
	int		 size;
	int		 sitem;
	int		 titem;
	int		 width = 14;
	WINDOW		*window;

	if (optional && !value) {
		cur_error(
"cur_slist_asked called without value with optional set\n");
		sleep(5);
		finalize();
	}
	if (!other && optional) {
		other = (cur_slist_t *)malloc(sizeof(cur_slist_t));
		other->string = malloc(10);
		strcpy(other->string,"<other>");
		other->next = NULL;
		other->last = NULL;
	}
	for (llptr = NULL,count = 0,lptr = list;
			 lptr;
			 llptr = lptr,lptr = lptr->next,count++) {
		if (strlen(lptr->string) + 4 > width)
			width = strlen(lptr->string) + 4;
	}
	if (optional) {
		llptr->next = other;
		other->last = llptr;
		count++;
	}
	size = count + 4;
	if (size > LINES - 3)
		size = LINES - 3;
	if (count > LINES - 8)
		titem = count - (LINES - 8);
	else
		titem = 1;
	window = newwin(size, width, 3, (COLS - width) / 2);
	box(window, '|', '-');
	waddch(window, '+');
	mvwaddch(window, 0, width - 1, '+');
	mvwaddch(window, size - 1,  0, '+');
	mvwaddch(window, size - 1, width - 1, '+');
	mvwaddstr(window,1,(width - 10) / 2,"Choose One");
	for (loop = 1;loop < width;loop++)
		mvwaddch(window,2,loop,'-');
	mvwaddch(window,2,0,'+');
	mvwaddch(window,2,width,'+');
	more = 1;
	if (current == 0 && optional)
		current = count;
	else if (current == 0)
		current = 1;
	for (loop = 1,lptr = list;loop < current;loop++,lptr = lptr->next)
		;
	while (more) {
		sitem = 1;
		if (count > size - 4) {
			if (current > size - 6)
				sitem = current;
				if (sitem > titem)
					sitem = titem;
		}
		for (loop = 3;loop < size -2;loop++)
			for (loop2 = 1;loop2 < width -2;loop2++)
				mvwaddch(window,loop,loop2,' ');
		for (loop = 1,llptr = list;loop < sitem;
				loop++,llptr = llptr->next)
			;
		if (sitem != 1) {
			mvwaddstr(window,4,4,"More ...");
			linenum = 5;
		}
		else
			linenum = 3;
		while (linenum < size - 3) {
			if (llptr == lptr)
				wstandout(window);
			mvwaddstr(window,linenum,4,llptr->string);
			if (llptr == lptr)
				wstandend(window);
			llptr = llptr->next;
			linenum++;
			sitem++;
		}
		if (sitem + 1 <= count) {
			if (llptr == lptr)
				wstandout(window);
			mvwaddstr(window,linenum,4,llptr->string);
			if (llptr == lptr)
				wstandend(window);
			llptr = llptr->next;
			if (llptr == lptr)
				wstandout(window);
			mvwaddstr(window,linenum + 1,4,llptr->string);
			if (llptr == lptr)
				wstandend(window);
		}
		else
			mvwaddstr(window,size - 1,4,"More ...");
		wrefresh(window);
		flushinp();
		ch = cur_getc();
		switch (ch) {
			case '\n':
				more = 0;
				break;
			case -1 :
				break;
			case KEY_DOWN :
			case 'j' :
				if (lptr->next) {
					lptr = lptr->next;
					current++;
				}
				else
					beep();
				break;
			case KEY_UP :
			case 'k' :
				if (lptr->last) {
					lptr = lptr->last;
					current--;
				}
				else
					beep();
				break;
		}
	}
	if (llptr == other) {
		if (*len < 256) {
			*len = 256;
			*value = realloc(*value,*len);
		}
		cur_str("What value do you wish to specify",*value);
		current = 0;
		lptr = NULL;
	}
	else {
		if (value) {
			if (strlen(lptr->string) + 1 > *len) {
				*len = strlen(lptr->string) + 1;
				*value = realloc(*value,*len);
			}
			strcpy(*value,lptr->string);
		}
	}
	if (optional) {
		other->last->next = NULL;
		other->last = NULL;
	}
	*chosen = current;
	return(lptr);
}

/*
cur_slist_fancy.c - Ask for a slist item in 'list'.
*/

#if defined(PROTOTYPES)
cur_slist_t *cur_slist_fancy(char *title,cur_slist_t *list,int current,
		int *chosen) {
#else
cur_slist_t *cur_slist_fancy(title,list,current,chosen)
char *title;cur_slist_t *list;int current; int *chosen; {
#endif
	int		 ch;
	cur_slist_t	*cur_list;
	int		 cur_place;
	int		 border;
	int		 edge;
	int		 items;
	int		 more;
	int		 loop;
	cur_slist_t	*lptr;
	int		 place;
	int		 size;
	int		 spaces;
	int		 start;
	int		 width;
	WINDOW		*window;

	width = strlen(title) + 4;
	cur_list = NULL;
	for (items = 0,lptr = list;lptr;items++,lptr = lptr->next) {
		if (items + 1 == current) {
			cur_place = current;
			cur_list = lptr;
		}
		if (width < strlen(lptr->string))
			width = strlen(lptr->string);
	}
	if (width + 4 < COLS) {
		width += 4;
		edge = 2;
	}
	else
		edge = 0;
	if (7 + items * 2 <= LINES) {
		size = 7 + items * 2;
		start = 4;
		border = YES;
		spaces = YES;
	}
	else if (4 + items * 2 <= LINES) {
		size = 4 + items * 2;
		start = 3;
		border = NO;
		spaces = YES;
	}
	else if (5 + items <= LINES) {
		start = 3;
		size = 5 + items;
		border = YES;
		spaces = NO;
	}
	else if (3 + items <= LINES) {
		start = 2;
		size = 3 + items;
		border = NO;
		spaces = NO;
	}
	else
		return cur_slist_ask(list,current,chosen,NULL,0,NO);

	/* create window */
	window = newwin(size, width, (LINES - size) / 2, (COLS - width) / 2);
	if (edge && border) {
		box(window, '|', '-');
		mvwaddch(window, 0,        0,   '+');
		mvwaddch(window, 0,        width - 1, '+');
		mvwaddch(window, 2,        0,   '+');
		mvwaddch(window, 2,        width - 1, '+');
		mvwaddch(window, size - 1, 0,   '+');
		mvwaddch(window, size - 1, width - 1, '+');
	}
	else if (edge) {
		for (loop = 0;loop < size;loop++) {
			mvwaddch(window,loop,0,'|');
			mvwaddch(window,loop,width - 1,'|');
		}
		mvwaddch(window, 1,        0,   '+');
		mvwaddch(window, 1,        width - 1, '+');
	}
	else if (border) {
		for (loop = 1;loop < width - 1;loop++) {
			mvwaddch(window, 0,loop,'-');
			mvwaddch(window, size,loop,'-');
		}
		mvwaddch(window, 0,        0,   '+');
		mvwaddch(window, 0,        width - 1, '+');
		mvwaddch(window, size - 1, 0,   '+');
		mvwaddch(window, size - 1, width - 1, '+');
	}

	/* add title */
	if (border)
		place = 1;
	else
		place = 0;
	mvwaddstr(window,place,(width - strlen(title)) / 2,title);
	for (loop = 1;loop < width - 1;loop++)
		mvwaddch(window, place + 1, loop,'-');
	if (!cur_list) {
		cur_place = 1;
		cur_list = list;
	}
	more = 1;
	while (more) {
		for (place = start,loop = 1,lptr = list;loop <= items;
				loop++,lptr = lptr->next) {
			if (loop == items) {
				mvwaddstr(window,place,edge,"     or");
				place++;
				if (spaces)
					place++;
			}
			if (cur_place == loop)
				wstandout(window);
			mvwaddstr(window,place,edge,lptr->string);
			if (cur_place == loop)
				wstandend(window);
			if (spaces)
				place++;
			place++;
		}
		wmove(window,0,0);
		wrefresh(window);
		flushinp();
		ch = cur_getc();
		switch (ch) {
			case '\n':
			case ' ':
				more = 0;
				break;
			case -1 :
				break;
			case KEY_DOWN :
			case 'j' :
				if (cur_list->next) {
					cur_list = cur_list->next;
					cur_place++;
				}
				else
					beep();
				break;
			case KEY_UP :
			case 'k' :
				if (cur_list->last) {
					cur_list = cur_list->last;
					cur_place--;
				}
				else
					beep();
				break;
			default:
				beep();
				break;
		}
	}
	cur_rm_window(window);
	*chosen = cur_place;
	return(cur_list);
}

/*
cur_start.c - start cur/curses
*/

int cur_started = NO;

#if defined(PROTOTYPES)
void cur_start(int argc,char *argv[]) {
#else
void cur_start(argc,argv) int argc;char *argv[]; {
#endif
	signal(SIGINT,catch_int);
	initscr();
	crmode();
	noecho();
	refresh();
	cur_started = YES;
#if defined(AIX)
	keypad(stdscr,YES);
#endif
}

/*
cur_stop.c - stop cur/curses
*/

#if defined(PROTOTYPES)
void cur_stop(void) {
#else
void cur_stop() {
#endif
	clear();
	move(23,0);
	refresh();
	nocrmode();
	echo();
	endwin();
	cur_started = NO;
}

/*
cur_str.c - Ask a question whose answer is a generic string
*/

#if defined(PROTOTYPES)
char *cur_str(char *question, char *answer) {
#else
char *cur_str(question,answer) char *question; char *answer;{
#endif
	char	*aptr;
	int	 ch;
	int	 length;
	int	 length_q;
	int	 place;
	char	 temp[200];
	WINDOW	*window;

	sprintf(temp,"%s ?",question);
	length_q = strlen(temp) + 3;
	length = length_q + 40;
	if (length > COLS)
		length = COLS;
	place = length_q;
re_do:
	window = newwin(5, length, 6, (COLS  - length) / 2);
	wclear(window);
	box(window, '|', '-');
	waddch(window, '+');
	mvwaddch(window, 0, length, '+');
	mvwaddch(window, 5,  0, '+');
	mvwaddch(window, 5, length, '+');
	mvwaddstr(window, 2, 2, temp);
	wmove(window,2,place);
	wrefresh(window);
	flushinp();
	aptr = answer;
	while ((ch = cur_getc()) !=  '\n') {
		if (ch != '\b') {
			mvwaddch(window, 2, place++,ch);
			wrefresh(window);
			*aptr = ch;
			aptr++;
		} else {
			if (place > length_q) {
				mvwaddch(window, 2, --place,' ');
				wmove(window,2,place);
				wrefresh(window);
				aptr--;
			}
		}
	}
	*aptr = '\0';
	cur_rm_window(window);
	if (!*answer) {
		cur_msg_win("You must answer this question");
		goto re_do;
	}
	touchwin(stdscr);
	refresh();
	return(answer);
}

/*
cur_strd.c - Ask a question whose answer is a string. If no answer is given,
				the answer is the default
*/

#if defined(PROTOTYPES)
char *cur_strd(char *question, char *default_value, char *answer) {
#else
char *cur_strd(question, default_value, answer) 
char *question; char *default_value; char *answer; {
#endif
	char	*aptr;
	int	 ch;
	int	 length;
	int	 length_default;
	int	 more;
	int	 number;
	int	 place;
	char	 temp[200];
	char	 temp_def[200];
	WINDOW	*window;

	strcpy(temp_def,default_value);
	sprintf(temp,"%s (%s)?",question,temp_def);
	length_default = strlen(temp) + 4;
	length = length_default + 40;
	if (length > COLS)
		length = COLS;
	place = length_default;
	window = newwin(5, length, 6, (COLS - length) / 2);
	wclear(window);
	box(window, '|', '-');
	waddch(window, '+');
	mvwaddch(window, 0, length, '+');
	mvwaddch(window, 5,  0, '+');
	mvwaddch(window, 5, length, '+');
	mvwaddstr(window, 2, 2, temp);
	wmove(window,2,place);
	wrefresh(window);
	flushinp();
	aptr = answer;
	while ((ch = cur_getc()) !=  '\n') {
		if (ch != '\b') {
			mvwaddch(window, 2, place++,ch);
			wrefresh(window);
			*aptr = ch;
			aptr++;
		} else {
			if (place > length_default) {
				mvwaddch(window, 2, --place,' ');
				wmove(window,2,place);
				wrefresh(window);
				aptr--;
			}
		}
	}
	*aptr = '\0';
	if (!*answer)
		strcpy(answer,temp_def);
	cur_rm_window(window);
	touchwin(stdscr);
	refresh();
	return(answer);
}

#if defined(PROTOTYPES)
void cur_text_dsp(char **strings) {
#else
void cur_text_dsp(strings) char **strings; {
#endif
	int   ch;
	int   place;
	int   size;
	WINDOW *window;

	size = LINES - 3;
	ch = 'x';
	window = newwin(size, 75, 1, 3);
	while (*strings && ch != 'q') {
		wclear(window);
		box(window, '|', '-');
		waddch(window, '+');
		mvwaddch(window, 0, 74, '+');
		mvwaddch(window,size - 1,  0, '+');
		mvwaddch(window,size - 1, 74, '+');
		for (place = 2;
				place < size - 3 &&
				*strings &&
				strcmp(*strings,"<END OF WINDOW>") != 0;
				place++,strings++) {
			mvwaddstr(window,place,2,*strings);
		}
		if (*strings)
			mvwaddstr(window,size - 2,2,
					"any key to continue - 'q' to quit");
		else
			mvwaddstr(window,size - 2,2,"any key to clear");
		if (*strings && strcmp(*strings,"<END OF WINDOW>") == 0)
			strings++;
		wrefresh(window);
		flushinp();
		ch = cur_getc();
	}
	cur_rm_window(window);
}
