static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "hcal.h"

#if defined(PROTOTYPES)
void add_to_day(day_data_t *day,info_t *info) {
#else
void add_to_day(day,info)
day_data_t *day;info_t *info; {
#endif
	if (day->info_last)
		day->info_last->next = info;
	else
		day->info = info;
	info->last = day->info_last;
	day->info_last = info;
	info->next = NULL;
}

#if defined(PROTOTYPES)
int break_up(int date,time_info_t *time,char *info,int bold,char *string)
#else
int break_up(date,time,info,bold,string)
char *time;char *info;int bold;char *string;
#endif
{
	int	 count;
	char	*iptr;
	char	*space;
	char	*temp;
	char	_temp[40];
	char	*tptr;
	char	*tspace;
	char	*xptr;

        temp = string ? string : _temp;
	tptr = temp;
	space = info - 1;
	tspace = NULL;
	count = 0;

	if (time && time->word1) {
		strcpy(temp,format_time(date,time,TIME_FORMAT_ABREV));
		tptr += strlen(temp);
	}
	for (iptr = info;iptr && *iptr;iptr++) {
		*tptr = *iptr;
		tptr++;
		*tptr = '\0';
		if (pstrlen(temp,bold) + 3 > BOX_WIDTH) {
			if (tspace) {
				*tspace = '\0';
				iptr = space;
			} else {
				iptr--;
				tptr--;
				*tptr = '\0';
			}
			count++;
			space = NULL;
			temp = string ? tspace + 1 : _temp;
			tspace = NULL;
			strcpy(temp,"   ");
			tptr = temp + 3;
		}
		else if (*iptr == ' ') {
			space = iptr;
			tspace = tptr - 1;
		}
	}
	*(tptr + 1) = '\0';
	count++;
	return count;
}

#if defined(PROTOTYPES)
void do_minyan_day(int this_day,time_info_t *shaharit,time_info_t *mincha,time_info_t *mariv) {
#else
void do_minyan_day(this_day,shaharit,mincha,mariv)
int this_day;time_info_t *shaharit;time_info_t *mincha;time_info_t *mariv; {
#endif
	day[this_day].shaharit.word1 = shaharit->word1;
	day[this_day].shaharit.word2 = shaharit->word2;
	day[this_day].mincha.word1 = mincha->word1;
	day[this_day].mincha.word2 = mincha->word2;
	day[this_day].mariv.word1 = mariv->word1;
	day[this_day].mariv.word2 = mariv->word2;
	day[this_day].edited &= ~(SET_PRAYER_MASK);
	day[this_day].edited |= SET_PRAYER_MANUAL;
	return;
}

#if defined(PROTOTYPES)
void do_minyan_week(int this_day,time_info_t *shaharit,time_info_t *mincha,time_info_t *mariv) {
#else
void do_minyan_week(this_day,shaharit,mincha,mariv) 
int this_day;time_info_t *shaharit;time_info_t *mincha;time_info_t *mariv;{
#endif
	int	default_level;
	int	loop;
	int	weekday;

	weekday = this_day - first_week_day + 1;
	if (weekday < 0)
		weekday += 7;
	if (this_day == 6)
		default_level = SET_PRAYER_SHABBAT;
	else
		default_level = SET_PRAYER_DEFAULT;

	for (loop = weekday ; loop <= numdays;loop += 7) {
		if ((day[loop].edited & SET_PRAYER_MASK) <= default_level) {
			day[loop].shaharit.word1 = shaharit->word1;
			day[loop].shaharit.word2 = shaharit->word2;
			day[loop].mincha.word1 = mincha->word1;
			day[loop].mincha.word2 = mincha->word2;
			day[loop].mariv.word1 = mariv->word1;
			day[loop].mariv.word2 = mariv->word2;
		}
	}

	minyan[this_day][SHAHARIT].word1 = shaharit->word1;
	minyan[this_day][SHAHARIT].word2 = shaharit->word2;
	minyan[this_day][MINCHA].word1 = mincha->word1;
	minyan[this_day][MINCHA].word2 = mincha->word2;
	minyan[this_day][MARIV].word1 = mariv->word1;
	minyan[this_day][MARIV].word2 = mariv->word2;
	return;
}

#if defined(PROTOTYPES)
void do_minyan_chag(time_info_t *shaharit,time_info_t *mincha,time_info_t *mariv) {
#else
void do_minyan_chag(shaharit,mincha,mariv)
time_info_t *shaharit;time_info_t *mincha;time_info_t *mariv; {
#endif
	int 	loop;

	for (loop = 1 ; loop <= numdays;loop ++) {
		if (!day[loop].holiday)
			continue;
		if ((day[loop].edited & SET_PRAYER_MASK) <= SET_PRAYER_CHAG) {
			day[loop].edited &= ~(SET_PRAYER_MASK);
			day[loop].edited |= SET_PRAYER_CHAG;
			day[loop].shaharit.word1 = shaharit->word1;
			day[loop].shaharit.word2 = shaharit->word2;
			day[loop].mincha.word1 = mincha->word1;
			day[loop].mincha.word2 = mincha->word2;
			day[loop].mariv.word1 = mariv->word1;
			day[loop].mariv.word2 = mariv->word2;
		}
	}

	minyan[CHAG][SHAHARIT].word1 = shaharit->word1;
	minyan[CHAG][SHAHARIT].word2 = shaharit->word2;
	minyan[CHAG][MINCHA].word1 = mincha->word1;
	minyan[CHAG][MINCHA].word2 = mincha->word2;
	minyan[CHAG][MARIV].word1 = mariv->word1;
	minyan[CHAG][MARIV].word2 = mariv->word2;
	return;
}

#if defined(PROTOTYPES)
void do_minyan_rosh(time_info_t *shaharit,time_info_t *mincha,time_info_t *mariv) {
#else
void do_minyan_rosh(shaharit,mincha,mariv)
time_info_t *shaharit;time_info_t *mincha;time_info_t *mariv; {
#endif
	int 	loop;

	for (loop = 1 ; loop <= numdays;loop ++) {
		if (day[loop].jday != 1 && day[loop].jday != 30)
			continue;
		if ((day[loop].edited & SET_PRAYER_MASK) <= SET_PRAYER_ROSH) {
			day[loop].edited &= ~(SET_PRAYER_MASK);
			day[loop].edited |= SET_PRAYER_ROSH;
			day[loop].shaharit.word1 = shaharit->word1;
			day[loop].shaharit.word2 = shaharit->word2;
			day[loop].mincha.word1 = mincha->word1;
			day[loop].mincha.word2 = mincha->word2;
			day[loop].mariv.word1 = mariv->word1;
			day[loop].mariv.word2 = mariv->word2;
		}
	}

	minyan[ROSH][SHAHARIT].word1 = shaharit->word1;
	minyan[ROSH][SHAHARIT].word2 = shaharit->word2;
	minyan[ROSH][MINCHA].word1 = mincha->word1;
	minyan[ROSH][MINCHA].word2 = mincha->word2;
	minyan[ROSH][MARIV].word1 = mariv->word1;
	minyan[ROSH][MARIV].word2 = mariv->word2;
	return;
}

#if defined(PROTOTYPES)
city_t *findadd_city(char *name,int *place) {
#else
city_t *findadd_city(name,place) char *name;int *place; {
#endif
	city_t		*cptr;
	int		 found;
	int		 lplace;
	cur_slist_t	*sptr;

	for (cptr = cities,lplace = 1,found = NO,sptr = city_slist;
			cptr && !(found = (casecmp(cptr->name,name) == 0)) &&
				cptr->next;
			cptr = cptr->next,sptr = sptr->next,lplace++)
		;

	if (!found) {
		if (!cptr) {
			cptr = (city_t *)new(sizeof(city_t));
			cptr->last = NULL;
			cities = cptr;
			city_number = 1;
		} else {
			cptr->next = (city_t *)new(sizeof(city_t));
			cptr->next->last = cptr;
			cptr = cptr->next;
			lplace++;
		}
		cptr->name = mk_string(name);
		cptr->next = NULL;
		cptr->slist_ptr = (cur_slist_t *)new(sizeof(cur_slist_t));
		cptr->slist_ptr->string = cptr->name;
		cptr->slist_ptr->next = NULL;
		cptr->slist_ptr->last = sptr;
		if (sptr)
			sptr->next = cptr->slist_ptr;
		else
			city_slist = cptr->slist_ptr;
	}

	if (place)
		*place = lplace;
	return(cptr);
}

#if defined(PROTOTYPES)
void free_month(void) {
#else
void free_month() {
#endif
	info_t	*dpast;
	info_t	*dptr;
	int	 loop;

	for (loop = 1;loop <= 32;loop++) {
		if (day[loop].jmonth)
			free(day[loop].jmonth);
		day[loop].jmonth = NULL;
		day[loop].jday = 0;
		day[loop].jyear = 0;
		day[loop].shaharit.word1 = 0;
		day[loop].shaharit.word2 = 0;
		day[loop].mincha.word1 = 0;
		day[loop].mincha.word2 = 0;
		day[loop].mariv.word1 = 0;
		day[loop].mariv.word2 = 0;
		day[loop].holiday = NO;
		day[loop].candles.word1 = 0;
		day[loop].candles.word2 = 0;
		if (day[loop].mitzvah) {
			if (day[loop].mitzvah->who)
				free(day[loop].mitzvah->who);
			if (day[loop].mitzvah->schedule)
				free(day[loop].mitzvah->schedule);
			free(day[loop].mitzvah);
		}
		day[loop].mitzvah = NULL;
		if (day[loop].shabbat) {
			if (day[loop].shabbat->name)
				free(day[loop].shabbat->name);
			if (day[loop].shabbat->schedule)
				free(day[loop].shabbat->schedule);
			if (day[loop].shabbat->torah)
				free(day[loop].shabbat->torah);
			if (day[loop].shabbat->prophet)
				free(day[loop].shabbat->prophet);
			free(day[loop].shabbat);
		}
		day[loop].shabbat = NULL;
		day[loop].chanukah = 0;
		day[loop].omer = 0;
		for (dpast = NULL,dptr = day[loop].info;
				dptr;
				dpast = dptr,dptr = dptr->next) {
			if (dptr->calendar)
				free(dptr->calendar);
			if (dptr->schedule)
				free(dptr->schedule);
			if (dpast)
				free(dpast);
		}
		if (dpast)
			free(dpast);
		day[loop].info = NULL;
		day[loop].info_last = NULL;
		day[loop].edited = NO;
		day[loop].autogenerated = 0;
	}
}

#if defined(PROTOTYPES)
int is_dst(int day,int year) {
#else
int is_dst(day,year) int day;int year; {
#endif
	int	dst;
	int	ewday;
	int	swday;
	int	mday;
	int	month;

	month_day(day,year,&mday,&month);
	swday = day_of_week(month,1,year);
	ewday = day_of_week(month,month_length[month],year);
	if (city->dst_start_month < 0)
		return NO;
	if (month == city->dst_start_month) {
		if (city->dst_start_day > 0) {
			if (swday == 0) swday = 7;
			dst = 8 - swday + ((city->dst_start_day - 1)) * 7;
			if (mday < dst)
				return NO;
			return YES;
		} else {
			dst = month_length[month] - ewday +
					((city->dst_start_day + 1) * 7);
			if (mday < dst)
				return NO;
			return YES;
		}
	} else if (month == city->dst_end_month) {
		if (city->dst_end_day > 0) {
			if (swday == 0) swday = 7;
			dst = 8 - swday + ((city->dst_end_day - 1)) * 7;
			if (mday < dst)
				return YES;
			return NO;
		} else {
			dst = month_length[month] - ewday +
					((city->dst_end_day + 1) * 7);
			if (mday < dst)
				return YES;
			return NO;
		}
	} else if (city->dst_start_month < city->dst_end_month) { /*north hemi*/
		if (month > city->dst_start_month &&
				month < city->dst_end_month)
			return YES;
		else
			return NO;
	} else { /* southern hemi */
		if (month > city->dst_end_month &&
				month < city->dst_start_month)
			return NO;
		else
			return YES;
	}
}

#if defined(PROTOTYPES)
void set_month(int month,int year) {
#else
void set_month(month,year) int month;int year; {
#endif
	int		 loop;

	first_week_day = day_of_week(month,1,year);

	if (month == 1) {
		if (year % 4 == 0 && year != 2000)
			numdays = 29;
		else
			numdays = 28;
	}
	else if (month == 8 || month == 3 || month == 5 || month == 10)
		numdays = 30;
	else
		numdays = 31;

	/* get calendar entry for each day */

	for (loop = 1;loop <= numdays;loop++)
		do_date(month,loop,year,&day[loop]);

	/* get calendar information for first day of the next month */
	if (month == 11)
		do_date(0,1,year + 1,&day[numdays + 1]);
	else
		do_date(month + 1,1,year,&day[numdays + 1]);

	/* move candle information back one day (so it is sunset previous day */
	for (loop = 1;loop <= numdays + 1;loop++) {
		day[loop].candles.word1 = day[loop + 1].candles.word1;
		day[loop].chanukah = day[loop + 1].chanukah;
	if (flag_C)
		read_calendar();
	}
}

#if defined(PROTOTYPES)
void read_calendar(void) {
#else
void read_calendar() {
#endif
	int flag_t = flag_q;
	FILE *file;
	char filename[256];
	char *home;

	flag_q = YES;
	if (home = getenv("HOME")) {
		strcpy(filename,home);
	} else {
		strcpy(filename,".");
	}
	strcat(filename,"/.calendar");
	read_file(filename,YES);
	flag_q = flag_t;
}
