static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "hcal.h"
/* #define PTOKENS */
/* #define PSTATE */
/* #define PBUFFER */

#if defined(PROTOTYPES)
int get_token(char *string) {
#else
int get_token(string) char *string; {
#endif
	int	ch;
	int	more;
	char   *sptr;
	int	state;
	int	token;

	if (parse_first) {
		read_end = read_buffer;
		read_place = read_buffer;
		read_token_start = read_place;
		parse_first = NO;
		while (1) {
			ch = next_char();
			if (ch == ' ' || ch == '\t') {
				replace_char();
				return TOKEN_EOLN;
			}
			else if (ch == EOF) {
				replace_char();
				return TOKEN_EOF;
			}
			else if (ch != '\n') {
				replace_char();
				return TOKEN_EOCM;
			}
		}
	}
	read_token_start = read_place;
	state = 0;
	sptr = string;
	*sptr = '\0';
	for (ch = next_char(),more= YES;more;more && (ch=next_char())) {
		switch (state) {
			case 0:
				if (ch == EOF) {
					replace_char();
					token = TOKEN_EOF;
					more = NO;
				} else if (ch == '\n') {
					if (isspace(ch = next_char()))
						token = TOKEN_EOLN;
					else
						token = TOKEN_EOCM;
					replace_char();
					strcpy(string,"\n");
					more = NO;
				} else if (ch == '{') {
					state = 2;
					parse_string_level = YES;
				} else if (!isspace(ch)) {
					*sptr = ch;
					sptr++;
					state = 1;
				}
				break;
			case 1:
				if (ch == EOF || isspace(ch)) {
					token = TOKEN_STRING;
					more = NO;
					replace_char();
					*sptr = '\0';
				} else {
					*sptr = ch;
					sptr++;
				}
				break;
			case 2:
				if (ch == EOF || ch == '\n') {
					parse_error(
					    "String not properly terminated");
					token = TOKEN_STRING;
					more = NO;
					parse_string_level = NO;
					replace_char();
					*sptr = '\0';
				} else if (ch == '\\') {
					state = 3;
				} else if (ch == '}') {
					token = TOKEN_STRING;
					more = NO;
					parse_string_level = NO;
					*sptr = '\0';
				} else {
					*sptr = ch;
					sptr++;
				}
				break;
			case 3:
				if (ch == EOF ) {
					parse_error(
					    "String not properly terminated");
					token = TOKEN_STRING;
					more = NO;
					parse_string_level = NO;
					replace_char();
					*sptr = '\0';
				} else if (ch == '\n') {
					*sptr = ' ';
					sptr++;
					state = 2;
				} else {
					*sptr = ch;
					sptr++;
					state = 2;
				}
				break;
	 	}
	}
	return token;
}

#if defined(PROTOTYPES)
int next_char(void) {
#else
int next_char() {
#endif
	int	ch;
	int	loop;

	if (read_place == read_end) {
		ch = getc(file_current->file);
		if (ch == '#' && !parse_string_level) {
			while (ch = getc(file_current->file),
					ch != EOF && ch != '\n')
				;
		}
		if (ch == '\n')
			file_current->line++;
		*read_place = ch;
		if (ch == EOF) {
			fclose(file_current->file);
			file_current = file_current->last;
			if (file_current) {
				ch = '\n';
				*read_place = ch;
				read_place++;
				if (read_place >= read_buffer + MAX_STR)
					read_place = read_buffer;
				read_end = read_place;
			} else
				read_end = read_place + 1;
		} else {
			read_place++;
			if (read_place >= read_buffer + MAX_STR)
				read_place = read_buffer;
			read_end = read_place;
		}
	} else {
		ch = *read_place;
		if (ch != EOF) {
			read_place++;
			if (read_place >= read_buffer + MAX_STR)
				read_place = read_buffer;
		}
	}
	return ch;
}

#if defined(PROTOTYPES)
int parse_action(ptable_t *table,char *token) {
#else
int parse_action(table,token) ptable_t *table;char *token; {
#endif
	info_t	*iptr;
	int 	next;
	info_t	*niptr;
	char	*sptr;
	FILE	*file;

	next = table->next;

	switch (table->action) {
		case  0:  /* Do Nothing */
			break;
		case  1:  /* Month Command Encountered */
			if (parse_have_month) {
				next = table->enext;
				if (parse_error(
					   "Month command already encountered or default already set by encountered date"))
					next = -2;
			}
			break;
		case  2:  /* No first Command Encountered */
			if (!flag_q && parse_error("Skipping to first command"))
				next = -2;
			break;
		case  3:  /* Unknown Command Encountered */
			if (parse_error("Unknown command ignored"))
				next = -2;
			break;
		case  4:  /* Store token as int 1 */
			parse_int_1 = atoi(token);
			break;
		case  5:  /* Store token as int 2 */
			parse_int_2 = atoi(token);
			break;
		case  6:  /* Store token as int 3 */
			parse_int_3 = atoi(token);
			break;
		case  7:  /* Store/Append token as string 1 */
			if (*parse_string_1) {
				strcat(parse_string_1," ");
				strcat(parse_string_1,token);
			}
			else
				strcpy(parse_string_1,token);
			break;
		case  8:  /* Store/Append token as string 2 */
			if (*parse_string_2) {
				strcat(parse_string_2," ");
				strcat(parse_string_2,token);
			}
			else
				strcpy(parse_string_2,token);
			break;
		case  9:  /* Store/Append token as string 3 */
			if (*parse_string_3) {
				strcat(parse_string_3," ");
				strcat(parse_string_3,token);
			}
			else
				strcpy(parse_string_3,token);
			break;
		case 10:  /* Store/Append token as string 4 */
			if (*parse_string_4) {
				strcat(parse_string_4," ");
				strcat(parse_string_4,token);
			}
			else
				strcpy(parse_string_4,token);
			break;
		case 11:  /* Store table->param as int 1 */
			parse_int_1 = table->param;
			break;
		case 12:  /* Store table->param as int 2 */
			parse_int_2 = table->param;
			break;
		case 13:  /* Store table->param as int 3 */
			parse_int_3 = table->param;
			break;
		case 14:  /* Garbage encounter at end of command */
			if (!flag_q && parse_error(
				   "Garbage at the end of the command ignored"))
				next = -2;
			break;
		case 15:  /* Get current_month from Month command*/
			parse_int_1 = is_month(token);
			parse_int_2 = current_year;
			break;
		case 16:  /* Get current_year from Month command */
			parse_int_2 = atoi(token);
			if (parse_int_2 < 1760 || parse_int_2 > 3000) {
				next = table->enext;
				if (parse_error(
					  "Year must be between 1760 and 3000"))
					next = -2;
			}
			/* fall through */
		case 17:  /* Process Month command */
			current_month = parse_int_1;
			current_year = parse_int_2;
			free_month();
			set_month(current_month,current_year);
			parse_have_month = YES;
			break;
		case 18:  /* Process City command */
			if (*parse_string_1) {
				city =findadd_city(parse_string_1,&city_number);
			} else {
				if (parse_error(
					   "No city name on City command line"))
					next = -2;
			}
			break;
		case 19: /* process latitute */
			if (token[0] == ' ')
				token[0] = '0';
			parse_int_1 = ((token[0] - '0') * 10)
					+ token[1] - '0';
			parse_int_2 = ((token[3] - '0') * 10)
					+ token[4] - '0';
			parse_int_3 = ((token[6] - '0') * 10)
					+ token[7] - '0';
			if (token[9] == 'S') {
				parse_int_1 = -parse_int_1;
				parse_int_2 = -parse_int_2;
				parse_int_3 = -parse_int_3;
			}
			if (!flag_q && 
					(city->latdeg && city->latdeg !=
					parse_int_1) ||
					(city->latmin &&
					city->latmin != parse_int_2) ||
					(city->latsec &&
					city->latsec != parse_int_3)) {
				sprintf(parse_string_2,
		 "%s latitute different that from internal data",city->name);
					parse_error(parse_string_2);
				parse_string_2[0] = '\0';
			}
			city->latdeg = parse_int_1;
			city->latmin = parse_int_2;
			city->latsec = parse_int_3;
			break;
		case 20: /* process longitute */
			if (token[0] == ' ')
				token[0] = '0';
			if (token[1] == ' ')
				token[1] = '0';
			parse_int_1 = ((token[0] - '0') * 100)
					+((token[1] - '0')*10)
					+ token[2] - '0';
			parse_int_2 = ((token[4] - '0') * 10)
					+ token[5] - '0';
			parse_int_3 = ((token[7] - '0') * 10)
					+ token[8] - '0';
			if (token[10] == 'E') {
				parse_int_1 = -parse_int_1;
				parse_int_2 = -parse_int_2;
				parse_int_3 = -parse_int_3;
			}
			if (!flag_q && 
					(city->longdeg &&
					city->longdeg != parse_int_1) ||
					(city->longmin &&
					city->longmin != parse_int_2) ||
					(city->longsec &&
					city->longsec != parse_int_3)) {
				sprintf(parse_string_2,
	 "%s longitute different that from internal data",city->name);
				parse_error(parse_string_2);
				parse_string_2[0] = '\0';
			}
			city->longdeg = parse_int_1;
			city->longmin = parse_int_2;
			city->longsec = parse_int_3;
			break;
		case 21: /* process timezone */
			parse_int_1 = atoi(token);
			if (parse_int_1 < -12 || parse_int_1 > 12) {
				if (parse_error(
					 "Timezone must be between -12 and 12"))
					next = -2;
				parse_string_2[0] = '\0';
			} else {
				if (!flag_q && city->tzone && 
						city->tzone != parse_int_1) {
					sprintf(parse_string_2,
	 "%s tzone different that from internal data",city->name);
					parse_error(parse_string_2);
					parse_string_2[0] = '\0';
				}
				city->tzone = parse_int_1;
			}
			break;
		case 22: /* int 2 = - int 2 */
			parse_int_2 = - parse_int_2;
			break;
		case 23: /* process dst */
			parse_int_3 = is_month(token);
			if (parse_int_1 == 1) {
				if (!flag_q && (city->dst_start_day &&
					city->dst_start_day != parse_int_2)
					|| (city->dst_start_month &&
					city->dst_start_month != parse_int_3)) {
					sprintf(parse_string_2,
	"%s dst start date different from internal data",city->name);
					parse_error(parse_string_2);
					parse_string_2[0] = '\0';
				}
				city->dst_start_day = parse_int_2;
				city->dst_start_month = parse_int_3;
			} else {
				if (!flag_q && (city->dst_end_day &&
					city->dst_end_day != parse_int_2) ||
					(city->dst_end_month &&
					city->dst_end_month != parse_int_3)) {
					sprintf(parse_string_2,
		 "%s dst end date different from internal data",city->name);
					parse_error(parse_string_2);
					parse_string_2[0] = '\0';
				}
				city->dst_end_day = parse_int_2;
				city->dst_end_month = parse_int_3;
			}
			break;
		case 24: /* verify month */
			if (!parse_have_month) {
				parse_int_1 = -1;
				parse_have_month = YES;
				sprintf(parse_string_2,
					"No month currently set - set to %s",
					month[current_month]);
				if (!flag_q && parse_error(parse_string_2))
					next = -2;
				parse_string_2[0] = '\0';
			}
			if (is_month(token) != current_month) {
				parse_int_1 = -1;
				next = table->enext;
				if (!flag_q && parse_error("Data out of month ignored"))
					next = -2;
			}
			break;
		case 25: /* verify day in month */
			parse_int_1 = atoi(token);
			if (parse_int_1 < 1 || parse_int_1 > numdays) {
				parse_int_1 = -1;
				if (parse_error("Day not in month specified"))
					next = -2;
			}
			break;
		case 26: /* Replace token and then do action 27 */
			replace_token();
			/* fall thorugh */
		case 27: /* process minyan information */
			if (parse_int_1 > 0)
				do_minyan_day(parse_int_1,&parse_time_2,
						&parse_time_3,&parse_time_1);
			else if (parse_int_1 != -1) {
				if (parse_int_2 == ROSH)
					do_minyan_rosh(&parse_time_2,
						&parse_time_3,&parse_time_1);
				else if (parse_int_2 == CHAG)
					do_minyan_chag(&parse_time_2,
						&parse_time_3,&parse_time_1);
				else
					do_minyan_week(parse_int_2,
						&parse_time_2,
						&parse_time_3,&parse_time_1);
			}
			parse_time_1.word1 = 0;
			parse_time_1.word2 = 0;
			parse_time_2.word1 = 0;
			parse_time_2.word2 = 0;
			parse_time_3.word1 = 0;
			parse_time_3.word2 = 0;
			break;
		case 28: /* Holiday */
			if (!day[parse_int_1].holiday && !flag_q)
				parse_error("Day not normally holiday");
			day[parse_int_1].holiday = YES;
			break;
		case 29: /* Havdalah */
			if (!day[parse_int_1].candles.word1 != 
					TIME_CANDLES_HAVDALAH)
				parse_error("Day not normally havdalah");
			day[parse_int_1].candles.word1 = TIME_CANDLES_HAVDALAH;
			break;
		case 30: /* process Jewish day */
			parse_int_2 = atoi(token);
			if (parse_int_2 < 1 || parse_int_2 > 30) {
				next = table->enext;
				if (parse_error("Jewish date out of range"))
					next = -2;
			}
			break;
		case 31: /* process Jewish year */
			parse_int_3 = atoi(token);
			/* fall thorugh */
		case 32: /* process Is command */
			if ((strcmp(day[parse_int_1].jmonth,parse_string_1)!= 0)
				    || (parse_int_2 &&
				    day[parse_int_1].jday != parse_int_2)
				    || (parse_int_3 && day[parse_int_1].jyear
				    != parse_int_3)) {
				free(day[parse_int_1].jmonth);
				day[parse_int_1].jmonth =
						mk_string(parse_string_1);
				if (parse_int_2)
					day[parse_int_1].jday = parse_int_2;
				if (parse_int_3)
					day[parse_int_1].jyear = parse_int_3;
				if (is_jmonth(parse_string_1) == -1)
					parse_error(
	"Jewish month given not recognized");
				parse_error(
	"Jewish date given different from one calculated");
			}
			break;
		case 33: /* process Candles command */
			if (day[parse_int_1].candles.word1 != table->param) {
				day[parse_int_1].candles.word1 = table->param;
				parse_error(
	"Candle time different than calculated time");
			}
			break;
		case 34: /* process Omer command */
			parse_int_2 = atoi(token);
			if (day[parse_int_1].omer != parse_int_2) {
				if (parse_int_2 < 1 || parse_int_2 > 49)
					parse_error(
	"Omer count not in proper range");
				else {
					day[parse_int_1].omer = atoi(token);
					parse_error(
	"Omer count different than calculated count");
				}
			}
			break;
		case 35: /* process Chanukah command */
			parse_int_2 = atoi(token);
			if (day[parse_int_1].chanukah != parse_int_2) {
				if (parse_int_2 < 1 || parse_int_2 > 8)
					parse_error(
	"Chanukah day not in proper range");
				else {
					day[parse_int_1].chanukah = atoi(token);
					parse_error(
	"Chanukah day different than calculated day");
						}
			}
			break;
		case 36: /* merge strings, 5 string form of Shabbat */
			strcat(parse_string_2," ");
			strcat(parse_string_2,parse_string_3);
			strcpy(parse_string_3,token);
			break;
		case 37: /* process Shabbat */
			if (!day[parse_int_1].shabbat) {
				day[parse_int_1].shabbat =
					(shabbat_t *)new(sizeof(shabbat_t));
				day[parse_int_1].shabbat->autogenerated = NO;
				if (parse_error(
				"Day not calculated as a Shabbat"))
					next = -2;
			}
			if (!day[parse_int_1].shabbat->name ||
					!day[parse_int_1].shabbat->torah ||
					!day[parse_int_1].shabbat->prophet ||
	strcmp(day[parse_int_1].shabbat->name,parse_string_1) != 0 ||
	strcmp(day[parse_int_1].shabbat->torah,parse_string_2) != 0 ||
	strcmp(day[parse_int_1].shabbat->prophet,parse_string_3) != 0) {
				parse_error(
	"Shabbat information different than calculated");
				if (day[parse_int_1].shabbat->name)
				       free(day[parse_int_1].shabbat->name);
				if (day[parse_int_1].shabbat->torah)
					free(day[parse_int_1].shabbat->torah);
				if (day[parse_int_1].shabbat->prophet)
					free(day[parse_int_1].shabbat->prophet);
				day[parse_int_1].shabbat->name =
						mk_string(parse_string_1);
				day[parse_int_1].shabbat->torah =
						mk_string(parse_string_2);
				day[parse_int_1].shabbat->prophet =
						mk_string(parse_string_3);
			}
			break;
		case 38: /* garbage at end of Shabbat line */
			if (parse_error(
	"Shabbat ignored - garbage at end of line"))
				next = -2;
			break;
		case 39: /* process Shabbat 2 */
			if (day[parse_int_1].shabbat->schedule)
				free(day[parse_int_1].shabbat->schedule);
			day[parse_int_1].shabbat->schedule =
					mk_string(parse_string_4);
			break;
		case 40: /* First word of mitzvah type 2 */
			if (*parse_string_2) {
				strcat(parse_string_2," ");
				strcat(parse_string_2,token);
			}
			else
				strcpy(parse_string_2,token);
			parse_int_2 = table->param;
			break;
		case 41: /* Process Bar Mitzvah */
			if (day[parse_int_1].mitzvah) {
				if (parse_error(
	"Bar Mitzvah already scheduled on that day"))
					next = -2;
			} else {
				if (!day[parse_int_1].shabbat)
					parse_error(
	"Day not recognized as a Sabbath");
				day[parse_int_1].mitzvah =
					(mitzvah_t *)new(sizeof(mitzvah_t));
				day[parse_int_1].mitzvah->place = parse_int_2;
				day[parse_int_1].mitzvah->type = parse_int_3;
				day[parse_int_1].mitzvah->who =
						mk_string(parse_string_2);
				day[parse_int_1].mitzvah->schedule =
						mk_string(parse_string_3);
			}
			break;
		case 42: /* Process Item */
			if (flag_C) {
				int len = strlen(parse_string_1);
				if (len > 6 && strcmp(parse_string_1 + len - 6,
					"(hcal)") == 0)
					break;
			}
			if (sptr = items_fit(&parse_time_1,parse_string_1,
					parse_int_2,parse_int_1)) {
				if (parse_error(sptr))
					next = -2;
			} else {
				for (iptr = day[parse_int_1].info;iptr &&
						strcmp(iptr->calendar,
						parse_string_1) != 0 &&
						iptr->next;
						iptr=iptr->next)
					;
				if (!iptr || strcmp(iptr->calendar,
						parse_string_1) != 0) {
					niptr = (info_t *)new(sizeof(info_t));
					niptr->calendar =
						mk_string(parse_string_1);
					niptr->next = NULL;
					niptr->last = iptr;
					if (iptr)
						iptr->next = niptr;
					else
						day[parse_int_1].info = niptr;
				} else {
					niptr = iptr;
				}
				niptr->schedule = mk_string(parse_string_2);
				niptr->time.word1 = parse_time_1.word1;
				niptr->time.word2 = parse_time_1.word2;
				niptr->bold = parse_int_2;
			}
			break;
		case 43: /* move time_1 to time_2 */
			parse_time_2.word1 = parse_time_1.word1;
			parse_time_2.word2 = parse_time_1.word2;
			parse_time_1.word1 = 0;
			parse_time_1.word2 = 0;
			break;
		case 44: /* move time_1 to time_3 */
			parse_time_3.word1 = parse_time_1.word1;
			parse_time_3.word2 = parse_time_1.word2;
			parse_time_1.word1 = 0;
			parse_time_1.word2 = 0;
			break;
		case 45: /* Open file in parse_string_1 for inclusion */
			if (file = fopen(parse_string_1,"r")) {
				if (!file_current) {
					file_current = file_bottom;
					read_end = read_place;
				} else if (!file_current->next) {
					file_current->next = (file_info_t *)
						new(sizeof(file_info_t));
					file_current->next->last = file_current;
					file_current->next->next = NULL;
					file_current = file_current->next;
				} else {
					file_current = file_current->next;
				}
				file_current->file = file;
				file_current->name = mk_string(parse_string_1);
				file_current->line = 1;
			} else {
				sprintf(parse_string_2,
				"Can not open file '%s' for inclusion",
						parse_string_1);
				parse_error(parse_string_2);
				parse_string_2[0] = '\0';
			}
			break;
		default :
			next = 1;
			sprintf(parse_string_1,
	"Unknown parsing action %d",table->action);
			if (parse_error(parse_string_1))
				next = -2;
			parse_string_1[0] = '\0';
			break;
			}
	return next;
}

#if defined(PROTOTYPES)
int parse_error(char *string) {
#else
int parse_error(string) char *string; {
#endif
	int  retval;
	char string2[MAX_STR];

	retval = NO;
	sprintf(string2,"file %s line %d : %s",
			file_current->name,file_current->line,string);
	parse_error_table[parse_errors] = mk_string(string2);
	if (++parse_errors >= MAX_STR - 2) {
		sprintf(string2,"file %s line %d : Too many errors - parsing stopped",
				file_current->name,file_current->line);
		retval = YES;
		parse_error_table[parse_errors] = mk_string(string2);
		parse_errors++;
	}
	parse_error_table[parse_errors] = NULL;
	return retval;
}

#if defined(PROTOTYPES)
void parse_init(void) {
#else
void parse_init() {
#endif
	parse_errors = 0;
	parse_first = YES;
	read_buffer[0] = 0;
	parse_have_month = NO;
}

ptable_t parse_table[] = {
/* state token		match		action	next	enext	param	*/
/*   0 initial state - expect command */
{  0,	TOKEN_MATCH,	"Month",	1,	3,	1,	0	},
{  0,	TOKEN_MATCH,	"Jdate",	0,	1,	0,	0	},
{  0,	TOKEN_MATCH,	"City",		0,	5,	0,	0	},
{  0,	TOKEN_MATCH,	"Lat",		0,	6,	0,	0	},
{  0,	TOKEN_MATCH,	"Latitude",	0,	6,	0,	0	},
{  0,	TOKEN_MATCH,	"Long",		0,	8,	0,	0	},
{  0,	TOKEN_MATCH,	"Longitude",	0,	8,	0,	0	},
{  0,	TOKEN_MATCH,	"Timezone",	0,	10,	0,	0	},
{  0,	TOKEN_MATCH,	"Tz",		0,	10,	0,	0	},
{  0,	TOKEN_MATCH,	"Daylight",	0,	11,	0,	0	},
{  0,	TOKEN_MATCH,	"DST",		0,	13,	0,	0	},
{  0,	TOKEN_MATCH,	"Minyan",	0,	21,	0,	0	},
{  0,	TOKEN_MATCH,	"Minyin",	0,	21,	0,	0	},
{  0,	TOKEN_MATCH,	"Include",	0,	51,	0,	0	},
{  0,	TOKEN_MONTH,	NULL,		24,	27,	1,	0	},
{  0,	TOKEN_INT,	NULL,		25,	28,	1,	0	},
{  0,	TOKEN_EOLN,	NULL,		2,	1,	0,	0	},
{  0,	TOKEN_EOCM,	NULL,		0,	0,	0,	0	},
{  0,	TOKEN_EOF,	NULL,		0,	-1,	0,	0	},
{  0,	TOKEN_STRING,	NULL,		3,	1,	0,	0	},
	/* 1 loop to end of command */
{  1,	TOKEN_EOCM,	NULL,		0,	0,	0,	0	},
{  1,	TOKEN_EOF,	NULL,		0,	-1,	0,	0	},
{  1,	TOKEN_STRING,	NULL,		0,	1,	0,	0	},
/*   2 <command> . EOCM */
{  2,	TOKEN_STRING,	NULL,		14,	1,	0,	0	},
{  2,	TOKEN_EOCM,	NULL,		0,	0,	0,	0	},
{  2,	TOKEN_EOF,	NULL,		0,	-1,	0,	0	},
/*   3 MONTH . <month> */
{  3,	TOKEN_MONTH,	NULL,		15,	4,	0,	0	},
/*   4 MONTH <month> . <year> */
{  4,	TOKEN_INT,	NULL,		16,	2,	1,	0	},
{  4,	TOKEN_EOCM,	NULL,		17,	0,	0,	0	},
{  4,	TOKEN_EOF,	NULL,		0,	-1,	0,	0	},
/*   5 City . <name> */
{  5,	TOKEN_STRING,	NULL,		7,	5,	0,	0	},
{  5,	TOKEN_EOCM,	NULL,		18,	0,	0,	0	},
{  5,	TOKEN_EOF,	NULL,		0,	-1,	0,	0	},
/*   6 Latitute . <lat> */
{  6,	TOKEN_LATITUDE,	NULL,		19,	2,	0,	0	},
/*   8 Longitute . <long> */
{  8,	TOKEN_LONGITUDE,NULL,		20,	2,	0,	0	},
/*  10 Timezone . <int> */
{ 10,	TOKEN_INT,	NULL,		21,	1,	0,	0	},
/*  11 Daylight . Savings Time */
{ 11,	TOKEN_MATCH,	"Savings",	0,	12,	0,	0	},
{ 11,	TOKEN_MATCH,	"Saving",	0,	12,	0,	0	},
/*  12 Daylight Savings . Time  */
{ 12,	TOKEN_MATCH,	"Time",		0,	13,	0,	0	},
/*  13 DST . [starts/ends] */
{ 13,	TOKEN_MATCH,	"starts",	11,	14,	0,	1	},
{ 13,	TOKEN_MATCH,	"start",	11,	14,	0,	1	},
{ 13,	TOKEN_MATCH,	"ends",		11,	14,	0,	2	},
{ 13,	TOKEN_MATCH,	"end",		11,	14,	0,	2	},
/*  14 DST [starts/ends] . nth weekend in <month> */
{ 14,	TOKEN_MATCH,	"first",	12,	15,	0,	1	},
{ 14,	TOKEN_MATCH,	"1st",		12,	15,	0,	1	},
{ 14,	TOKEN_MATCH,	"second",	12,	15,	0,	2	},
{ 14,	TOKEN_MATCH,	"2nd",		12,	15,	0,	2	},
{ 14,	TOKEN_MATCH,	"third",	12,	15,	0,	3	},
{ 14,	TOKEN_MATCH,	"3rd",		12,	15,	0,	3	},
{ 14,	TOKEN_MATCH,	"forth",	12,	15,	0,	4	},
{ 14,	TOKEN_MATCH,	"4th",		12,	15,	0,	4	},
{ 14,	TOKEN_MATCH,	"last",		12,	18,	0,	-1	},
{ 14,	TOKEN_MATCH,	"next",		12,	16,	0,	-2	},
/*  15 DST [starts/ends] nth . [to last] weekend in <month> */
{ 15,	TOKEN_MATCH,	"to",		0,	17,	0,	0	},
{ 15,	TOKEN_MATCH,	"weekend",	0,	19,	0,	0	},
{ 15,	TOKEN_MATCH,	"week",		0,	19,	0,	0	},
/*  16 DST [starts/ends] next . to last weekend in <month> */
{ 16,	TOKEN_MATCH,	"to",		0,	17,	0,	0	},
/*  17 DST [starts/ends] nth to . last weekend in <month> */
{ 17,	TOKEN_MATCH,	"last",		22,	18,	0,	0	},
/*  18 DST [starts/ends] nth to last . weekend in <month> */
{ 18,	TOKEN_MATCH,	"weekend",	0,	19,	0,	0	},
{ 18,	TOKEN_MATCH,	"week",		0,	19,	0,	0	},
/*  19 DST [starts/ends] nth weekend . in <month> */
{ 19,	TOKEN_MATCH,	"in",		0,	20,	0,	0	},
/*  20 DST [starts/ends] nth weekend in . <month> */
{ 20,	TOKEN_MONTH,	NULL,		23,	2,	0,	0	},
/*  21 MINYIN . phrase */
{ 21,	TOKEN_MONTH,	NULL,		24,	22,	1,	0	},
{ 21,	TOKEN_INT,	NULL,		25,	23,	1,	0	},
{ 21,	TOKEN_MATCH,	"Sunday",	12,	23,	0,	0	},
{ 21,	TOKEN_MATCH,	"Sun",		12,	23,	0,	0	},
{ 21,	TOKEN_MATCH,	"Monday",	12,	23,	0,	1	},
{ 21,	TOKEN_MATCH,	"Mon",		12,	23,	0,	1	},
{ 21,	TOKEN_MATCH,	"Tuesday",	12,	23,	0,	2	},
{ 21,	TOKEN_MATCH,	"Tues",		12,	23,	0,	2	},
{ 21,	TOKEN_MATCH,	"Tue",		12,	23,	0,	2	},
{ 21,	TOKEN_MATCH,	"Wednesday",	12,	23,	0,	3	},
{ 21,	TOKEN_MATCH,	"Wed",		12,	23,	0,	3	},
{ 21,	TOKEN_MATCH,	"Thursday",	12,	23,	0,	4	},
{ 21,	TOKEN_MATCH,	"Thurs",	12,	23,	0,	4	},
{ 21,	TOKEN_MATCH,	"Thu",		12,	23,	0,	4	},
{ 21,	TOKEN_MATCH,	"Friday",	12,	23,	0,	5	},
{ 21,	TOKEN_MATCH,	"Fri",		12,	23,	0,	5	},
{ 21,	TOKEN_MATCH,	"Saturday",	12,	23,	0,	6	},
{ 21,	TOKEN_MATCH,	"Sat",		12,	23,	0,	6	},
{ 21,	TOKEN_MATCH,	"Shabbat",	12,	23,	0,	6	},
{ 21,	TOKEN_MATCH,	"Sabbath",	12,	23,	0,	6	},
{ 21,	TOKEN_MATCH,	"Rosh",		0,	50,	0,	0	},
{ 21,	TOKEN_MATCH,	"Holiday",	12,	23,	0,	CHAG	},
{ 21,	TOKEN_MATCH,	"Hag",		12,	23,	0,	CHAG	},
{ 21,	TOKEN_MATCH,	"Chag",		12,	23,	0,	CHAG	},
/*  22 MINYIN <month> . <date> <times> */
{ 22,	TOKEN_INT,	NULL,		25,	23,	1,	0	},
/*  23 MINYIN <date> . <time> [<time> [<time>]] */
{ 23,	TOKEN_TIME,	NULL,		43,	24,	0,	0	},
{ 23,	TOKEN_MATCH,	"........",	0,	24,	0,	0	},
{ 23,	TOKEN_MATCH,	".......",	0,	24,	0,	0	},
{ 23,	TOKEN_MATCH,	"...",		0,	24,	0,	0	},
{ 23,	TOKEN_MATCH,	".",		0,	24,	0,	0	},
/*  24 MINYIN <date> <time> . [<time> [<time>]] */
{ 24,	TOKEN_TIME,	NULL,		44,	25,	0,	0	},
{ 24,	TOKEN_MATCH,	"........",	0,	25,	0,	0	},
{ 24,	TOKEN_MATCH,	".......",	0,	25,	0,	0	},
{ 24,	TOKEN_MATCH,	"...",		0,	25,	0,	0	},
{ 24,	TOKEN_MATCH,	".",		0,	25,	0,	0	},
{ 24,	TOKEN_EOCM,	NULL,		27,	0,	0,	0	},
{ 24,	TOKEN_EOF,	NULL,		27,	-1,	0,	0	},
{ 24,	TOKEN_STRING,	NULL,		26,	21,	0,	0	},
/*  25 MINYIN <date> <time> <time> . [<time>] */
{ 25,	TOKEN_TIME,	NULL,		0,	26,	0,	0	},
{ 25,	TOKEN_MATCH,	"........",	0,	26,	0,	0	},
{ 25,	TOKEN_MATCH,	".......",	0,	26,	0,	0	},
{ 25,	TOKEN_MATCH,	"...",		0,	26,	0,	0	},
{ 25,	TOKEN_MATCH,	".",		0,	26,	0,	0	},
{ 25,	TOKEN_EOCM,	NULL,		27,	0,	0,	0	},
{ 25,	TOKEN_EOF,	NULL,		27,	-1,	0,	0	},
{ 25,	TOKEN_STRING,   NULL,		26,	21,	0,	0	},
/*  26 MINYIN <date> <time> <time> <time> . */
{ 26,	TOKEN_EOCM,	NULL,		27,	0,	0,	0	},
{ 26,	TOKEN_EOF,	NULL,		27,	-1,	0,	0	},
{ 26,	TOKEN_STRING,	NULL,		26,	21,	0,	0	},
/*  27 <month> . <day> <dated command> */
{ 27,	TOKEN_INT,	NULL,		25,	28,	1,	0	},
/*  28 <month> <day> . <dated command> */
{ 28,	TOKEN_MATCH,	"Is",		0,	29,	0,	0	},
{ 28,	TOKEN_MATCH,	"Holiday",	28,	2,	0,	0	},
{ 28,	TOKEN_MATCH,	"Hag",		28,	2,	0,	0	},
{ 28,	TOKEN_MATCH,	"Chag",		28,	2,	0,	0	},
{ 28,	TOKEN_MATCH,	"Candles",	0,	32,	0,	0	},
{ 28,	TOKEN_MATCH,	"Havdalah",	29,	2,	0,	0	},
{ 28,	TOKEN_MATCH,	"Omer",		0,	33,	0,	0	},
{ 28,	TOKEN_MATCH,	"Chanukah",	0,	34,	0,	0	},
{ 28,	TOKEN_MATCH,	"Chanukiah",	0,	34,	0,	0	},
{ 28,	TOKEN_MATCH,	"Hanukah",	0,	34,	0,	0	},
{ 28,	TOKEN_MATCH,	"Hanukiah",	0,	34,	0,	0	},
{ 28,	TOKEN_MATCH,	"Chanuka",	0,	34,	0,	0	},
{ 28,	TOKEN_MATCH,	"Chanukia",	0,	34,	0,	0	},
{ 28,	TOKEN_MATCH,	"Hanuka",	0,	34,	0,	0	},
{ 28,	TOKEN_MATCH,	"Hanukia",	0,	34,	0,	0	},
{ 28,	TOKEN_MATCH,	"Shabbat",	0,	35,	0,	0	},
{ 28,	TOKEN_MATCH,	"Sabbath",	0,	35,	0,	0	},
{ 28,	TOKEN_MATCH,	"Bar",		13,	42,	0,	0	},
{ 28,	TOKEN_MATCH,	"Bat",		13,	42,	0,	1	},
{ 28,	TOKEN_MATCH,	"B'nei",	13,	42,	0,	2	},
{ 28,	TOKEN_MATCH,	"Bnei",		13,	42,	0,	2	},
{ 28,	TOKEN_MATCH,	"B'not",	13,	42,	0,	3	},
{ 28,	TOKEN_MATCH,	"Bnot",		13,	42,	0,	3	},
{ 28,	TOKEN_MATCH,	"*",		12,	47,	0,	1	},
{ 28,	TOKEN_TIME,	NULL,		0,	48,	0,	0	},
{ 28,	TOKEN_STRING,	NULL,		7,	48,	0,	0	},
{ 28,	TOKEN_EOLN,	NULL,		0,	49,	0,	0	},
/*  29 <month> <day> Is . <jmonth> [<day> [<year>]] */
{ 29,	TOKEN_STRING,	NULL,		7,	30,	1,	0	},
/*  30 <month> <day> Is <jmonth> . [<day> [<year>]] */
{ 30,	TOKEN_INT,	NULL,		30,	31,	1,	0	},
{ 30,	TOKEN_EOCM,	NULL,		32,	0,	0,	0	},
{ 30,	TOKEN_EOF,	NULL,		32,	-1,	0,	0	},
/*  31 <month> <day> Is <jmonth> <day> . [<year>] */
{ 31,	TOKEN_INT,	NULL,		31,	2,	1,	0	},
{ 31,	TOKEN_EOCM,	NULL,		32,	0,	0,	0	},
{ 31,	TOKEN_EOF,	NULL,		32,	-1,	0,	0	},
/*  32 <month> <day> Candles . Early | Late */
{ 32,	TOKEN_MATCH,	"Early",	33,	2,	0,	TIME_CANDLES_EARLY	},
{ 32,	TOKEN_MATCH,	"Late",		33,	2,	0,	TIME_CANDLES_LATE	},
/*  33 <month> <day> Omer . <count> */
{ 33,	TOKEN_INT,	NULL,		34,	2,	0,	0	},
/*  34 <month> <day> Chanukah . <count> */
{ 34,	TOKEN_INT,	NULL,		35,	2,	0,	0	},
/*  35 <month> <day> Shabbat . <parsha> <torah> <prophet> */
{ 35,	TOKEN_STRING,	NULL,		7,	36,	0,	0	},
/*  36 <month> <day> Shabbat <parsha> . <torah> <prophet> */
{ 36,	TOKEN_STRING,	NULL,		8,	37,	0,	0	},
/*  37 <month> <day> Shabbat <parsha> <torah> . <prophet> */
{ 37,	TOKEN_STRING,	NULL,		9,	38,	0,	0	},
/*  38 <month> <day> Shabbat <parsha> <torah> <prophet> . [<str> <str>]*/
{ 38,	TOKEN_EOLN,	NULL,		37,	41,	0,	0	},
{ 38,	TOKEN_EOCM,	NULL,		37,	0,	0,	0	},
{ 38,	TOKEN_EOF,	NULL,		37,	-1,	0,	0	},
{ 38,	TOKEN_STRING,	NULL,		36,	39,	0,	0	},
/*  39 <month> <day> Shabbat <parsha> <torah> <chap> <prophet> . <chap> */
{ 39,	TOKEN_STRING,	NULL,		9,	40,	0,	0	},
/*  40 <month> <day> Shabbat <parsha> <torah> <chap> <prophet> <chap> . */
{ 40,	TOKEN_EOLN,	NULL,		37,	41,	0,	0	},
{ 40,	TOKEN_EOCM,	NULL,		37,	0,	0,	0	},
{ 40,	TOKEN_EOF,	NULL,		37,	-1,	0,	0	},
{ 40,	TOKEN_STRING,	NULL,		38,	1,	0,	0	},
/*  41 <month> <day> Shabbat <params> <EOLN> . <stuff> */
{ 41,	TOKEN_EOCM,	NULL,		39,	0,	0,	0	},
{ 41,	TOKEN_EOF,	NULL,		39,	-1,	0,	0	},
{ 41,	TOKEN_STRING,	NULL,		10,	41,	0,	0	},
/*  42 <month> <day> Bar . Mitzvah [of] name */
{ 42,	TOKEN_MATCH,	"Mitzvah",	0,	43,	0,	0	},
{ 42,	TOKEN_EOLN,	NULL,		0,	49,	0,	0	},
{ 42,	TOKEN_EOCM,	NULL,		42,	0,	0,	0	},
{ 42,	TOKEN_EOF,	NULL,		42,	-1,	0,	0	},
{ 42,	TOKEN_STRING,	NULL,		7,	48,	0,	0	},
/*  43 <month> <day> Bar Mitzvah . [of] name */
{ 43,	TOKEN_MATCH,	"of",		12,	44,	0,	1	},
{ 43,	TOKEN_STRING,	NULL,		40,	45,	0,	2	},
/*  44 <month> <day> Bar Mitzvah of . name */
{ 44,	TOKEN_STRING,	NULL,		8,	45,	0,	0	},
/*  45 <month> <day> Bar Mitzvah of name . [name] [<EOLN> <more>] */
{ 45,	TOKEN_STRING,	NULL,		8,	45,	0,	0	},
{ 45,	TOKEN_EOLN,	NULL,		0,	46,	0,	0	},
{ 45,	TOKEN_EOCM,	NULL,		41,	0,	0,	0	},
{ 45,	TOKEN_EOF,	NULL,		41,	-1,	0,	0	},
/*  46 <month> <day> Bar Mitzvah of name <EOLN> . <more> */
{ 46,	TOKEN_STRING,	NULL,		9,	46,	0,	0	},
{ 46,	TOKEN_EOCM,	NULL,		41,	0,	0,	0	},
{ 46,	TOKEN_EOF,	NULL,		41,	-1,	0,	0	},
/*  47 <month> <day> * . [<time>] item... */
{ 47,	TOKEN_TIME,	NULL,		0,	48,	0,	0	},
{ 47,	TOKEN_STRING,	NULL,		7,	48,	0,	0	},
/*  48 <month> <day> * <time> <item> . [<item...>] [<eoln> <more>] */
{ 48,	TOKEN_STRING,	NULL,		7,	48,	0,	0	},
{ 48,	TOKEN_EOLN,	NULL,		0,	49,	0,	0	},
{ 48,	TOKEN_EOCM,	NULL,		42,	0,	0,	0	},
{ 48,	TOKEN_EOF,	NULL,		42,	-1,	0,	0	},
/*  49 <month> <day> * <time> <item...> <eoln> . <more>] */
{ 49,	TOKEN_STRING,	NULL,		8,	49,	0,	0	},
{ 49,	TOKEN_EOCM,	NULL,		42,	0,	0,	0	},
{ 49,	TOKEN_EOF,	NULL,		42,	-1,	0,	0	},
/*  50 MINYIN ROSH . CHODESH phrase */
{ 50,	TOKEN_MATCH,	"Chodesh",	12,	23,	0,	ROSH	},
{ 50,	TOKEN_MATCH,	"Hodesh",	12,	23,	0,	ROSH	},
/*  51 INCLUDE . <file> */
{ 51,	TOKEN_STRING,	NULL,		7,	51,	0,	0	},
{ 51,	TOKEN_EOCM,	NULL,		45,	0,	0,	0	},
{ 51,	TOKEN_EOF,	NULL,		45,	-1,	0,	0	},
/*  -1 trailer */
{ -1,	0,		NULL,		0,	0,	0,	0	}
};

#if defined(PROTOTYPES)
int read_file(char *filename,int report_open) {
#else
int read_file(filename,report_open) char *filename; int report_open;{
#endif
	FILE	 *file;
	char    **pptr;
	int       state;
	char      string[MAX_STR];
	char      string2[MAX_STR];
	ptable_t *table;
	int       token;

	if (!(file = fopen(filename,"r"))) {
		if (report_open) {
			sprintf(string,"Can not open file %s",filename);
			report_error(string);
		}
		return 1;
	}
	if (!file_bottom) {
		file_bottom = (file_info_t *)new(sizeof(file_info_t));
		file_bottom->last = NULL;
		file_bottom->next = NULL;
	}
	file_bottom->name = filename;
	file_bottom->file = file;
	file_bottom->line = 1;
	file_current = file_bottom;
	state = 0;
	parse_errors = 0;
	read_buffer[0] = 0;
	parse_init();
#ifdef PTOKENS
	while ((token = get_token(string)) != TOKEN_EOF) {
		switch (token) {
			case TOKEN_EOCM:
				fprintf(stderr,"END OF COMMAND\n");
				break;
			case TOKEN_EOLN:
				fprintf(stderr,"END OF LINE\n");
				break;
			case TOKEN_STRING:
				fprintf(stderr,"STRING = %s\n",string);
				break;
		}
	}
#else
	while (state >= 0) {
		if (state == 0) {
			parse_int_1 = 0;
			parse_int_2 = 0;
			parse_int_3 = 0;
			*parse_string_1 = '\0';
			*parse_string_2 = '\0';
			*parse_string_3 = '\0';
			*parse_string_4 = '\0';
		}
		token = get_token(string);
#ifdef PSTATE
		fprintf(stderr,"state = %3d, token = %-7s,%-10.10s",state,
				token == TOKEN_EOF ? "EOF":
				token == TOKEN_EOLN ? "EOLN":
				token == TOKEN_EOCM ? "EOCM":
				token == TOKEN_STRING ? "STRING" :
				                       "UNKNOWN",string);
#endif
		for (table = parse_entry[state];
			table->state == state &&
			       !((table->token == token) ||
				 (table->token == TOKEN_MATCH &&
				     casecmp(string,table->match) == 0) ||
				 (table->token == TOKEN_INT &&
				     is_int(string)) ||
				 (table->token == TOKEN_TIME &&
				     (is_time(string,YES,&parse_time_1))) ||
				 (table->token == TOKEN_JMONTH &&
				     is_jmonth(string)) ||
				 (table->token == TOKEN_MONTH &&
				     is_month(string) != -1) ||
				 (table->token == TOKEN_DOT &&
				     is_dot(string) != -1) ||
				 (table->token == TOKEN_LATITUDE &&
				     is_latlong(string,'l',YES)) ||
				 (table->token == TOKEN_LONGITUDE &&
				     is_latlong(string,'L',YES))
				);
			table++)
			;

		if (table->state == state) {
#ifdef PSTATE
			fprintf(stderr,"token = %-7s,%-10.10s, action = %3d    ",
				table->token == TOKEN_EOF ? "EOF":
				table->token == TOKEN_EOLN ? "EOLN":
				table->token == TOKEN_EOCM ? "EOCM":
				table->token == TOKEN_STRING ? "STRING" :
				table->token == TOKEN_MATCH ? "MATCH":
				table->token == TOKEN_INT ? "INT":
				table->token == TOKEN_TIME ? "TIME":
				table->token == TOKEN_JMONTH ? "JMONTH":
				table->token == TOKEN_MONTH ? "MONTH":
				table->token == TOKEN_DOT ? "DOT":
				table->token == TOKEN_LATITUDE ? "LATITUDE":
				table->token == TOKEN_LONGITUDE ? "LONGITUDE":
				                       "UNKNOWN",
			string,table->action);
#endif
			state = parse_action(table,string);
		} else {
#ifdef PSTATE
			if (token != TOKEN_EOLN)
				fprintf(stderr,"%28saction = error\n"," ");
#endif
			if (token == TOKEN_EOF) {
				parse_error("Premature EOF in file");
				state = -2;
			} else if (token == TOKEN_EOCM) {
				state = 0;
				if (parse_error("Premature end of command"))
					state = -2;
			} else if (token != TOKEN_EOLN) {
				state = 0;
				sprintf(string2,
	"Unexpected token '%s' in command",string);
				if (parse_error(string2))
					state = -2;
				else {
					while (token != TOKEN_EOCM &&
							token != TOKEN_EOF) {
						token = get_token(string);
					}
				}
			}
		}
#ifdef PSTATE
		fprintf(stderr,"nstate = %3d\n",state);
#endif
	}
#endif
	if (parse_errors)
		display_it(parse_error_table);
	return(parse_errors);
}

#if defined(PROTOTYPES)
void replace_char(void) {
#else
void replace_char() {
#endif
	if (*read_place == EOF)
		return;
	if (read_place == read_buffer)
		read_place = read_buffer + MAX_STR;
	read_place--;
	return;
}

#if defined(PROTOTYPES)
void replace_token(void) {
#else
void replace_token(); {
#endif
	read_place = read_token_start;
	return;
}
