static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "hcal.h"

static float height_pixel_point,width_pixel_point;
static int cal_height,cal_width;
static Window xcal_window;
  static cur_wlist_t		*cptr_redraw;
  static cur_wlist_t		*cptr_holder;
  static cur_wlist_t		*cptr_scroller;
  static cur_wlist_t		*cptr_calendar;
static GC cal_gc;
XFontStruct	*font8M;
XFontStruct	*font10M;
XFontStruct	*font12M;
XFontStruct	*font14M;
XFontStruct	*font18M;
XFontStruct	*font24M;
XFontStruct	*font8B;
XFontStruct	*font10B;
XFontStruct	*font12B;
XFontStruct	*font24B;

#if defined(PROTOTYPES)
void xcal_setup(void)
#else
void xcal_setup()
#endif
  {
  int			 init_lines;
  int			 lines;
  int			 loop;
  int			 max_width;
  char			**tptr;
  int			 width;
  int			 winsize = 0;
  char			**local_text;
  int			display_heightMM;
  int			display_widthMM;

  cal_gc = XCreateGC(cur_display,cur_base_window,0,NULL);
  XSetForeground(cur_display,cal_gc,BlackPixel(cur_display,cur_display_number));
  XSetBackground(cur_display,cal_gc,WhitePixel(cur_display,cur_display_number));
  XSetLineAttributes(cur_display,cal_gc,2,LineSolid,CapButt,JoinMiter);
  if ((font8B=XLoadQueryFont(cur_display,"*helvetica-bold-r-*-80-*")) == NULL) 
    cur_msg_win("Can not load font helvetica bold 8");
  if ((font10B=XLoadQueryFont(cur_display,"*helvetica-bold-r-*-100-*")) == NULL) 
    cur_msg_win("Can not load font helvetica bold 10");
  if ((font12B=XLoadQueryFont(cur_display,"*helvetica-bold-r-*-120-*")) == NULL) 
    cur_msg_win("Can not load font helvetica bold 12");
  if ((font24B=XLoadQueryFont(cur_display,"*helvetica-bold-r-*-240-*")) == NULL) 
    cur_msg_win("Can not load font helvetica bold 24");
  if ((font8M=XLoadQueryFont(cur_display,"*helvetica-medium-r-*-80-*")) == NULL) 
    cur_msg_win("Can not load font helvetica medium 8");
  if ((font10M=XLoadQueryFont(cur_display,"*helvetica-medium-r-*-100-*")) == NULL) 
    cur_msg_win("Can not load font helvetica medium 10");
  if ((font12M=XLoadQueryFont(cur_display,"*helvetica-medium-r-*-120-*")) == NULL) 
    cur_msg_win("Can not load font helvetica medium 12");
  if ((font14M=XLoadQueryFont(cur_display,"*helvetica-medium-r-*-140-*")) == NULL) 
    cur_msg_win("Can not load font helvetica medium 14");
  if ((font18M=XLoadQueryFont(cur_display,"*helvetica-medium-r-*-180-*")) == NULL) 
    cur_msg_win("Can not load font helvetica medium 18");
  if ((font24M=XLoadQueryFont(cur_display,"*helvetica-medium-r-*-240-*")) == NULL) 
    cur_msg_win("Can not load font helvetica medium 24");

  display_heightMM = DisplayHeightMM(cur_display,cur_display_number);
  display_widthMM = DisplayWidthMM(cur_display,cur_display_number);
  height_pixel_point = (25.4 * cur_display_height) / (72.0 * display_heightMM);
  width_pixel_point = (25.4 * cur_display_width) / (72.0 * display_widthMM);
  cal_width = 11 * 72 * width_pixel_point;
  cal_height = 8.5 * 72 * height_pixel_point;

  cptr_holder = cur_mk_holder("Calendar","Calendar",
	cal_width + 24,cal_height + CUR_BUTTON_HEIGHT + 12,
	1,1,40 + cur_button_width,40 + CUR_BUTTON_HEIGHT,flag_i);

  cptr_redraw = cur_mk_button(cptr_holder,"Redraw",-cptr_holder->width,
	-cptr_holder->height,0,SouthWestGravity,CUR_BUTTON_NORETURN,
	xcal_draw,NULL,NULL,NULL,NULL);

  cptr_scroller = cur_mk_scroller(cptr_holder,0,0,cal_width + 2,cal_height + 2,
	1,1,0,0);

  xcal_window = XCreateSimpleWindow(cur_display,cptr_scroller->window,0,0,
	cal_width,cal_height,0,
	BlackPixel(cur_display,cur_display_number),
	WhitePixel(cur_display,cur_display_number));

  XSelectInput(cur_display, xcal_window, ExposureMask);
  XMapWindow(cur_display,xcal_window);
  enlist(cptr_calendar,xcal_window,CUR_WLIST_OTHER,cal_height,cal_width)

  cptr_calendar->data.other.routine = xcal_draw;
  cptr_calendar->data.other.parameter1 = NULL;
  cptr_calendar->data.other.parameter2 = NULL;
  cptr_calendar->data.other.parameter3 = NULL;

  cptr_holder->data.holder.child = cptr_scroller;
  cptr_scroller->data.scroller.child = cptr_calendar;
  cptr_scroller->data.scroller.child_width = cptr_calendar->width;
  cptr_scroller->data.scroller.child_height = cptr_calendar->height;

  cur_msg_win("Calendar does NOT automatically update, hit redraw button to update");

  return;
  }

#if defined(PROTOTYPES)
void xcal_remove(void)
#else
void xcal_remove()
#endif
  {
  delist(cptr_calendar);
  cur_rm_button(cptr_redraw);
  cur_rm_scroller(cptr_scroller);
  cur_rm_holder(cptr_holder);
  return;
  }

#undef		BOTTOM_MARGIN /* these undefs counter defs for main program */
#undef		TOP_MARGIN    /* which cover ps macro names we are trying to */
#undef		RIGHT_MARGIN  /* preserve */
#undef		LEFT_MARGIN
#undef		SHAHARIT
#undef		MINCHA
#undef		MARIV

static int	BOXY;
static int	BOXX;

#if defined(PROTOTYPES)
static void	GET_BOX(int);
static void	SHAHARIT(char *);
static void	MINCHA(char *);
static void	MARIV(char *);
static void	MITZVAH(int,char *,char *);
static void	DATE(int);
static void	HOLIDAY(int);
static void	CANDLES(char *);
static void	HAVDALAH(char *);
static void	CHANUKAH(int);
static void	CHANUKAH_FLAME(int,int);
static void	OMER(int);
static void	SHABBAT(char *,char *,char *);
static void	BOLD_ITEM(int,char *);
static void	ITEM(int,char *);
static void	JDATE(char *,int);
#else
static void	GET_BOX();
static void	SHAHARIT();
static void	MINCHA();
static void	MARIV();
static void	MITZVAH();
static void	DATE();
static void	HOLIDAY();
static void	CANDLES();
static void	HAVDALAH();
static void	CHANUKAH();
static void	CHANUKAH_FLAME();
static void	OMER();
static void	SHABBAT();
static void	BOLD_ITEM();
static void	ITEM();
static void	JDATE();
#endif

static int	TOP;

#define		START_DAY	(first_week_day + 1)
static char	MONTH[40];
#define		MDAYS		numdays
static char	YEAR[5];
#define		BOTTOM_MARGIN	margin_bottom
#define		TOP_MARGIN	margin_top
#define		RIGHT_MARGIN	margin_right
#define		LEFT_MARGIN	margin_left
static char	JYEAR[10];

#define		HEIGHT		612
#define		WIDTH		792
#define		MONTH_SIZE	24
#define		DAY_SIZE	18
#define		BOX_WIDTH	102
#define pixelx(point)  ((int)(((float)(point)) * width_pixel_point))
#define pixely(point)  ((int)(((float)(HEIGHT - (point))) * height_pixel_point))

static int	TOP_LINE;
static int	TOP_CAL;
static int	CAL_HEIGHT;

static int	RIGHT_SIDE;
#define		LEFT_SIDE	LEFT_MARGIN
static int	CAL_WIDTH;

static int BOXES;
static int MDAY_SIZE;
static int BOX_HEIGHT;

#define DO_FONT(font)  XSetFont(cur_display,cal_gc,font->fid)
#if defined(PROTOTYPES)
int xcal_draw(void)
#else
int xcal_draw()
#endif
  {
  int tempx;
  int tempy;
  int loop;
  int mark;
  int item;
  char string[256];
  char *sptr;
  info_t *iptr;

  XClearWindow(cur_display,xcal_window);
  if (!draw_month)
    return;
  /* set up variables */
  strcpy(MONTH,month[current_month]);
  strcat(MONTH," - ");
  for (mark = 0,loop = 1;loop <= numdays;loop++) 
    {
    if ((!mark && day[loop].jmonth) ||
        strcmp(day[mark].jmonth,day[loop].jmonth)!= 0) 
      {
      if (mark)
	strcat(MONTH,"/");
      strcat(MONTH,day[loop].jmonth);
      mark = loop;
      }
    }

  TOP = HEIGHT - TOP_MARGIN;
  TOP_LINE = TOP - MONTH_SIZE;
  TOP_CAL = TOP_LINE - DAY_SIZE;
  CAL_HEIGHT = TOP_LINE - BOTTOM_MARGIN;

  RIGHT_SIDE = WIDTH - RIGHT_MARGIN;
  CAL_WIDTH = RIGHT_SIDE - LEFT_MARGIN;

  BOXES = (MDAYS + START_DAY + 5) / 7;
  MDAY_SIZE = (BOXES == 6) ? 14 : 24;
  BOX_HEIGHT = (TOP_CAL - BOTTOM_MARGIN) / BOXES;

  /* draw lines */
  for (loop = 0; loop <= BOXES;loop++)
    {
    tempy = pixely((loop * BOX_HEIGHT) + BOTTOM_MARGIN);
    XDrawLine(cur_display,xcal_window,cal_gc,
	pixelx(LEFT_SIDE),tempy,pixelx(LEFT_SIDE + CAL_WIDTH),tempy);
    }
  for (loop = 0; loop <= 7;loop++)
    {
    tempx = pixelx((loop * BOX_WIDTH) + LEFT_SIDE);
    XDrawLine(cur_display,xcal_window,cal_gc,
	tempx,pixely(BOTTOM_MARGIN),tempx,pixely(BOTTOM_MARGIN + CAL_HEIGHT));
    }

  /* print month header */
  DO_FONT(font24B);
  tempx = CAL_WIDTH;
  tempx -= (XTextWidth(font24B,MONTH,strlen(MONTH)) / width_pixel_point);
  tempx /= 2;
  tempx += LEFT_SIDE;
  tempx = pixelx(tempx);
  tempy = pixely(TOP_LINE + 5);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,MONTH,strlen(MONTH));
  sprintf(string,"%d",current_year);
  tempx = pixelx(LEFT_SIDE);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,string,strlen(string));
  if (day[1].jyear != day[numdays].jyear)
    sprintf(string,"%d/%d",day[1].jyear,day[numdays].jyear);
  else
    sprintf(string,"%d",day[1].jyear);
  tempx = RIGHT_SIDE;
  tempx -= (XTextWidth(font24B,string,strlen(string)) / width_pixel_point);
  tempx = pixelx(tempx);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,string,strlen(string));

  /* print days of week */
  DO_FONT(font18M);
  tempy = pixely(TOP_CAL + 2);
  for (loop = 0;loop < 7;loop++)
    {
    tempx = pixelx((loop * BOX_WIDTH) + LEFT_SIDE + 4);
    XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,
	weekdays[loop],strlen(weekdays[loop]));
    }

  /* do locale */
  DO_FONT(font12M);
  GET_BOX(MDAYS);
  sprintf(string,"Candle Lighting times are for %s",city->name);
  tempx = CAL_WIDTH;
  tempx -= (XTextWidth(font12B,string,strlen(string)) / width_pixel_point);
  tempx /= 2;
  tempx += LEFT_SIDE;
  tempx = pixelx(tempx);
  tempy = pixely(BOXY - 12);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,string,strlen(string));

  /* now do dailies */
  for (loop = 1;loop <= numdays;loop++)
    {
    item = 1;
    GET_BOX(loop);
    if (day[loop].holiday || day[loop].shabbat)
      HOLIDAY(loop);
    else
      DATE(loop);
    if (day[loop].shaharit.word1)
      SHAHARIT(format_time(loop,&day[loop].shaharit,TIME_FORMAT_CLIPPED));
    if (day[loop].mincha.word1)
      MINCHA(format_time(loop,&day[loop].mincha,TIME_FORMAT_CLIPPED));
    if (day[loop].mariv.word1)
      MARIV(format_time(loop,&day[loop].mariv,TIME_FORMAT_CLIPPED));
    if (day[loop].jmonth && *day[loop].jmonth)
      JDATE(day[loop].jmonth,day[loop].jday);
    if (day[loop].mitzvah) 
      {
      MITZVAH(day[loop].mitzvah->place,day[loop].mitzvah->who,
		mitztypes[day[loop].mitzvah->type]);
      item++;
      }
    if (day[loop + 1].mitzvah)
      item++;
    if (day[loop].shabbat) 
	SHABBAT(day[loop].shabbat->name,
			day[loop].shabbat->torah,day[loop].shabbat->prophet);
    if (day[loop].candles.word1 == TIME_CANDLES_HAVDALAH)
      HAVDALAH(format_time(loop,&day[loop].candles,TIME_FORMAT_CLIPPED));
    else if (day[loop].candles.word1)
      CANDLES(format_time(loop,&day[loop].candles,TIME_FORMAT_CLIPPED));
    if (day[loop].omer)
      OMER(day[loop].omer);
    if (day[loop].chanukah)
      CHANUKAH(day[loop].chanukah);
    for (iptr = day[loop].info;iptr;iptr = iptr->next)
      {
      if (iptr->calendar)
	{
	break_up(loop,&iptr->time,iptr->calendar,iptr->bold,string);
	for (sptr = string;*sptr;sptr = sptr + strlen(sptr) + 1)
	  {
	  if (iptr->bold)
	    BOLD_ITEM(item++,sptr);
	  else
	    ITEM(item++,sptr);
	  }
	}
      }
    }
  }

#if defined(PROTOTYPES)
static void GET_BOX(int date)
#else
static void GET_BOX(date) int date;
#endif
  {
  int wday;

  wday = date + START_DAY - 2;
  BOXX = ((wday % 7) * BOX_WIDTH) + LEFT_SIDE;
  BOXY = (((BOXES - 1) - (wday / 7)) * BOX_HEIGHT) + BOTTOM_MARGIN;
  }

#if defined(PROTOTYPES)
static void SHAHARIT(char *time)
#else
static void SHAHARIT(time) char *time;
#endif
  {
  int tempx,tempy;

  DO_FONT(font8M);
  tempx = pixelx(BOXX + 3);
  tempy = pixely(BOXY + BOX_HEIGHT - 10);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,time,strlen(time));
  };

#if defined(PROTOTYPES)
static void MINCHA(char *time)
#else
static void MINCHA(time) char *time;
#endif
  {
  int tempx,tempy;

  DO_FONT(font8M);
  tempx = pixelx(BOXX + 3);
  tempy = pixely(BOXY + 9);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,time,strlen(time));
  };

#if defined(PROTOTYPES)
static void MARIV(char *time)
#else
static void MARIV(time) char *time;
#endif
  {
  int tempx,tempy;

  DO_FONT(font8M);
  tempx = pixelx(BOXX + 3);
  tempy = pixely(BOXY + 1);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,time,strlen(time));
  }

#if defined(PROTOTYPES)
static void DATE(int date)
#else
static void DATE(date) int date;
#endif
  {
  char string[4];
  int tempx,tempy;
  
  sprintf(string,"%d",date);
  tempx = BOXX + BOX_WIDTH;
  if (MDAY_SIZE == 14)
    {
    DO_FONT(font14M);
    tempx -= (XTextWidth(font14M,string,strlen(string)) / width_pixel_point);
    }
  else
    {
    DO_FONT(font24M);
    tempx -= (XTextWidth(font24M,string,strlen(string)) / width_pixel_point);
    }
  tempx -= 3;
  tempx = pixelx(tempx);
  tempy = pixely(BOXY + BOX_HEIGHT - MDAY_SIZE);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,string,strlen(string));
  }

#if defined(PROTOTYPES)
static void HOLIDAY(int date)
#else
static void HOLIDAY(date) int date;
#endif
  {
  char string[4];
  int widthx,tempx1,tempx2,tempy1,tempy2;
  
  sprintf(string,"%d",date);
  if (MDAY_SIZE == 14)
    {
    DO_FONT(font14M);
    widthx = XTextWidth(font14M,string,strlen(string));
    }
  else
    {
    DO_FONT(font24M);
    widthx = XTextWidth(font24M,string,strlen(string));
    }
  tempx1 = pixelx(BOXX + BOX_WIDTH - 6) - widthx;
  tempx2 = pixelx(BOXX + BOX_WIDTH);
  tempy1 = pixely(BOXY + BOX_HEIGHT);
  tempy2 = pixely(BOXY + BOX_HEIGHT - MDAY_SIZE);
  XFillRectangle(cur_display,xcal_window,cal_gc,tempx1,tempy1,
      tempx2 - tempx1,tempy2 - tempy1);
  XSetForeground(cur_display,cal_gc,WhitePixel(cur_display,cur_display_number));
  tempx1 = pixelx(BOXX + BOX_WIDTH - 3) - widthx;
  XDrawString(cur_display,xcal_window,cal_gc,tempx1,tempy2,string,strlen(string));
  XSetForeground(cur_display,cal_gc,BlackPixel(cur_display,cur_display_number));
  }

#if defined(PROTOTYPES)
static void JDATE(char *month,int day)
#else
static void JDATE(month,day) char *month;int day;
#endif
  {
  char string[12];
  int tempx,tempy;

  DO_FONT(font10M);
  sprintf(string,"%s %d",month,day);
  tempx = BOXX + BOX_WIDTH;
  tempx -= (XTextWidth(font10M,string,strlen(string)) / width_pixel_point);
  tempx -= 3;
  tempx = pixelx(tempx);
  tempy = pixely(BOXY + 2);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,string,strlen(string));
  }

#if defined(PROTOTYPES)
static void MITZVAH(int format,char *name,char *type)
#else
static void MITZVAH(format,name,type) int format;char *name;char *type;
#endif
  {
  char string[40];
  int tempx,tempy;

  DO_FONT(font12B);
  if (format == 1)
    sprintf(string,"%s Mitzvah of %s",type,name);
  else
    sprintf(string,"%s %s Mitzvah",name,type);
  tempx = XTextWidth(font12B,string,strlen(string)) / width_pixel_point;
  tempx /= 2;
  tempx = BOXX - tempx;
  tempx = pixelx(tempx);
  tempy = pixely(BOXY + BOX_HEIGHT - 14 - MDAY_SIZE);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,string,strlen(string));
  }

#if defined(PROTOTYPES)
static void SHABBAT(char *name,char *torah,char *prophet)
#else
static void SHABBAT(name,torah,prophet) char *name;char *torah;char *prophet;
#endif
  {
  int tempx,tempy;

  tempx = pixelx(BOXX + 3);
  DO_FONT(font10M);
  tempy = pixely(BOXY + 18 + 15);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,name,strlen(name));
  DO_FONT(font8M);
  if (torah)
    {
    tempy = pixely(BOXY + 10 + 15);
    XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,torah,strlen(torah));
    }
  if (prophet)
    {
    tempy = pixely(BOXY + 2 + 15);
    XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,
	prophet,strlen(prophet));
    }
  }

#if defined(PROTOTYPES)
static void BOLD_ITEM(int place,char *string)
#else
static void BOLD_ITEM(place,string) int place;char *string;
#endif
  {
  int tempx,tempy;

  DO_FONT(font10B);
  tempx = pixelx(BOXX + 3);
  tempy = pixely(BOXY + BOX_HEIGHT - MDAY_SIZE - ((place - 1) * 11) - 14);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,string,strlen(string));
  }

#if defined(PROTOTYPES)
static void ITEM(int place,char *string)
#else
static void ITEM(place,string) int place;char *string;
#endif
  {
  int tempx,tempy;

  DO_FONT(font10M);
  tempx = pixelx(BOXX + 3);
  tempy = pixely(BOXY + BOX_HEIGHT - MDAY_SIZE - ((place - 1) * 11) - 14);
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,string,strlen(string));
  }

#if defined(PROTOTYPES)
static void CANDLES(char *time)
#else
static void CANDLES(time) char *time;
#endif
  {
  XPoint pl[10]; int p; float x,y;
  int tempx,tempy;
  
  XSetLineAttributes(cur_display,cal_gc,1,LineSolid,CapButt,JoinMiter);
  DO_FONT(font8M);
  tempx = BOXX + BOX_WIDTH - 15;
  if (MDAY_SIZE == 14)
    tempx -= XTextWidth(font14M,"99",2) / width_pixel_point;
  else
    tempx -= XTextWidth(font24M,"99",2) / width_pixel_point;
  tempx = pixelx(tempx);
  tempy = pixely(BOXY + BOX_HEIGHT - 20);

  XDrawRectangle(cur_display,xcal_window,cal_gc,tempx,tempy - 10,4,10);

  p = 0;
  x = tempx;y = tempy - 13;pl[p].x = x;pl[p].y = y;p++;
  x += 2;   y -= 5;        pl[p].x = x;pl[p].y = y;p++;
  x += 2;   y += 5;        pl[p].x = x;pl[p].y = y;p++;
  XFillPolygon(cur_display,xcal_window,cal_gc,pl,p,Convex,CoordModeOrigin);

  XDrawRectangle(cur_display,xcal_window,cal_gc,tempx + 6,tempy - 10,4,10);

  p = 0;
  x = tempx + 6;y = tempy - 13;pl[p].x = x;pl[p].y = y;p++;
  x += 2;       y -= 5;        pl[p].x = x;pl[p].y = y;p++;
  x += 2;       y += 5;        pl[p].x = x;pl[p].y = y;p++;
  XFillPolygon(cur_display,xcal_window,cal_gc,pl,p,Convex,CoordModeOrigin);

  tempx -= 2;
  tempx -= XTextWidth(font8M,time,strlen(time));
  tempy -= 3;
  XDrawString(cur_display,xcal_window,cal_gc,tempx,tempy,time,strlen(time));
  XSetLineAttributes(cur_display,cal_gc,2,LineSolid,CapButt,JoinMiter);
  }

#if defined(PROTOTYPES)
static void HAVDALAH(char * time)
#else
static void HAVDALAH(time) char * time;
#endif
  {
  XPoint pl[10]; int p,x,y;
  int tempx,tempy,tempx1;
  
  XSetLineAttributes(cur_display,cal_gc,1,LineSolid,CapButt,JoinMiter);
  DO_FONT(font8M);
  tempx = BOXX + BOX_WIDTH - 15;
  if (MDAY_SIZE == 14)
    tempx -= XTextWidth(font14M,"99",2) / width_pixel_point;
  else
    tempx -= XTextWidth(font24M,"99",2) / width_pixel_point;
  tempx = pixelx(tempx);
  tempy = pixely(BOXY + BOX_HEIGHT - 20);

  tempx1 = tempx - 2;
  tempx1 -= XTextWidth(font8M,time,strlen(time));
  XDrawString(cur_display,xcal_window,cal_gc,tempx1,tempy + 3,time,strlen(time));
  p = 0;
  x = tempx;    y = tempy;     pl[p].x = x;pl[p].y = y;p++;
  x += 2;       y -= 0;        pl[p].x = x;pl[p].y = y;p++;
  x += 0;       y -= 2;        pl[p].x = x;pl[p].y = y;p++;
  x += 8;       y -= 4;        pl[p].x = x;pl[p].y = y;p++;
  x += 0;       y -= 3;        pl[p].x = x;pl[p].y = y;p++;
  x += -2;      y -= 0;        pl[p].x = x;pl[p].y = y;p++;
  x += 0;       y -= -2;       pl[p].x = x;pl[p].y = y;p++;
  x += -8;      y -= -4;       pl[p].x = x;pl[p].y = y;p++;
  XDrawLines(cur_display,xcal_window,cal_gc,pl,p,CoordModeOrigin);
  p = 0;
  x = tempx + 4;y = tempy;     pl[p].x = x;pl[p].y = y;p++;
  x += 2;       y -= 0;        pl[p].x = x;pl[p].y = y;p++;
  x += 0;       y -= 1;        pl[p].x = x;pl[p].y = y;p++;
  x += -1;      y -= 2;        pl[p].x = x;pl[p].y = y;p++;
  x += -2;      y -= -1;       pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= -1;       pl[p].x = x;pl[p].y = y;p++;
  XDrawLines(cur_display,xcal_window,cal_gc,pl,p,CoordModeOrigin);
  p = 0;
  x = tempx + 6;y = tempy - 9; pl[p].x = x;pl[p].y = y;p++;
  x += -2;      y -= 0;        pl[p].x = x;pl[p].y = y;p++;
  x += 0;       y -= -1;       pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= -2;       pl[p].x = x;pl[p].y = y;p++;
  x += 2;       y -= 1;        pl[p].x = x;pl[p].y = y;p++;
  x += -1;      y -= 1;        pl[p].x = x;pl[p].y = y;p++;
  XDrawLines(cur_display,xcal_window,cal_gc,pl,p,CoordModeOrigin);
  p = 0;
  x = tempx + 8;y = tempy;     pl[p].x = x;pl[p].y = y;p++;
  x += 2;       y -= 0;        pl[p].x = x;pl[p].y = y;p++;
  x += 0;       y -= 1;        pl[p].x = x;pl[p].y = y;p++;
  x += -2;      y -= 3;        pl[p].x = x;pl[p].y = y;p++;
  x += -1;      y -= -1;       pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= -2;       pl[p].x = x;pl[p].y = y;p++;
  XDrawLines(cur_display,xcal_window,cal_gc,pl,p,CoordModeOrigin);
  p = 0;
  x = tempx + 2;y = tempy - 9; pl[p].x = x;pl[p].y = y;p++;
  x += -2;      y -= 0;        pl[p].x = x;pl[p].y = y;p++;
  x += 0;       y -= -1;       pl[p].x = x;pl[p].y = y;p++;
  x += 2;       y -= -3;       pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= 1;        pl[p].x = x;pl[p].y = y;p++;
  x += -1;      y -= 2;        pl[p].x = x;pl[p].y = y;p++;
  XDrawLines(cur_display,xcal_window,cal_gc,pl,p,CoordModeOrigin);
  p = 0;
  x = tempx;    y = tempy - 11;pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= 5;        pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= -5;       pl[p].x = x;pl[p].y = y;p++;
  XFillPolygon(cur_display,xcal_window,cal_gc,pl,p,Convex,CoordModeOrigin);
  p = 0;
  x = tempx + 4;y = tempy - 11;pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= 5;        pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= -5;       pl[p].x = x;pl[p].y = y;p++;
  XFillPolygon(cur_display,xcal_window,cal_gc,pl,p,Convex,CoordModeOrigin);
  p = 0;
  x = tempx + 8;y = tempy - 11;pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= 5;        pl[p].x = x;pl[p].y = y;p++;
  x += 1;       y -= -5;       pl[p].x = x;pl[p].y = y;p++;
  XFillPolygon(cur_display,xcal_window,cal_gc,pl,p,Convex,CoordModeOrigin);
  XSetLineAttributes(cur_display,cal_gc,2,LineSolid,CapButt,JoinMiter);
  }

#if defined(PROTOTYPES)
static void OMER(int count)
#else
static void OMER(count) int count;
#endif
  {
  int tempx,tempy;
  char string[10];
  
  XSetLineAttributes(cur_display,cal_gc,1,LineSolid,CapButt,JoinMiter);
  DO_FONT(font8M);
  tempx = BOXX;
  tempx += XTextWidth(font8M,"10:00",2);
  tempx += 18;
  tempx = pixelx(tempx);
  tempy = pixely(BOXY + BOX_HEIGHT - 10);

  sprintf(string,"%d",count);

  DO_FONT(font8B);
  XDrawString(cur_display,xcal_window,cal_gc,tempx + 4,tempy + 13,string,strlen(string));
#define arc_stroke(fx,fy,tx,ty,up) XDrawArc(cur_display,xcal_window,cal_gc,fx,fy,tx,ty,up*64,180*64)
	arc_stroke(tempx - 1,tempy - 4,2,2,0);
	arc_stroke(tempx - 1,tempy - 1,2,2,0);
	arc_stroke(tempx - 1,tempy + 2,2,2,0);
	arc_stroke(tempx - 1,tempy + 5,2,2,0);
	arc_stroke(tempx - 1,tempy - 3,2,2,180);
	arc_stroke(tempx - 1,tempy + 0,2,2,180);
	arc_stroke(tempx - 1,tempy + 3,2,2,180);
	arc_stroke(tempx - 1,tempy + 6,2,2,180);
	arc_stroke(tempx - 3,tempy - 3,2,2,0);
	arc_stroke(tempx - 3,tempy + 0,2,2,0);
	arc_stroke(tempx - 3,tempy + 3,2,2,0);
	arc_stroke(tempx - 3,tempy - 2,2,2,180);
	arc_stroke(tempx - 3,tempy + 1,2,2,180);
	arc_stroke(tempx - 3,tempy + 4,2,2,180);
#define stroke(fx,fy,tx,ty) XDrawLine(cur_display,xcal_window,cal_gc,tempx+(fx),tempy-(fy),tempx+(fx)+(tx),tempy-(ty)-(fy));
	stroke(-1,-14, 0,21);
	stroke( 1,  2, 0, 1);
	stroke( 1, -1, 0, 1);
	stroke( 1, -4, 0, 1);
	stroke( 1, -7, 0, 1);
	stroke( 1,  2, 3, 3);
	stroke( 1, -1, 3, 3);
	stroke( 1, -4, 3, 3);
	stroke( 1, -7, 3, 3);
	stroke(-3,  1, 0, 1);
	stroke(-3, -2, 0, 1);
	stroke(-3, -5, 0, 1);
	stroke(-3,  1,-3, 3);
	stroke(-3, -2,-3, 3);
	stroke(-3, -5,-3, 3);
  }

#if defined(PROTOTYPES)
static void CHANUKAH(int count)
#else
static void CHANUKAH(count) int count;
#endif
  {
  int loop,tempx,tempy;
  
  XSetLineAttributes(cur_display,cal_gc,1,LineSolid,CapButt,JoinMiter);
  tempx = BOXX;
  tempx += XTextWidth(font8M,"10:00",2);
  tempx += 18;
  tempx = pixelx(tempx);
  tempy = pixely(BOXY + BOX_HEIGHT - 10);

  stroke(0,2, 0,-16);
  arc_stroke(tempx - 2,tempy - 2, 4, 4,180);
  arc_stroke(tempx - 4,tempy - 4, 8, 8,180);
  arc_stroke(tempx - 6,tempy - 6,12,12,180);
  arc_stroke(tempx - 8,tempy - 8,16,16,180);
  CHANUKAH_FLAME(tempx,tempy - 4);
  for (loop = 0;loop < count;loop++)
    {
    if (loop > 3)
      CHANUKAH_FLAME(tempx + 6 - (loop * 2),tempy-2);
    else
      CHANUKAH_FLAME(tempx + 8 - (loop * 2),tempy-2);
    }
  }

#if defined(PROTOTYPES)
static void CHANUKAH_FLAME(int x,int y)
#else
static void CHANUKAH_FLAME(x,y) int x;int y;
#endif
  {
  XPoint pl[3];

  pl[0].x = x - 1;pl[0].y = y + 0;
  pl[1].x = x + 0;pl[1].y = y - 2;
  pl[2].x = x + 1;pl[2].y = y + 0;
  XFillPolygon(cur_display,xcal_window,cal_gc,pl,3,Convex,CoordModeOrigin);
  }
