static char version[] =
"hcal version 1.0 - postscript hebrew calendar generator\n\n\
copyright 1994,1995 - Steven Weintraub";

/*
 
    hcal version 1.0 - postscript hebrew calendar generator
    copyright 1994,1995 - Steven Weintraub
 
    This program is created and distribed by Steven Weintraub. It
    can be freely distributed without permission as long as this
    head is retained in all files it appears and the LICENCE file
    accompanies it.
 
*/

#include "cur.h"

#if defined(PROTOTYPES)
extern int cur_alist_ask(char *title,cur_alist_t *list,int current,
    char *active_string,int action(int,int,void *),char *print(int,void *,char *))
#else
extern int cur_alist_ask(title,list,current,active_string,action,print) 
char *title;cur_alist_t *list;int current; char *active_string;int (*action)();char *(* print)();
#endif
  {
  cur_wlist_t		*cptr_scroller;
  cur_wlist_t		*cptr_qparent;
  cur_wlist_t		*cptr_qwin;
  cur_wlist_t		*cptr_last;
  cur_wlist_t		*cptr_current;
  cur_wlist_t		*cptr_first;
  cur_wlist_t		*orig_safe;
  int			 init_items;
  int		 	 have_safe;
  int			 min_items;
  int			 items;
  int			 loop;
  int			 value;
  int			 max_width;
  int			 width;
  int			 swidth;
  int			 width_all;
  Window		 window;
  cur_alist_t 		*lptr;
  XClassHint		 class_hints;
  XTextProperty		 tx_icon_name;
  XTextProperty		 tx_window_name;
  XSizeHints		 size_hints;
  XWMHints		 wm_hints;
  int			 incr;
  int			 p_count_start;
  char			 string[128];

  incr = (cur_button_height - CUR_BUTTON_PAD - (2 * CUR_BUTTON_BORDER));
  max_width = 0;
  for (lptr=list,items = 0;lptr;items++,lptr = lptr->next)
    {
    print(lptr->type,lptr->data,string);
    width = XTextWidth(cur_font,string,strlen(string));
    if (width > max_width)
      max_width = width;
    }

  init_items = (14 > items ? items : 14);
  min_items = (3 > items ? items + 1: 4);
  if (cur_width_80 + 20 < max_width)
    width_all = cur_width_80 + 20;
  else
    width_all = max_width + CUR_BUTTON_MARGIN + 4;

  orig_safe = cur_cptr_safe;
  if (cur_cptr_safe && cur_cptr_safe != (cur_wlist_t *)-1)
    {
    cptr_scroller = cur_cptr_safe;
    cptr_qparent = cptr_scroller->data.scroller.child;
    cptr_qparent->width = max_width + CUR_BUTTON_MARGIN + 2;
    cptr_qparent->height = ((items - 1) * incr) + cur_button_height + 2;
    XResizeWindow(cur_display,cptr_qparent->window,cptr_qparent->width,
	cptr_qparent->height);
    cptr_scroller->data.scroller.child_width = cptr_qparent->width;
    cptr_scroller->data.scroller.child_height = cptr_qparent->height;
    }
  else
    {
    cptr_scroller = cur_mk_scroller(&cur_root_wlist,0,0,width_all + 2,
	  (init_items - 1) * incr + cur_button_height + 16,width_all / 80,
	  CUR_BUTTON_HEIGHT,width_all,((items - 1) * incr) + cur_button_height);

    if (XStringListToTextProperty(&title, 1, &tx_icon_name) == 0)
      {
      cur_error("Can not alloc string property icon_name");
      exit(1);
      }
    if (XStringListToTextProperty(&title, 1, &tx_window_name) == 0)
      {
      cur_error("Can not alloc string property window_name");
      exit(1);
      }

    size_hints.flags = PPosition | PSize | PMinSize | PResizeInc;
    size_hints.min_width = width_all /10;
    size_hints.width_inc = 1;
    size_hints.height_inc = incr;
    size_hints.min_height = incr * 3 + 2 * CUR_BUTTON_PAD + 4;
  
    wm_hints.initial_state = NormalState;
    wm_hints.input = True;
    wm_hints.flags = StateHint | InputHint;

    class_hints.res_name = cur_argv[0];
    class_hints.res_class = "message";

    XSetWMProperties(cur_display, cptr_scroller->window, &tx_window_name, 
        &tx_icon_name, cur_argv, cur_argc, &size_hints, &wm_hints, &class_hints);

    window = XCreateSimpleWindow(cur_display,cptr_scroller->window,0,0,
        max_width + CUR_BUTTON_MARGIN,((items - 1) * incr) + cur_button_height,
        0,cur_foreground_color,cur_background_color);

    XMapWindow(cur_display,window);

    enlist(cptr_qparent,window,CUR_WLIST_MLISTS,((items - 1) * incr) + cur_button_height + 2,max_width + CUR_BUTTON_MARGIN + 2)
    }
  if (cur_cptr_safe)
    {
    have_safe = YES;
    orig_safe = cptr_scroller;
    }
  else
    have_safe = NO;
  cur_cptr_safe = NULL;

  cptr_qwin = NULL;
  for (cptr_last = NULL,cptr_first = NULL,cptr_current = NULL,
       loop = 0,
       lptr = list;
       lptr;
       lptr = lptr->next,
       loop++)
    {
    cptr_qwin = cur_mk_button(cptr_qparent,
	cur_mk_str(print(lptr->type,lptr->data,string)),
	0,loop * incr,max_width,NorthWestGravity,loop,
	action,(void *)' ',(void *)lptr->type,lptr->data,active_string);
    if (loop == current - 1)
      cptr_current = cptr_qwin;
    cptr_qwin->data.button.up = cptr_last;
    cptr_qwin->data.button.down = NULL;
    if (cptr_last)
      cptr_last->data.button.down = cptr_qwin;
    if (!cptr_first)
      cptr_first = cptr_qwin;
    cptr_last = cptr_qwin;
    }

  if (!cptr_current)
    cptr_current = cptr_first;
  cptr_first->data.button.alt_last = cptr_last;
  cptr_last->data.button.alt_next = cptr_first;
  cptr_scroller->data.scroller.child = cptr_qparent;
  cptr_scroller->data.scroller.child_width = cptr_qparent->width;
  cptr_scroller->data.scroller.child_height = cptr_qparent->height;
  cptr_qparent->data.mlists.first = cptr_qwin;
  cur_warp(cptr_current);
  p_count_start = cur_process_count;
  do
    {
    cur_process_count = p_count_start;
    value = cur_process_events();
    if (cur_routine_value == CUR_ALIST_REDRAW)
      {
      for (cptr_qwin = cptr_first,cptr_last = cptr_qwin ? cptr_qwin->data.button.down : NULL;
          cptr_qwin;
          cptr_qwin = cptr_last,cptr_last = cptr_qwin ? cptr_qwin->data.button.down : NULL)
	{
	print((int)cptr_qwin->data.button.parameter2,
	    (void *)cptr_qwin->data.button.parameter3,string);
	if (strcmp(string,cptr_qwin->data.button.name) != 0)
	  {
	  swidth = strlen(string);
	  if (swidth <= cptr_qwin->data.button.length)
	    strcpy(cptr_qwin->data.button.name,string);
	  else
	    {
	    free(cptr_qwin->data.button.name);
	    cptr_qwin->data.button.name = cur_mk_str(string);
	    }
	  cptr_qwin->data.button.length = swidth;
	  XClearWindow(cur_display,cptr_qwin->window);
          XDrawRectangle(cur_display,cptr_qwin->window,cur_gc,2,2,
              cptr_qwin->width - CUR_BUTTON_INNER,
	      cptr_qwin->height - CUR_BUTTON_INNER);
          swidth = XTextWidth(cur_font,cptr_qwin->data.button.name,
			cptr_qwin->data.button.length);
          XDrawString(cur_display,cptr_qwin->window,cur_gc,
	      (cptr_qwin->width - swidth) / 2,cur_font_height +CUR_BUTTON_INNER,
	      cptr_qwin->data.button.name,cptr_qwin->data.button.length);
	  }
	}
      }
    }
  while (cur_routine_value != CUR_ALIST_END);

  for (cptr_qwin = cptr_first,cptr_last = cptr_qwin ? cptr_qwin->data.button.down : NULL;
      cptr_qwin;
      cptr_qwin = cptr_last,cptr_last = cptr_qwin ? cptr_qwin->data.button.down : NULL)
    {
    free(cptr_qwin->data.button.name);
    cur_rm_button(cptr_qwin);
    }
  if (!have_safe)
    {
    delist(cptr_qparent);
    cur_rm_scroller(cptr_scroller);
    }

  cur_cptr_safe = orig_safe;
  return value + 1;
  }

#if defined(PROTOTYPES)
extern void cur_alist_back(cur_wlist_t *window)
#else
extern void cur_alist_back(window) cur_wlist_t *window;
#endif
  {
  delist(window->data.scroller.child);
  cur_rm_scroller(window);
  }

#if defined(PROTOTYPES)
extern cur_wlist_t *cur_alist_front(char *title,int items,int width,int max_width)
#else
extern cur_wlist_t *cur_alist_front(title,items,width,max_width) 
char *title;int items;int width;int max_width;
#endif
  {
  cur_wlist_t		*cptr_scroller;
  cur_wlist_t		*cptr_qparent;
  int			 init_items;
  int			 min_items;
  Window		 window;
  XClassHint		 class_hints;
  XTextProperty		 tx_icon_name;
  XTextProperty		 tx_window_name;
  XSizeHints		 size_hints;
  XWMHints		 wm_hints;
  int			 incr;

  incr = (cur_button_height - CUR_BUTTON_PAD - (2 * CUR_BUTTON_BORDER));
  init_items = (14 > items ? items : 14);
  min_items = (3 > items ? items + 1: 4);

  cptr_scroller = cur_mk_scroller(&cur_root_wlist,0,0,width + 2,
	(init_items - 1) * incr + cur_button_height + 16,width / 80,
	CUR_BUTTON_HEIGHT,width,((items - 1) * incr) + cur_button_height);

  if (XStringListToTextProperty(&title, 1, &tx_icon_name) == 0)
    {
    cur_error("Can not alloc string property icon_name");
    exit(1);
    }
  if (XStringListToTextProperty(&title, 1, &tx_window_name) == 0)
    {
    cur_error("Can not alloc string property window_name");
    exit(1);
    }

  size_hints.flags = PPosition | PSize | PMinSize | PResizeInc;
  size_hints.min_width = width /10;
  size_hints.width_inc = 1;
  size_hints.height_inc = incr;
  size_hints.min_height = incr * 3 + 2 * CUR_BUTTON_PAD + 4;
  
  wm_hints.initial_state = NormalState;
  wm_hints.input = True;
  wm_hints.flags = StateHint | InputHint;

  class_hints.res_name = cur_argv[0];
  class_hints.res_class = "message";

  XSetWMProperties(cur_display, cptr_scroller->window, &tx_window_name, 
      &tx_icon_name, cur_argv, cur_argc, &size_hints, &wm_hints, &class_hints);

  window = XCreateSimpleWindow(cur_display,cptr_scroller->window,0,0,
      max_width + CUR_BUTTON_MARGIN,((items - 1) * incr) + cur_button_height,
      0,cur_foreground_color,cur_background_color);

  XMapWindow(cur_display,window);

  enlist(cptr_qparent,window,CUR_WLIST_MLISTS,((items - 1) * incr) + cur_button_height + 2,max_width + CUR_BUTTON_MARGIN + 2)

  cptr_scroller->data.scroller.child = cptr_qparent;
  cptr_scroller->data.scroller.child_width = cptr_qparent->width;
  cptr_scroller->data.scroller.child_height = cptr_qparent->height;
  return cptr_scroller;
  }

#if defined(PROTOTYPES)
static int cur_number_verify(cur_mlist_t *mptr)
#else
static int cur_number_verify(mptr) cur_mlist_t *mptr;
#endif
  {
  char message[128];

  if (mptr->i_answer < mptr->i_lower || mptr->i_answer > mptr->i_upper)
    {
    sprintf(message,"Value must be between %d and %d",mptr->i_lower,mptr->i_upper);
    cur_msg_win(message);
    return 0;
    }
  return 1;
  }

#if defined(PROTOTYPES)
int cur_ask_num_lud(char *question,char *short_answer,int lower,int upper,
    int default_v)
#else
int cur_ask_num_lud(question,short_answer,lower,upper,default_v)
char *question;char *short_answer;int lower;int upper;int default_v;
#endif
  {
  cur_mlist_t item;

  item.name = question;
  item.type = CUR_MENU_INT;
  item.type_special = 0;
  item.s_answer = cur_mk_str("1111111111");
  sprintf(item.s_answer,"%d",default_v);
  item.s_answer_size = 10;
  item.i_answer = default_v;
  item.i_lower = lower;
  item.i_upper = upper;
  item.l_answer = NULL;
  item.default_value.i = default_v;
  item.have_default = YES;
  item.enterable = YES;
  item.must_have = YES;
  item.edited= NO;
  item.list = NULL;
  item.next = NULL;
  item.last = NULL;

  cur_menu_ask_true("String Question",&item,NULL,NO);

  return item.i_answer;
  }

#if defined(PROTOTYPES)
int cur_ask_y_n(char *string,char *dummy)
#else
int cur_ask_y_n(string,dummy) char *string;char *dummy;
#endif
  {
  XClassHint		 class_hints;
  cur_wlist_t		*cptr;
  cur_wlist_t		*cptr_no;
  cur_wlist_t		*cptr_yes;
  XTextProperty		 icon_name;
  char			*name_string;
  XSizeHints		 size_hints;
  int			 value;
  int			 width_all;
  int			 width_string;
  Window		 window;
  XTextProperty		 window_name;
  XWMHints		 wm_hints;

  width_string = XTextWidth(cur_font,string,strlen(string));
  if ((width_string + 12) > (2 * cur_button_width))
    width_all = width_string + 12;
  else
    width_all = 2 * cur_button_width;

  window = XCreateSimpleWindow(cur_display,cur_root_window,0,0,
      width_all + 200,cur_font_height + cur_button_height,4,
      cur_foreground_color,cur_background_color);

  name_string = "Question";
  if (XStringListToTextProperty(&name_string, 1, &icon_name) == 0)
    {
    cur_error("Can not alloc string property icon_name");
    exit(1);
    }
  name_string = "Yes or No Question";
  if (XStringListToTextProperty(&name_string, 1, &window_name) == 0)
    {
    cur_error("Can not alloc string property window_name");
    exit(1);
    }

  size_hints.flags = PPosition | PSize | PMinSize;
  size_hints.min_width = width_all;
  size_hints.min_height = cur_font_height + cur_button_height;
  
  wm_hints.initial_state = NormalState;
  wm_hints.input = True;
  wm_hints.flags = StateHint | InputHint;

  class_hints.res_name = cur_argv[0];
  class_hints.res_class = "message";

  XSetWMProperties(cur_display, window, &window_name, &icon_name, 
    cur_argv, cur_argc, &size_hints, &wm_hints, &class_hints);

  XSelectInput(cur_display, window, ExposureMask | StructureNotifyMask);

  XMapWindow(cur_display,window);

  enlist(cptr,window,CUR_WLIST_MESSAGE,cur_font_height + cur_button_height,width_all + 200);
  cptr->data.message.string = string;
  cptr->data.message.width = width_string;

  cptr_yes = cur_mk_button(cptr,"Yes",0,-cptr->height,0,SouthWestGravity,
      1,NULL,NULL,NULL,NULL,NULL);
  cptr_no = cur_mk_button(cptr,"No",-cptr->width,-cptr->height,0,
      SouthEastGravity,0,NULL,NULL,NULL,NULL,NULL);

  cptr_yes->data.button.up   = cptr_no;
  cptr_yes->data.button.down = cptr_no;
  cptr_no->data.button.up    = cptr_yes;
  cptr_no->data.button.down  = cptr_yes;
  cur_warp(cptr_yes);

  XBell(cur_display,100);
  value = cur_process_events();

  cur_rm_button(cptr_yes);
  cur_rm_button(cptr_no);

  delist(cptr);

  return value;
  }

#if defined(PROTOTYPES)
void cur_bump_slider(cur_wlist_t *slider,int direction)
#else
void cur_bump_slider(slider,direction) cur_wlist_t *slider;int direction;
#endif
  {
  int lmove;
  int place;
  Window scrolled_window;
  int hplace;
  int vplace;
  cur_wlist_t *parent;
  cur_wlist_t *hslider;
  cur_wlist_t *vslider;

  parent = slider->data.slider.parent;
  vslider = parent->data.scroller.vslider;
  hslider = parent->data.scroller.hslider;

  lmove = slider->data.slider.incr * direction;
  place = slider->data.slider.place + lmove - slider->data.slider.base;
  place /= slider->data.slider.incr;
  place *= slider->data.slider.incr;
  place += slider->data.slider.base;

  if (place < 0 || 
      (slider->data.slider.vertical && 
	  place + parent->height > slider->data.slider.size) ||
      (!slider->data.slider.vertical && 
	  place + parent->width > slider->data.slider.size))
    {
    XBell(cur_display,100);
    return;
    }

  slider->data.slider.place = place;
  scrolled_window = parent->data.scroller.child->window;
  if (hslider)
    hplace = -hslider->data.slider.place;
  else
    hplace = 0;
  if (vslider)
    vplace = -vslider->data.slider.place;
  else
    vplace = 0;

  XMoveWindow(cur_display,scrolled_window,hplace,vplace);
  if (slider->data.slider.vertical)
    cur_draw_vslider(slider);
  else
    cur_draw_hslider(slider);
  }

#if defined(PROTOTYPES)
void cur_draw_hslider(cur_wlist_t *cptr)
#else
void cur_draw_hslider(cptr) cur_wlist_t *cptr;
#endif
  { 
  int eplace;
  int place;
  int size;

  size = cptr->width - (2 * CUR_SLIDER_WIDTH);
  place = size * cptr->data.slider.place / cptr->data.slider.size;
  eplace = size * (cptr->data.slider.place + cptr->width) / cptr->data.slider.size;

  XClearArea(cur_display,cptr->window,0,0,place + CUR_SLIDER_WIDTH,0,NO);
  XClearArea(cur_display,cptr->window,eplace + CUR_SLIDER_WIDTH,0,0,0,0);
  XFillRectangle(cur_display,cptr->window,cur_gc,place + CUR_SLIDER_WIDTH - 1,0,
      eplace - place,CUR_SLIDER_WIDTH);
  }

#if defined(PROTOTYPES)
void cur_draw_vslider(cur_wlist_t *cptr)
#else
void cur_draw_vslider(cptr) cur_wlist_t *cptr;
#endif
  { 
  int eplace;
  int place;
  int size;

  size = cptr->height - (2 * CUR_SLIDER_WIDTH);
  place = size * cptr->data.slider.place / cptr->data.slider.size;
  eplace = size * (cptr->data.slider.place + cptr->height) / cptr->data.slider.size;

  XClearArea(cur_display,cptr->window,0,0,0,place + CUR_SLIDER_WIDTH,NO);
  XClearArea(cur_display,cptr->window,0,eplace + CUR_SLIDER_WIDTH,0,0,0);
  XFillRectangle(cur_display,cptr->window,cur_gc,0,place + CUR_SLIDER_WIDTH - 1,
      CUR_SLIDER_WIDTH,eplace - place);
  }

int 		 cur_argc;
char 		**cur_argv;
unsigned long	 cur_background_color;
char		*cur_background_color_name = NULL;
Window		 cur_base_window;
int		 cur_button_height;
int		 cur_button_width;
cur_wlist_t	*cur_cptr_safe;
Display		*cur_display;
char		*cur_display_name = NULL;
unsigned long	 cur_display_height;
unsigned long	 cur_display_width;
int		 cur_display_number;
int		 cur_do_warp = YES;
unsigned long	 cur_foreground_color;
char		*cur_foreground_color_name = NULL;
XFontStruct	*cur_font;
int		 cur_font_height;
int		 cur_font_decent;
char 		*cur_font_name = NULL;
GC		 cur_gc;
Window		 cur_root_window;
cur_wlist_t	 cur_root_wlist;
int		 cur_routine_value;
int		 cur_process_count = 0;
int		 cur_process_max = 0;
int		 cur_started = NO;
int		 cur_width_80;
cur_wlist_t 	*cur_win_list = NULL;

#if defined(PROTOTYPES)
unsigned long cur_get_color(char *parameter,char *resource,char *fallback,
    char *monochrome,unsigned long bit)
#else
unsigned long cur_get_color(parameter,resource,fallback,monochrome,bit)
char *parameter;char *resource;char *fallback;
    char *monochrome;unsigned long bit;
#endif
  {
  XColor cell1,cell2;
  int have_pixel;
  unsigned long pixel;
  char *color_name;
  char message[200];

  have_pixel = NO;
  if (parameter)
    {
    if (!XAllocNamedColor(cur_display,
       DefaultColormap(cur_display,cur_display_number),parameter,&cell1,&cell2))
      {
      sprintf(message,"Could not allocate parameter color '%s', using fallback",
	parameter);
      cur_error(message);
      }
    else
      {
      have_pixel = YES;
      pixel = cell1.pixel;
      }
    }
  if (!have_pixel && resource)
    {
    if (color_name = XGetDefault(cur_display,"cur",resource))
      {
      if (!XAllocNamedColor(cur_display,
          DefaultColormap(cur_display,cur_display_number),color_name,&cell1,
	  &cell2))
        {
        sprintf(message,
	    "Could not allocate resource color '%s', using fallback '%s'",
	    color_name,fallback);
        cur_error(message);
        }
      else
        {
        have_pixel = YES;
        pixel = cell1.pixel;
        }
      }
    }
  if (!have_pixel)
    {
    if (!XAllocNamedColor(cur_display,
	DefaultColormap(cur_display,cur_display_number),fallback,&cell1,&cell2))
      {
      sprintf(message,
	  "Could not allocate default color '%s', using monochrome '%s'",
	  fallback,monochrome);
      cur_error(message);
      }
    else
      {
      have_pixel = YES;
      pixel = cell1.pixel;
      }
    }
  if (!have_pixel)
    pixel = bit;
  return pixel;
  }

#if defined(PROTOTYPES)
int cur_menu_ask(char *title,cur_mlist_t *menu,int verify(cur_mlist_t *))
#else
int cur_menu_ask(title,menu,verify)
char *title;cur_mlist_t *menu;int (*verify)();
#endif
  {
  return cur_menu_ask_true(title,menu,verify,YES);
  }

static char *text[] = {
"                     Menu Direction Help",
"",
"You can enter data in the field by moving your cursor over that",
"field and typing.  Backspace does work.  The data is entered",
"starting at the prompt mark.  This prompt can be moved by using",
"the left and right arrow keys.",
"",
"Typing return automatically moves the cursor to the next window.",
"",
"The up and down arrow keys work similarly.",
"",
"The buttons on the bottom of the window can be pressed by moving",
"the mouse to the button and pressing the mouse button or typing",
"return.",
"",
"In a list item, typing tab will bring up a list of items.",
"Control X will clear an item.",
"Control Z will restore the default (if any).",
NULL };


#if defined(PROTOTYPES)
int cur_menu_ask_true(char *title,cur_mlist_t *menu,int verify(cur_mlist_t *),
    int have_cancel)
#else
int cur_menu_ask_true(title,menu,verify,have_cancel)
char *title;cur_mlist_t *menu;int (*verify)(),have_cancel;
#endif
  {
  cur_wlist_t		*cptr_accept;
  cur_wlist_t		*cptr_cancel;
  cur_wlist_t		*cptr_help;
  cur_wlist_t		*cptr_holder;
  cur_wlist_t		*cptr_scroller;
  cur_wlist_t		*cptr_qparent;
  cur_wlist_t		*cptr_qwin;
  cur_wlist_t		*cptr_last;
  cur_wlist_t		*cptr_first;
  cur_wlist_t		*cptr_swin;
  int			 init_items;
  int			 min_items;
  int			 items;
  int			 loop;
  int			 value;
  int			 max_width;
  int			 width;
  int			 width_all;
  Window		 window;
  Window		 subwindow;
  cur_mlist_t 		*mptr;

  max_width = 3 * cur_button_width;
  for (mptr=menu,items = 0;mptr;items++,mptr = mptr->next)
    {
    width = XTextWidth(cur_font,mptr->name,strlen(mptr->name)) + (cur_width_80 / 2) + 23;
    if (width > max_width)
      max_width = width;
    }

  init_items = (10 > items ? items : 10);
  min_items = (3 > items ? items + 1: 4);
  if (cur_width_80 + 20 < max_width)
    width_all = cur_width_80 + 20;
  else
    width_all = max_width;

  cptr_holder = cur_mk_holder(title,"Menu",width_all,(init_items  + 1) * CUR_BUTTON_HEIGHT + 10,width_all / 80,CUR_BUTTON_HEIGHT,width_all / 8 + 20,CUR_BUTTON_HEIGHT * min_items + 10,NO);

  cptr_accept = cur_mk_button(cptr_holder,"Accept",-cptr_holder->width,-cptr_holder->height,0,SouthEastGravity,1,cur_mlist_verify_all,menu,verify,NULL,NULL);

  if (have_cancel)
    {
    cptr_cancel = cur_mk_button(cptr_holder,"Cancel",0,-cptr_holder->height,0,SouthWestGravity,0,NULL,NULL,NULL,NULL,NULL);
    cptr_help = cur_mk_button(cptr_holder,"Help",cur_button_width,-cptr_holder->height,0,SouthWestGravity,CUR_BUTTON_NORETURN,cur_text_dsp,text,NULL,NULL,NULL);
    }
  else
    {
    cptr_cancel = NULL;
    cptr_help = NULL;
    }

  cptr_scroller = cur_mk_scroller(cptr_holder,0,0,width_all,init_items * CUR_BUTTON_HEIGHT + 2,width_all / 80,CUR_BUTTON_HEIGHT,0,0);

  window = XCreateSimpleWindow(cur_display,cptr_scroller->window,0,0,
      width_all - 2,init_items * CUR_BUTTON_HEIGHT,
      0,cur_foreground_color,cur_background_color);

  XMapWindow(cur_display,window);

  enlist(cptr_qparent,window,CUR_WLIST_MLISTS,init_items * CUR_BUTTON_HEIGHT,width_all - 2)

  cptr_qwin = NULL;
  for (cptr_last = NULL, cptr_first = NULL,
       loop = 0,
       mptr = menu;
       mptr;
       mptr = mptr->next,
       loop++)
    {
    window = XCreateSimpleWindow(cur_display,cptr_qparent->window,
	0,loop * CUR_BUTTON_HEIGHT,max_width - 2,CUR_BUTTON_HEIGHT - 2,1,
        cur_foreground_color,cur_background_color);

    XSelectInput(cur_display, window, ExposureMask | KeyPressMask );
    XMapWindow(cur_display,window);

    subwindow = XCreateSimpleWindow(cur_display,window,
	max_width - 10 - (cur_width_80 / 2),
	(CUR_BUTTON_HEIGHT - cur_font_height - 4) / 2,
	cur_width_80 / 2,cur_font_height + 4,1,
        cur_foreground_color,cur_background_color);

    XSelectInput(cur_display, subwindow, ExposureMask | KeyPressMask | ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionHintMask );
    XMapWindow(cur_display,subwindow);

    enlist(cptr_qwin,window,CUR_WLIST_MLIST,CUR_BUTTON_HEIGHT,max_width - 2)
    enlist(cptr_swin,subwindow,CUR_WLIST_MLIST_DATA,cur_font_height + 2,cur_width_80 / 2)
    if (!cptr_first)
      cptr_first = cptr_qwin;
    cptr_qwin->data.mlist.item = mptr;
    cptr_qwin->data.mlist.child = cptr_swin;
    cptr_qwin->data.mlist.last = cptr_last;
    cptr_qwin->data.mlist.next = NULL;
    if (cptr_last)
      cptr_last->data.mlist.next = cptr_qwin;
    cptr_swin->data.mdata.item = mptr;
    cptr_swin->data.mdata.parent = cptr_qwin;
    cptr_swin->data.mdata.place = 0;
    cptr_swin->data.mdata.first_ch = 0;
    cptr_swin->data.mdata.last_ch = 0;
    cptr_last = cptr_qwin;
    }

  cptr_accept->data.button.alt_next = cptr_first->data.mlist.child;
  cptr_first->data.mlist.alt_last = cptr_accept;
  if (have_cancel)
    {
    cptr_last->data.mlist.alt_next = cptr_cancel;
    cptr_cancel->data.button.down = cptr_help;
    cptr_help->data.button.down = cptr_accept;
    cptr_accept->data.button.up = cptr_help;
    cptr_help->data.button.up = cptr_cancel;
    cptr_cancel->data.button.alt_last = cptr_last->data.mlist.child;
    }
  else
    {
    cptr_accept->data.button.up = cptr_last->data.mlist.child;
    cptr_last->data.mlist.alt_next = cptr_accept;
    }
   
  cptr_holder->data.holder.child = cptr_scroller;
  cptr_scroller->data.scroller.child = cptr_qparent;
  cptr_scroller->data.scroller.child_width = cptr_qparent->width;
  cptr_scroller->data.scroller.child_height = cptr_qparent->height;
  cptr_qparent->data.mlists.first = cptr_first;
  cur_warp(cptr_first->data.mlist.child);
  value = cur_process_events();

  for (cptr_qwin = cptr_first,cptr_last = cptr_qwin ? cptr_qwin->data.mlist.next : NULL ;
      cptr_qwin;
      cptr_qwin = cptr_last,cptr_last = cptr_qwin ? cptr_qwin->data.mlist.next : NULL )
    {
    delist(cptr_qwin->data.mlist.child);
    delist(cptr_qwin);
    }
  delist(cptr_qparent);
  cur_rm_button(cptr_accept);
  if (have_cancel)
    {
    cur_rm_button(cptr_cancel);
    cur_rm_button(cptr_help);
    }
  cur_rm_scroller(cptr_scroller);
  cur_rm_holder(cptr_holder);

  return value;
  }

#if defined(PROTOTYPES)
cur_wlist_t *cur_mk_button(cur_wlist_t *parent,char *button_name,int x,int y,
    int button_width,int gravity,unsigned long return_value,
    int routine(unsigned long),void *parameter1,void *parameter2,
    void *parameter3,char *active_string)
#else
cur_wlist_t *cur_mk_button(parent,button_name,x,y,
    button_width,gravity,return_value,
    routine,parameter1,parameter2,
    parameter3,active_string)
cur_wlist_t *parent;char *button_name;int x;int y;
    int button_width;int gravity;unsigned long return_value;
    int (*routine)();void *parameter1;void *parameter2;
    void *parameter3;char *active_string;
#endif
  {
  XSetWindowAttributes	 attrib;
  int			 button_length;
  cur_wlist_t		*cptr;
  Window		 window;

  button_length = strlen(button_name);
  if (!button_width)
    {
    button_width = XTextWidth(cur_font,button_name,button_length);
    if (button_width + CUR_BUTTON_MARGIN > cur_button_width)
      cur_button_width = button_width + CUR_BUTTON_MARGIN;
    }
  if (x >= 0)
    x += CUR_BUTTON_PAD;
  else
    x = -x - button_width - (CUR_BUTTON_MARGIN - CUR_BUTTON_PAD);
  if (y >= 0)
    y += CUR_BUTTON_PAD;
  else
    y = -y - cur_button_height + CUR_BUTTON_PAD;

  window = XCreateSimpleWindow(cur_display,parent->window,x,y,
      button_width + CUR_BUTTON_PAD * 2,cur_button_height - (2 * CUR_BUTTON_PAD + 2 * CUR_BUTTON_BORDER),CUR_BUTTON_BORDER,
      cur_foreground_color, cur_background_color);

  if (gravity)
    attrib.win_gravity = gravity;
  else
    attrib.win_gravity = SouthEastGravity;
  XChangeWindowAttributes(cur_display, window, CWWinGravity, &attrib);

  XSelectInput(cur_display, window, ExposureMask | KeyPressMask | ButtonPressMask);

  XMapWindow(cur_display,window);

  enlist(cptr,window,CUR_WLIST_BUTTON,cur_button_height - (2 * CUR_BUTTON_PAD + 2 * CUR_BUTTON_BORDER),button_width + (2 * CUR_BUTTON_PAD));
  cptr->data.button.width = button_width;
  cptr->data.button.name = button_name;
  cptr->data.button.length = button_length;
  cptr->data.button.width = button_width;
  cptr->data.button.return_value = return_value;
  cptr->data.button.routine = routine;
  cptr->data.button.parameter1 = parameter1;
  cptr->data.button.parameter2 = parameter2;
  cptr->data.button.parameter3 = parameter3;
  cptr->data.button.active_string = active_string;
  cptr->data.button.up = NULL;
  cptr->data.button.down = NULL;
  cptr->data.button.alt_next = NULL;
  cptr->data.button.alt_last = NULL;

  return cptr;
  }

#if defined(PROTOTYPES)
cur_wlist_t *cur_mk_holder(char *window_name,char *icon_name,
    int width,int height,int width_incr,int height_incr,
    int width_min,int height_min,int iconize)
#else
cur_wlist_t *cur_mk_holder(window_name,icon_name,width,height,width_incr,
    height_incr,width_min,height_min,iconize)
char *window_name;char *icon_name; int width;int height;int width_incr;
int height_incr; int width_min;int height_min;int iconize;
#endif
  {
  XClassHint		 class_hints;
  cur_wlist_t		*cptr;
  XTextProperty		 tx_icon_name;
  XTextProperty		 tx_window_name;
  XSizeHints		 size_hints;
  Window		 window;
  XWMHints		 wm_hints;

  window = XCreateSimpleWindow(cur_display,cur_root_window,0,0,
      width,height,4,cur_foreground_color,cur_background_color);

  if (XStringListToTextProperty(&icon_name, 1, &tx_icon_name) == 0)
    {
    cur_error("Can not alloc string property icon_name");
    exit(1);
    }
  if (XStringListToTextProperty(&window_name, 1, &tx_window_name) == 0)
    {
    cur_error("Can not alloc string property window_name");
    exit(1);
    }

  size_hints.flags = PPosition | PSize | PMinSize | PResizeInc;
  size_hints.min_width = width_min;
  size_hints.width_inc = 1;
  size_hints.height_inc = height_incr;
  size_hints.min_height = height_min;
  
  if (iconize)
	wm_hints.initial_state = IconicState;
  else
	wm_hints.initial_state = NormalState;
  wm_hints.input = True;
  wm_hints.flags = StateHint | InputHint;

  class_hints.res_name = cur_argv[0];
  class_hints.res_class = "message";

  XSetWMProperties(cur_display, window, &tx_window_name, &tx_icon_name, 
    cur_argv, cur_argc, &size_hints, &wm_hints, &class_hints);

  XSelectInput(cur_display, window, StructureNotifyMask);

  XMapWindow(cur_display,window);

  enlist(cptr,window,CUR_WLIST_HOLDER,height,width)

  return cptr;
  }

#if defined(PROTOTYPES)
cur_wlist_t *cur_mk_hslider(cur_wlist_t *parent,int size,int incr,int base)
#else
cur_wlist_t *cur_mk_hslider(parent,size,incr,base) 
cur_wlist_t *parent;int size;int incr;int base;
#endif
  { 
  XSetWindowAttributes	 attrib;
  int width;
  int height;
  int x,y;
  Window window_slider;
  Window window_earlier;
  Window window_later;
  cur_wlist_t *slider;
  cur_wlist_t *earlier;
  cur_wlist_t *later;

  height = CUR_SLIDER_WIDTH - 2 * CUR_SLIDER_BORDER;
  width = parent->width - 2 * CUR_SLIDER_BORDER;
  if (parent->data.scroller.vslider)
    width -= CUR_SLIDER_WIDTH;
  y=parent->height - CUR_SLIDER_WIDTH;
  x=0;

  window_slider = XCreateSimpleWindow(cur_display,parent->window,x,y,
      width,height,CUR_SLIDER_BORDER,cur_foreground_color,cur_background_color);
  attrib.win_gravity = SouthWestGravity;
  XChangeWindowAttributes(cur_display, window_slider, CWWinGravity, &attrib);
  XSelectInput(cur_display, window_slider, ExposureMask | ButtonPressMask | StructureNotifyMask | ButtonMotionMask | PointerMotionHintMask );
  XMapWindow(cur_display,window_slider);

  window_earlier = XCreateSimpleWindow(cur_display,window_slider,0,0,
      CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),
      CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),
      1,cur_foreground_color,cur_background_color);
  attrib.win_gravity = SouthWestGravity;
  XChangeWindowAttributes(cur_display, window_earlier, CWWinGravity, &attrib);
  XSelectInput(cur_display, window_earlier, ExposureMask | ButtonPressMask);
  XMapWindow(cur_display,window_earlier);

  window_later = XCreateSimpleWindow(cur_display,window_slider,
      width - CUR_SLIDER_WIDTH,0,
      CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),
      CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),
      1,cur_foreground_color,cur_background_color);
  attrib.win_gravity = SouthEastGravity;
  XChangeWindowAttributes(cur_display, window_later, CWWinGravity, &attrib);
  XSelectInput(cur_display, window_later, ExposureMask | ButtonPressMask);
  XMapWindow(cur_display,window_later);

  enlist(slider,window_slider,CUR_WLIST_HORIZONTAL_SLIDER,height,width);
  enlist(earlier,window_earlier,CUR_WLIST_HORIZONTAL_SLIDER_BOX,CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER))
  enlist(later,window_later,CUR_WLIST_HORIZONTAL_SLIDER_BOX,CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER))

  slider->data.slider.vertical = NO;
  slider->data.slider.place = 0;
  slider->data.slider.size = size;
  slider->data.slider.incr = incr;
  slider->data.slider.base = base;
  slider->data.slider.parent = parent;
  slider->data.slider.earlier = earlier;
  slider->data.slider.later = later;
  earlier->data.slider_box.incr = -1;
  earlier->data.slider_box.parent = slider;
  later->data.slider_box.incr = 1;
  later->data.slider_box.parent = slider;

  return slider;
  }

#if defined(PROTOTYPES)
cur_wlist_t *cur_mk_scroller(cur_wlist_t *parent,int x,int y,
    int width,int height,int width_incr,int height_incr,
    int width_base,int height_base)
#else
cur_wlist_t *cur_mk_scroller(parent,x,y,width,height,width_incr,height_incr,
        width_base,height_base)
cur_wlist_t *parent;int x;int y;
    int width;int height;int width_incr;int height_incr;
    int width_base;int height_base;
#endif
  {
  cur_wlist_t		*cptr;
  Window		 window;

  window = XCreateSimpleWindow(cur_display,parent->window,x,y,
      width,height,1,cur_foreground_color,cur_background_color);

  XSelectInput(cur_display, window, Expose | StructureNotifyMask);

  XMapWindow(cur_display,window);

  enlist(cptr,window,CUR_WLIST_SCROLLER,height,width)
  cptr->data.scroller.child_width_incr = 1;
  cptr->data.scroller.child_height_incr = height_incr;
  cptr->data.scroller.child_width_base = width_base;
  cptr->data.scroller.child_height_base = height_base;
  cptr->data.scroller.hslider = NULL;
  cptr->data.scroller.vslider = NULL;

  return cptr;
  }

#if defined(PROTOTYPES)
cur_wlist_t *cur_mk_text(cur_wlist_t *parent,char **text,int x,int y,
    int width,int height)
#else
cur_wlist_t *cur_mk_text(parent,text,x,y,width,height)
cur_wlist_t *parent;char **text;int x;int y; int width;int height;
#endif
  {
  cur_wlist_t		*cptr;
  Window		 window;

  window = XCreateSimpleWindow(cur_display,parent->window,x,y,width,height,
      0,cur_foreground_color,cur_background_color);

  XSelectInput(cur_display, window, ExposureMask);

  XMapWindow(cur_display,window);

  enlist(cptr,window,CUR_WLIST_TEXT,height,width)

  cptr->data.text.text = text;

  return(cptr);
  }

#if defined(PROTOTYPES)
cur_wlist_t *cur_mk_vslider(cur_wlist_t *parent,int size,int incr,int base)
#else
cur_wlist_t *cur_mk_vslider(parent,size,incr,base)
cur_wlist_t *parent;int size;int incr;int base;
#endif
  { 
  XSetWindowAttributes	 attrib;
  int width;
  int height;
  int x,y;
  Window window_slider;
  Window window_earlier;
  Window window_later;
  cur_wlist_t *slider;
  cur_wlist_t *earlier;
  cur_wlist_t *later;

  width = CUR_SLIDER_WIDTH - 2 * CUR_SLIDER_BORDER;
  height = parent->height - 2 * CUR_SLIDER_BORDER;
  x=parent->width - CUR_SLIDER_WIDTH;
  y=0;

  window_slider = XCreateSimpleWindow(cur_display,parent->window,x,y,
      width,height,CUR_SLIDER_BORDER,cur_foreground_color,cur_background_color);
  attrib.win_gravity = NorthEastGravity;
  XChangeWindowAttributes(cur_display, window_slider, CWWinGravity, &attrib);
  XSelectInput(cur_display, window_slider, ExposureMask | ButtonPressMask | StructureNotifyMask | ButtonMotionMask | PointerMotionHintMask );
  XMapWindow(cur_display,window_slider);

  window_earlier = XCreateSimpleWindow(cur_display,window_slider,0,0,
      CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),
      CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),
      1,cur_foreground_color,cur_background_color);
  attrib.win_gravity = NorthWestGravity;
  XChangeWindowAttributes(cur_display, window_earlier, CWWinGravity, &attrib);
  XSelectInput(cur_display, window_earlier, ExposureMask | ButtonPressMask);
  XMapWindow(cur_display,window_earlier);

  window_later = XCreateSimpleWindow(cur_display,window_slider,0,
      height - CUR_SLIDER_WIDTH,
      CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),
      CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),
      1,cur_foreground_color,cur_background_color);
  attrib.win_gravity = SouthWestGravity;
  XChangeWindowAttributes(cur_display, window_later, CWWinGravity, &attrib);
  XSelectInput(cur_display, window_later, ExposureMask | ButtonPressMask);
  XMapWindow(cur_display,window_later);

  enlist(slider,window_slider,CUR_WLIST_VERTICAL_SLIDER,height,width);
  enlist(earlier,window_earlier,CUR_WLIST_VERTICAL_SLIDER_BOX,CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER))
  enlist(later,window_later,CUR_WLIST_VERTICAL_SLIDER_BOX,CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER),CUR_SLIDER_WIDTH - (4 * CUR_SLIDER_BORDER))

  slider->data.slider.vertical = YES;
  slider->data.slider.place = 0;
  slider->data.slider.size = size;
  slider->data.slider.incr = incr;
  slider->data.slider.base = base;
  slider->data.slider.parent = parent;
  slider->data.slider.earlier = earlier;
  slider->data.slider.later = later;
  earlier->data.slider_box.incr = -1;
  earlier->data.slider_box.parent = slider;
  later->data.slider_box.incr = 1;
  later->data.slider_box.parent = slider;

  return slider;
  }

#if defined(PROTOTYPES)
void cur_msg_win(char *string)
#else
void cur_msg_win(string) char *string;
#endif
  {
  XClassHint		 class_hints;
  cur_wlist_t		*cptr;
  cur_wlist_t		*cptr_cancel;
  XTextProperty		 icon_name;
  char			*name_string;
  XSizeHints		 size_hints;
  int			 width_all;
  int			 width_string;
  Window		 window;
  Window		 window2;
  XTextProperty		 window_name;
  XWMHints		 wm_hints;

  width_string = XTextWidth(cur_font,string,strlen(string));
  width_all = ((width_string + 12) > cur_button_width) ? width_string + 12 
						       : cur_button_width;

  window = XCreateSimpleWindow(cur_display,cur_root_window,0,0,
      width_all + 200,cur_font_height + cur_button_height,4,
      cur_foreground_color,cur_background_color);

  name_string = "message";
  if (XStringListToTextProperty(&name_string, 1, &icon_name) == 0)
    {
    cur_error("Can not alloc string property icon_name");
    exit(1);
    }
  if (XStringListToTextProperty(&name_string, 1, &window_name) == 0)
    {
    cur_error("Can not alloc string property window_name");
    exit(1);
    }

  size_hints.flags = PPosition | PSize | PMinSize;
  size_hints.min_width = width_all;
  size_hints.min_height = cur_font_height + cur_button_height;
  
  wm_hints.initial_state = NormalState;
  wm_hints.input = True;
  wm_hints.flags = StateHint | InputHint;

  class_hints.res_name = cur_argv[0];
  class_hints.res_class = "message";

  XSetWMProperties(cur_display, window, &window_name, &icon_name, 
    cur_argv, cur_argc, &size_hints, &wm_hints, &class_hints);

  XSelectInput(cur_display, window, ExposureMask | StructureNotifyMask);

  XMapWindow(cur_display,window);

  enlist(cptr,window,CUR_WLIST_MESSAGE,cur_font_height + cur_button_height, width_all + 200);
  cptr->data.message.string = string;
  cptr->data.message.width = width_string;

  cptr_cancel = cur_mk_button(cptr,"Cancel",-cptr->width,-cptr->height,0,
      SouthEastGravity,0,NULL,NULL,NULL,NULL,NULL);
  cur_warp(cptr_cancel);

  XBell(cur_display,100);
  cur_process_events();

  cur_rm_button(cptr_cancel);

  delist(cptr);

  return;
  }

#if defined(PROTOTYPES)
void cur_mv_slider(cur_wlist_t *slider,int place)
#else
void cur_mv_slider(slider,place) cur_wlist_t *slider;int place;
#endif
  {
  Window scrolled_window;
  int hplace;
  int vplace;
  cur_wlist_t *parent;
  cur_wlist_t *hslider;
  cur_wlist_t *vslider;

  parent = slider->data.slider.parent;
  vslider = parent->data.scroller.vslider;
  hslider = parent->data.scroller.hslider;

  place -= CUR_SLIDER_WIDTH;
  place *= slider->data.slider.size;
  if (slider->data.slider.vertical)
    {
    place /= slider->height - (2 * CUR_SLIDER_WIDTH);
    if (place + parent->height > slider->data.slider.size)
      place = slider->data.slider.size - parent->height;
    }
  else
    {
    place /= slider->width - (2 * CUR_SLIDER_WIDTH);
    if (place + parent->width > slider->data.slider.size)
      place = slider->data.slider.size - parent->width;
    }

  if (place < 0)
    place = 0;

  slider->data.slider.place = place;
  scrolled_window = parent->data.scroller.child->window;
  if (hslider)
    hplace = -hslider->data.slider.place;
  else
    hplace = 0;
  if (vslider)
    vplace = -vslider->data.slider.place;
  else
    vplace = 0;

  XMoveWindow(cur_display,scrolled_window,hplace,vplace);
  if (slider->data.slider.vertical)
    cur_draw_vslider(slider);
  else
    cur_draw_hslider(slider);
  }

#define recase(wintype,signal)  (((wintype) << 10) + signal)
#define docase(wintype,signal)  case recase(wintype,signal)
#define control(ch)		(ch - 'a' + 1)
#define do_warp(cptr)	{if (cur_do_warp)  XWarpPointer(cur_display,NULL,cptr->window,0,0,0,0,4,cur_font_height);}

#if defined(PROTOTYPES)
int cur_process_events(void)
#else
int cur_process_events()
#endif
  {
  int more;
  int more2;
  int value;
  int process;
  int place,ch,swidth,pwidth;
  int need_vslider,need_hslider;
  XEvent report;
  Window event_window;
  cur_wlist_t *cptr;
  cur_wlist_t *text_window;
  int redraw;
  char **tptr;
  XPoint plist[4];
  int origx,origy;
  int posx,posy,rootx,rooty,key_buttons;
  Window root,child;
  char buffer[10];
  KeySym keysym;
  int count;
  XComposeStatus compose;
  char *sptr;
  cur_mlist_t *mptr;

  value = 0;
  more = 1;
  buffer[0] = '\0';
  buffer[1] = '\0';
  process = cur_process_count;
  cur_process_count = ++cur_process_max;
  while (more)
    {
    XNextEvent(cur_display,&report);
#ifdef DEBUG
    fprintf(stderr,"Event = %d;",report.type);
#endif
    event_window = 0;
    switch (report.type)
      {
      case Expose :
          if (report.xexpose.count)
            break;
          event_window = report.xexpose.window;
        break;
      case ConfigureNotify :
          event_window = report.xconfigure.window;
        break;
      case MotionNotify :
          event_window = report.xmotion.window;
        break;
      case ButtonPress :
          event_window = report.xbutton.window;
        break;
      case KeyPress :
          event_window = report.xkey.window;
        break;
      }
    if (!event_window)
      {
#ifdef DEBUG
      fputc('\n',stderr);
#endif
      continue;
      }
#ifdef DEBUG
    fprintf(stderr,"Window = %d;",event_window);
#endif
    for (cptr = cur_win_list;
        cptr && cptr->window != event_window;
        cptr = cptr->next)
      ;
    if (!cptr)
      continue;
#ifdef DEBUG
    fprintf(stderr,"Type = %d\n",cptr->type);
#endif
    switch (recase(cptr->type,report.type))
      {
      docase(CUR_WLIST_OTHER,Expose) :
	  cptr->data.other.routine(cptr->data.other.parameter1,
		cptr->data.other.parameter2,cptr->data.other.parameter3);
        break;
      docase(CUR_WLIST_MESSAGE,ConfigureNotify) :
      docase(CUR_WLIST_VERTICAL_SLIDER,ConfigureNotify) :
      docase(CUR_WLIST_HORIZONTAL_SLIDER,ConfigureNotify) :
          cptr->width = report.xconfigure.width;
          cptr->height = report.xconfigure.height;
        break;
      docase(CUR_WLIST_MESSAGE,Expose) :
          if (!cptr->width)
            {
            cptr->width = report.xexpose.width;
            cptr->height = report.xexpose.height;
            }
          XDrawString(cur_display,cptr->window,cur_gc,
              (cptr->width - cptr->data.message.width) / 2,cur_font_height,
              cptr->data.message.string,strlen(cptr->data.message.string));
        break;
      docase(CUR_WLIST_BUTTON,Expose) :
          XDrawRectangle(cur_display,cptr->window,cur_gc,2,2,
              cptr->width - CUR_BUTTON_INNER,cptr->height - CUR_BUTTON_INNER);
          swidth = XTextWidth(cur_font,cptr->data.button.name,
			strlen(cptr->data.button.name));
	  if (swidth > cptr->width + 10)
		swidth = cptr->width - 10;
          XDrawString(cur_display,cptr->window,cur_gc,
	      (cptr->width - swidth) / 2,cur_font_height + CUR_BUTTON_INNER,
	      cptr->data.button.name,cptr->data.button.length);
        break;
      docase(CUR_WLIST_BUTTON,KeyPress) :
	  count = XLookupString(&report,buffer,10,&keysym,&compose);
	  ch = 0;
	  if (buffer[1] == '\0' && (
	      (keysym >= XK_KP_Space && keysym <= XK_KP_9) ||
	      (keysym >= XK_space && keysym <= XK_asciitilde)))
	    ch = buffer[0];
          if (cptr->data.button.routine && 
		strchr(cptr->data.button.active_string,ch) &&
                (cur_routine_value = 
		    cptr->data.button.routine(ch,cptr->data.button.parameter2,
		    cptr->data.button.parameter3)))
	    {
            value = cptr->data.button.return_value;
	    if (value != CUR_BUTTON_NORETURN)
	      {
              more = 0;
	      do_warp(cptr);
	      }
	    }
	  else if (keysym == XK_Linefeed || keysym == XK_Return)
	    {
            if (!cptr->data.button.routine ||
                (cur_routine_value = 
			cptr->data.button.routine(cptr->data.button.parameter1,
			cptr->data.button.parameter2,
			cptr->data.button.parameter3)))
              {
              value = cptr->data.button.return_value;
	      if (value != CUR_BUTTON_NORETURN)
		{
                more = 0;
		do_warp(cptr);
		}
	      }
	    else
	      do_warp(cptr);
	    }
	  else if (ch == 'j' || keysym == XK_Down || keysym == XK_Right)
	    {
	    if (cptr->data.button.down)
	      cptr = cptr->data.button.down;
	    else if (cptr->data.button.alt_next)
	      cptr = cptr->data.button.alt_next;
	    else
	      {
              XBell(cur_display, 100);
	      break;
	      }
	    do_warp(cptr);
	    }
          else if (ch == 'k' || keysym == XK_Up || keysym == XK_Left)
	    {
	    if (cptr->data.button.up)
	      cptr = cptr->data.button.up;
	    else if (cptr->data.button.alt_last)
	      cptr = cptr->data.button.alt_last;
	    else
	      {
              XBell(cur_display, 100);
	      break;
	      }
	    do_warp(cptr);
	    }
	  else
	    {
            XBell(cur_display, 100);
	    redraw = NO;
	    }
          buffer[1] = '\0';
	break;
      docase(CUR_WLIST_BUTTON,ButtonPress) :
          if (!cptr->data.button.routine ||
              (cur_routine_value = 
			cptr->data.button.routine(cptr->data.button.parameter1,
			cptr->data.button.parameter2,
			cptr->data.button.parameter3)))
            {
            value = cptr->data.button.return_value;
	    if (value != CUR_BUTTON_NORETURN)
              more = 0;
            }
        break;
      docase(CUR_WLIST_TEXT,Expose) :
          origy = cur_font_height - cur_font_decent;
          origx = 10;
          for (tptr = cptr->data.text.text;
               *tptr;
               tptr++,origy += cur_font_height)
           XDrawString(cur_display,cptr->window,cur_gc,origx,
               origy,*tptr,strlen(*tptr));
        break;
      docase(CUR_WLIST_SCROLLER,ConfigureNotify) :
          cptr->width = report.xconfigure.width;
          cptr->height = report.xconfigure.height;
          need_vslider = NO;
          need_hslider = NO;
          if (cptr->width < cptr->data.scroller.child_width -
              (cptr->data.scroller.vslider ? CUR_SLIDER_WIDTH : 0))
            need_hslider = YES;
          if (cptr->height < cptr->data.scroller.child_height -
              (cptr->data.scroller.hslider ? CUR_SLIDER_WIDTH : 0))
            need_vslider = YES;
          if (cptr->width < cptr->data.scroller.child_width -
              (need_hslider ? CUR_SLIDER_WIDTH : 0))
            need_hslider = YES;
          if (cptr->height < cptr->data.scroller.child_height -
              (need_vslider ? CUR_SLIDER_WIDTH : 0))
            need_vslider = YES;
          if (need_vslider)
            {
            if (cptr->data.scroller.vslider)
              {
              XResizeWindow(cur_display,cptr->data.scroller.vslider->window,
                  CUR_SLIDER_WIDTH, cptr->height);
              if (cptr->data.scroller.vslider->data.slider.place +
                  cptr->height >
                  cptr->data.scroller.vslider->data.slider.size)
                {
                cptr->data.scroller.vslider->data.slider.place =
                    cptr->data.scroller.vslider->data.slider.size -
                    cptr->height;
                XMoveWindow(cur_display,cptr->data.scroller.child->window,
                    -cptr->data.scroller.hslider->data.slider.place,
                    -cptr->data.scroller.vslider->data.slider.place);
                }
              }
            else
              cptr->data.scroller.vslider = cur_mk_vslider(cptr,
                  cptr->data.scroller.child_height,
                  cptr->data.scroller.child_height_incr,
                  cptr->data.scroller.child_height_base);
            }
          else if (cptr->data.scroller.vslider)
            {
            cur_rm_vslider(cptr->data.scroller.vslider);
            cptr->data.scroller.vslider = NULL;
            XMoveWindow(cur_display,cptr->data.scroller.child->window,0,0);
            }
          if (need_hslider)
            {
            if (cptr->data.scroller.hslider)
              {
              XResizeWindow(cur_display,cptr->data.scroller.hslider->window,
                  cptr->width - (need_vslider ? CUR_SLIDER_WIDTH : 0),
                  CUR_SLIDER_WIDTH);
              if (cptr->data.scroller.hslider->data.slider.place +
                  cptr->width - (need_vslider ? CUR_SLIDER_WIDTH : 0) >
                  cptr->data.scroller.hslider->data.slider.size)
                {
                cptr->data.scroller.hslider->data.slider.place =
                    cptr->data.scroller.hslider->data.slider.size -
                    cptr->width + (need_vslider ? CUR_SLIDER_WIDTH : 0);
                XMoveWindow(cur_display,cptr->data.scroller.child->window,
                    -cptr->data.scroller.hslider->data.slider.place,
                    -cptr->data.scroller.vslider->data.slider.place);
                }
              }
            else
              cptr->data.scroller.hslider = cur_mk_hslider(cptr,
                  cptr->data.scroller.child_width,
                  cptr->data.scroller.child_width_incr,
                  cptr->data.scroller.child_width_base);
            }
          else if (cptr->data.scroller.hslider)
            {
            cur_rm_hslider(cptr->data.scroller.hslider);
            cptr->data.scroller.hslider = NULL;
            XMoveWindow(cur_display,cptr->data.scroller.child->window,0,0);
            }
        break;
      docase(CUR_WLIST_HOLDER,ConfigureNotify) :
          cptr->width = report.xconfigure.width;
          cptr->height = report.xconfigure.height;
          XResizeWindow(cur_display,cptr->data.holder.child->window,
              report.xconfigure.width,
              report.xconfigure.height - CUR_BUTTON_HEIGHT - 10);
        break;
      docase(CUR_WLIST_VERTICAL_SLIDER,Expose) :
          cur_draw_vslider(cptr);
        break;
      docase(CUR_WLIST_VERTICAL_SLIDER,MotionNotify) :
          while (XCheckMaskEvent(cur_display,Button2MotionMask,&report))
            ;
          if (!XQueryPointer(cur_display,report.xmotion.window,
              &root,&child,&rootx,&rooty,&posx,&posy,&key_buttons))
            ;
          cur_mv_vslider(cptr,posy);
        break;
      docase(CUR_WLIST_VERTICAL_SLIDER,ButtonPress) :
          if (report.xbutton.button == 1)
            cur_bump_slider(cptr,-1);
          else if (report.xbutton.button == 2)
            cur_mv_vslider(cptr,report.xbutton.y);
          else if (report.xbutton.button == 3)
            cur_bump_slider(cptr,1);
        break;
      docase(CUR_WLIST_VERTICAL_SLIDER_BOX,Expose) :
          plist[0].x = 3;
          plist[1].x = 5;
          plist[2].x = 5;
          plist[3].x = -10;
          if (cptr->data.slider_box.incr == -1)
            {
            plist[0].y = 13;
            plist[1].y = -10;
            plist[2].y = 10;
            }
          else
            {
            plist[0].y = 3;
            plist[1].y = 10;
            plist[2].y = -10;
            }
          plist[3].y = 0;
          XFillPolygon(cur_display,cptr->window,cur_gc,plist,4,Convex,CoordModePrevious);
          XDrawLines(cur_display,cptr->window,cur_gc,plist,4,CoordModePrevious);
        break;
      docase(CUR_WLIST_VERTICAL_SLIDER_BOX,ButtonPress) :
          cur_bump_slider(cptr->data.slider_box.parent,
              cptr->data.slider_box.incr);
        break;
      docase(CUR_WLIST_HORIZONTAL_SLIDER,Expose) :
          cur_draw_hslider(cptr);
        break;
      docase(CUR_WLIST_HORIZONTAL_SLIDER,MotionNotify) :
          while (XCheckMaskEvent(cur_display,Button2MotionMask,&report))
            ;
          if (!XQueryPointer(cur_display,report.xmotion.window,
              &root,&child,&rootx,&rooty,&posx,&posy,&key_buttons))
            ;
          cur_mv_slider(cptr,posx);
        break;
      docase(CUR_WLIST_HORIZONTAL_SLIDER,ButtonPress) :
          if (report.xbutton.button == 1)
            cur_bump_slider(cptr,-1);
          else if (report.xbutton.button == 2)
            cur_mv_slider(cptr,report.xbutton.x);
          else if (report.xbutton.button == 3)
            cur_bump_slider(cptr,1);
        break;
      docase(CUR_WLIST_HORIZONTAL_SLIDER_BOX,Expose) :
          plist[0].y = 3;
          plist[1].y = 5;
          plist[2].y = 5;
          plist[3].y = -10;
          if (cptr->data.slider_box.incr == -1)
            {
            plist[0].x = 13;
            plist[1].x = -10;
            plist[2].x = 10;
            }
          else
            {
            plist[0].x = 3;
            plist[1].x = 10;
            plist[2].x = -10;
            }
          plist[3].x = 0;
          XFillPolygon(cur_display,cptr->window,cur_gc,plist,4,Convex,CoordModePrevious);
          XDrawLines(cur_display,cptr->window,cur_gc,plist,4,CoordModePrevious);
        break;
      docase(CUR_WLIST_HORIZONTAL_SLIDER_BOX,ButtonPress) :
          cur_bump_slider(cptr->data.slider_box.parent,
              cptr->data.slider_box.incr);
        break;
      docase(CUR_WLIST_MLIST,Expose) :
          XDrawString(cur_display,cptr->window,cur_gc,10,
              cptr->height / 2 + cur_font_decent,
              cptr->data.mlist.item->name,
              strlen(cptr->data.mlist.item->name));
        break;
      docase(CUR_WLIST_MLIST,KeyPress) :
	  cptr = cptr->data.mlist.child;
	/* Fall through */
      docase(CUR_WLIST_MLIST_DATA,KeyPress) :
	  redraw = YES;
	  count = XLookupString(&report,buffer,10,&keysym,&compose);
	  ch = 0;
	  if (buffer[1] == '\0' && (
	      (keysym >= XK_KP_Space && keysym <= XK_KP_9) ||
	      (keysym >= XK_space && keysym <= XK_asciitilde)))
	    ch = buffer[0];
          if (ch == control('i') || keysym == XK_Tab && 
	      cptr->data.mdata.item->type == CUR_MENU_LIST)
	    {
	    cptr->data.mdata.item->l_answer = cur_slist_fancy(
		"Choose an item",cptr->data.mdata.item->list,
	        cptr->data.mdata.item->i_answer,
		&cptr->data.mdata.item->i_answer);
	    cptr->data.mdata.place = 0;
	    strcpy(cptr->data.mdata.item->s_answer,
		cptr->data.mdata.item->l_answer->string);
	    do_warp(cptr);
	    }
          else if ((ch >= ' ' && ch <= '~') ||
              (keysym >= XK_F1 && keysym <= XK_F35 && *buffer != '\0'))
            {
	    if (ch == '?' && (
	        cptr->data.mdata.item->type == CUR_MENU_LIST || 
	        cptr->data.mdata.item->type == CUR_MENU_OLIST) )
	      {
	      cptr->data.mdata.item->l_answer = cur_slist_fancy("Choose one",cptr->data.mdata.item->list,cptr->data.mdata.item->i_answer,&cptr->data.mdata.item->i_answer);
              if (cptr->data.mdata.item->s_answer_size < strlen(cptr->data.mdata.item->l_answer->string))
		{
		cptr->data.mdata.item->s_answer_size = strlen(cptr->data.mdata.item->l_answer->string) + 10;
		free(cptr->data.mdata.item->s_answer);
		cptr->data.mdata.item->s_answer = malloc(cptr->data.mdata.item->s_answer_size);
		}
	      strcpy(cptr->data.mdata.item->s_answer,cptr->data.mdata.item->l_answer->string);
              cptr->data.mdata.item->edited = YES;
	      }
	    else if (!cptr->data.mdata.item->enterable)
	      {
	      cur_msg_win("This item is not editable");
	      }
	    else
	      {
	      swidth = strlen(cptr->data.mdata.item->s_answer);
	      pwidth = strlen(buffer);
              if (swidth + pwidth + 1>= cptr->data.mdata.item->s_answer_size)
	        {
	        cptr->data.mdata.item->s_answer_size += 32;
	        cptr->data.mdata.item->s_answer = 
		    realloc(cptr->data.mdata.item->s_answer,
		    cptr->data.mdata.item->s_answer_size);
	        }
	      for (sptr = cptr->data.mdata.item->s_answer + swidth;
		   sptr >= cptr->data.mdata.item->s_answer + 
		       cptr->data.mdata.place;
		   sptr--)
	        *(sptr + pwidth) = *sptr;
	      for (count = 0;count < pwidth;count++)
	        cptr->data.mdata.item->s_answer[
		    cptr->data.mdata.place + count] = buffer[count];
	      cptr->data.mdata.place += pwidth;
	      }
            }
          else if (ch == control('h') || keysym == XK_BackSpace || 
	       keysym == XK_Delete) 
            {
            if (cptr->data.mdata.place > 0) 
              { 
	      if (!cptr->data.mdata.item->enterable)
	        {
	        cur_msg_win("This item is not editable");
	        }
	      else
	        {
	        for (sptr = cptr->data.mdata.item->s_answer + cptr->data.mdata.place;*sptr;sptr++)
		  *(sptr - 1) = *sptr;
	        *(sptr - 1) = '\0';
	        cptr->data.mdata.place--;
	        }
              }
            else
	      {
              XBell(cur_display, 100);
	      redraw = NO;
	      }
            }
          else if (keysym == XK_Linefeed || keysym == XK_Return || 
	      keysym == XK_Down) 
	    {
	    redraw = NO;
	    cptr = cptr->data.mdata.parent;
	    if (cptr->data.mlist.next)
	      {
	      cptr = cptr->data.mlist.next;
	      cptr = cptr->data.mlist.child;
	      }
	    else if (cptr->data.mlist.alt_next)
	      cptr = cptr->data.mlist.alt_next;
	    else
	      {
	      for (;cptr->data.mlist.last;cptr = cptr->data.mlist.last)
	        ;
	      }
	    do_warp(cptr);
	    }
          else if (keysym == XK_Escape)
	    {
	    value = 0;
            more = 0;
	    do_warp(cptr);
	    }
          else if (keysym == XK_Up)
	    {
	    redraw = NO;
	    cptr = cptr->data.mdata.parent;
	    if (cptr->data.mlist.last)
	      {
	      cptr = cptr->data.mlist.last;
	      cptr = cptr->data.mlist.child;
	      }
	    else if (cptr->data.mlist.alt_last)
	      cptr = cptr->data.mlist.alt_last;
	    else
	      {
	      for (;cptr->data.mlist.next;cptr = cptr->data.mlist.next)
	        ;
	      }
	    do_warp(cptr);
	    }
          else if (keysym == XK_Left)
	    {
	    if (cptr->data.mdata.place > 0)
	      cptr->data.mdata.place--;
	    else
	      {
              XBell(cur_display, 100);
	      redraw = NO;
	      }
	    }
          else if (keysym == XK_Right)
	    {
	    if (cptr->data.mdata.place < 
		strlen(cptr->data.mdata.item->s_answer))
	      cptr->data.mdata.place++;
	    else
	      {
              XBell(cur_display, 100);
	      redraw = NO;
	      }
	    }
          else if (keysym == XK_End)
	    {
	    cptr->data.mdata.place = strlen(cptr->data.mdata.item->s_answer);
	    }
          else if (ch == control('z'))
	    {
	    if (!cptr->data.mdata.item->enterable)
	      {
              XBell(cur_display, 100);
	      redraw = NO;
	      }
	    else
	      {
	      cptr->data.mdata.place = 0;
	      mptr = cptr->data.mdata.item->next;
	      cur_menu_reset(cptr->data.mdata.item);
	      cptr->data.mdata.item->next = mptr;
	      }
	    }
          else if (ch == control('x'))
	    {
	    if (!cptr->data.mdata.item->enterable)
	      {
              XBell(cur_display, 100);
	      redraw = NO;
	      }
	    else
	      {
	      cptr->data.mdata.place = 0;
	      cptr->data.mdata.item->s_answer[0] = '\0';
	      }
	    }
          else if (keysym == XK_Begin || keysym == XK_Home)
	    {
	    cptr->data.mdata.place = 0;
	    }
          else if (!(keysym >= XK_Shift_L && keysym <= XK_Hyper_R))
	    {
            XBell(cur_display, 100);
	    redraw = NO;
	    }
          buffer[1] = '\0';
	  if (!redraw)
            break;
      docase(CUR_WLIST_MLIST_DATA,ButtonPress) :
      docase(CUR_WLIST_MLIST_DATA,Expose) :
          XClearWindow(cur_display,cptr->window); 
	  swidth = XTextWidth(cur_font,cptr->data.mdata.item->s_answer,
	      strlen(cptr->data.mdata.item->s_answer));
        redo_pwidth :
	  if (cptr->data.mdata.place == 0)
	    pwidth = 0;
	  else
	    {
	    ch = cptr->data.mdata.item->s_answer[cptr->data.mdata.place];
	    cptr->data.mdata.item->s_answer[cptr->data.mdata.place] = '\0';
	    pwidth = XTextWidth(cur_font,cptr->data.mdata.item->s_answer,strlen(cptr->data.mdata.item->s_answer));
	    cptr->data.mdata.item->s_answer[cptr->data.mdata.place] = ch;
	    }
          if (report.type == ButtonPress)
	    {
	    if (swidth < cptr->width || pwidth < cptr->width - 50)
	      swidth = report.xbutton.x - 10;
	    else
	      swidth = report.xbutton.x - (cptr->width - 50 - pwidth);
            for (sptr = cptr->data.mdata.item->s_answer, more2 = 1;
	       *sptr && more2;
	       more2 && sptr++)
	      {
	      ch = *sptr;
	      *sptr = '\0';
	      pwidth = XTextWidth(cur_font,cptr->data.mdata.item->s_answer,strlen(cptr->data.mdata.item->s_answer));
	      *sptr = ch;
	      if (pwidth > swidth)
		more2 = 0;
	      }
	    if (*sptr || 
		XTextWidth(cur_font,cptr->data.mdata.item->s_answer,
		strlen(cptr->data.mdata.item->s_answer)) > swidth)
	      cptr->data.mdata.place = sptr - cptr->data.mdata.item->s_answer - 
		  1;
	    else
	      cptr->data.mdata.place = strlen(cptr->data.mdata.item->s_answer);
	    report.type = Expose;
	    goto redo_pwidth;
	    }
	  if (swidth < cptr->width || pwidth < cptr->width - 50)
	    {
            XDrawString(cur_display,cptr->window,cur_gc,10,
                cptr->height - cur_font_decent - 1,
                cptr->data.mdata.item->s_answer,
                strlen(cptr->data.mdata.item->s_answer));
	    pwidth += 10;
	    }
	  else
	    {
            XDrawString(cur_display,cptr->window,cur_gc,
		cptr->width - 50 - pwidth,
                cptr->height - cur_font_decent - 1,
                cptr->data.mdata.item->s_answer,
                strlen(cptr->data.mdata.item->s_answer));
	    pwidth = cptr->width - 50;
	    }
          plist[0].x = pwidth;
          plist[1].x = 4;
          plist[2].x = -8;
          plist[3].x = 4;
          plist[0].y = cptr->height - 3;
          plist[1].y = 4;
          plist[2].y = 0;
          plist[3].y = -4;
          XFillPolygon(cur_display,cptr->window,cur_gc,plist,4,Convex,CoordModePrevious);
        break;
      }
    if (!more && cptr->process != process)
      {
      more = YES;
      XBell(cur_display,100);
      }
    if (cptr->warp)
      {
      cptr->warp = NO;
      do_warp(cptr);
      }
    }
  return value;
  }

#if defined(PROTOTYPES)
void cur_rm_button(cur_wlist_t *button)
#else
void cur_rm_button(button) cur_wlist_t *button;
#endif
  {
  delist(button);
  }

#if defined(PROTOTYPES)
void cur_rm_holder(cur_wlist_t *cptr)
#else
void cur_rm_holder(cptr) cur_wlist_t *cptr;
#endif
  {
  delist(cptr);
  }

#if defined(PROTOTYPES)
void cur_rm_scroller(cur_wlist_t *cptr)
#else
void cur_rm_scroller(cptr) cur_wlist_t *cptr;
#endif
  {
  if (cptr->data.scroller.vslider)
    cur_rm_slider(cptr->data.scroller.vslider);
  if (cptr->data.scroller.hslider)
    cur_rm_slider(cptr->data.scroller.hslider);
  delist(cptr);
  }

#if defined(PROTOTYPES)
void cur_rm_slider(cur_wlist_t *slider)
#else
void cur_rm_slider(slider) cur_wlist_t *slider;
#endif
  {
  delist(slider->data.slider.earlier);
  delist(slider->data.slider.later);
  delist(slider);
  }

#if defined(PROTOTYPES)
void cur_rm_text(cur_wlist_t *text)
#else
void cur_rm_text(text) cur_wlist_t *text;
#endif
  {
  delist(text)
  }

#if defined(PROTOTYPES)
cur_slist_t *cur_slist_fancy(char *title,cur_slist_t *list,int current,
    int *answer)
#else
cur_slist_t *cur_slist_fancy(title,list,current,answer)
char *title;cur_slist_t *list;int current; int *answer;
#endif
  {
  cur_wlist_t		*cptr_scroller;
  cur_wlist_t		*cptr_qparent;
  cur_wlist_t		*cptr_qwin;
  cur_wlist_t		*cptr_last;
  cur_wlist_t		*cptr_current;
  cur_wlist_t		*cptr_first;
  int			 init_items;
  int			 min_items;
  int			 items;
  int			 loop;
  int			 value;
  int			 max_width;
  int			 width;
  int			 width_all;
  Window		 window;
  cur_slist_t 		*lptr;
  XClassHint		 class_hints;
  XTextProperty		 tx_icon_name;
  XTextProperty		 tx_window_name;
  XSizeHints		 size_hints;
  XWMHints		 wm_hints;
  int			 incr;

  incr = (cur_button_height - CUR_BUTTON_PAD - (2 * CUR_BUTTON_BORDER));
  max_width = 0;
  for (lptr=list,items = 0;lptr;items++,lptr = lptr->next)
    {
    width = XTextWidth(cur_font,lptr->string,strlen(lptr->string));
    if (width > max_width)
      max_width = width;
    }

  init_items = (14 > items ? items : 14);
  min_items = (3 > items ? items + 1: 4);
  if (cur_width_80 + 20 < max_width)
    width_all = cur_width_80 + 20;
  else
    width_all = max_width + CUR_BUTTON_MARGIN;

  cptr_scroller = cur_mk_scroller(&cur_root_wlist,0,0,width_all + 2,
	(init_items - 1) * incr + cur_button_height + 16,width_all / 80,
	CUR_BUTTON_HEIGHT,width_all,((items - 1) * incr) + cur_button_height);

  if (XStringListToTextProperty(&title, 1, &tx_icon_name) == 0)
    {
    cur_error("Can not alloc string property icon_name");
    exit(1);
    }
  if (XStringListToTextProperty(&title, 1, &tx_window_name) == 0)
    {
    cur_error("Can not alloc string property window_name");
    exit(1);
    }

  size_hints.flags = PPosition | PSize | PMinSize | PResizeInc;
  size_hints.min_width = width_all /10;
  size_hints.width_inc = 1;
  size_hints.height_inc = incr;
  size_hints.min_height = incr * 3 + 2 * CUR_BUTTON_PAD + 4;
  
  wm_hints.initial_state = NormalState;
  wm_hints.input = True;
  wm_hints.flags = StateHint | InputHint;

  class_hints.res_name = cur_argv[0];
  class_hints.res_class = "message";

  XSetWMProperties(cur_display, cptr_scroller->window, &tx_window_name, 
      &tx_icon_name, cur_argv, cur_argc, &size_hints, &wm_hints, &class_hints);

  window = XCreateSimpleWindow(cur_display,cptr_scroller->window,0,0,
      max_width + CUR_BUTTON_MARGIN,((items - 1) * incr) + cur_button_height,
      0,cur_foreground_color,cur_background_color);

  XMapWindow(cur_display,window);

  enlist(cptr_qparent,window,CUR_WLIST_MLISTS,((items - 1) * incr) + cur_button_height + 2,max_width + CUR_BUTTON_MARGIN + 2)

  cptr_qwin = NULL;
  for (cptr_last = NULL,cptr_first = NULL,cptr_current = NULL,
       loop = 0,
       lptr = list;
       lptr;
       lptr = lptr->next,
       loop++)
    {
    cptr_qwin = cur_mk_button(cptr_qparent,lptr->string,0,
	loop * incr,max_width,NorthWestGravity,loop,NULL,NULL,NULL,NULL,NULL);
    if (loop == current - 1)
      cptr_current = cptr_qwin;
    cptr_qwin->data.button.up = cptr_last;
    cptr_qwin->data.button.down = NULL;
    if (cptr_last)
      cptr_last->data.button.down = cptr_qwin;
    if (!cptr_first)
      cptr_first = cptr_qwin;
    cptr_last = cptr_qwin;
    }

  if (!cptr_current)
    cptr_current = cptr_first;
  cptr_first->data.button.alt_last = cptr_last;
  cptr_last->data.button.alt_next = cptr_first;
  cptr_scroller->data.scroller.child = cptr_qparent;
  cptr_scroller->data.scroller.child_width = cptr_qparent->width;
  cptr_scroller->data.scroller.child_height = cptr_qparent->height;
  cptr_qparent->data.mlists.first = cptr_qwin;
  cur_warp(cptr_current);
  value = cur_process_events();

  for (cptr_qwin = cptr_first,cptr_last = cptr_qwin ? cptr_qwin->data.button.down : NULL;
      cptr_qwin;
      cptr_qwin = cptr_last,cptr_last = cptr_qwin ? cptr_qwin->data.button.down : NULL)
    cur_rm_button(cptr_qwin);
  delist(cptr_qparent);
  cur_rm_scroller(cptr_scroller);

  for (loop = 0,lptr = list;loop < value;loop++,lptr = lptr->next)
    ;
  *answer = value + 1;
  return lptr;
  }

#if defined(PROTOTYPES)
void cur_start(int argc,char **argv)
#else
void cur_start(argc,argv) int argc;char **argv;
#endif
  {
  XGCValues xgcvalues;
  XColor cell1,cell2;

  cur_argc = argc;
  cur_argv = argv;
  if ((cur_display = XOpenDisplay(cur_display_name)) == NULL)
    {
    cur_error("Can not open Display '%s'");
    exit(1);
    }
  cur_display_number = DefaultScreen(cur_display);
  cur_display_height = DisplayHeight(cur_display,cur_display_number);
  cur_display_width = DisplayWidth(cur_display,cur_display_number);
  cur_background_color = cur_get_color(cur_background_color_name,
       "background","blue","white",
       WhitePixel(cur_display,cur_display_number));
  cur_foreground_color = cur_get_color(cur_foreground_color_name,
       "foreground","grey95","black",
       BlackPixel(cur_display,cur_display_number));
  cur_root_window = RootWindow(cur_display,cur_display_number);
  cur_root_wlist.type = CUR_WLIST_ROOT;
  cur_root_wlist.window = cur_root_window;
  cur_base_window = XCreateSimpleWindow(cur_display,cur_root_window,0,0,
      cur_display_width,cur_display_height,4,cur_foreground_color,
      cur_background_color);
  cur_gc = XCreateGC(cur_display,cur_base_window,0,&xgcvalues);
  if ((cur_font = XLoadQueryFont(cur_display,"9x15")) == NULL)
    {
    cur_error("Could not find font 9x15");
    XCloseDisplay(cur_display);
    exit(1);
    }
  cur_font_height = cur_font->ascent + cur_font->descent;
  cur_font_decent = cur_font->descent;
  cur_button_width = XTextWidth(cur_font,"Cancel",6) + CUR_BUTTON_MARGIN;
  cur_button_height = cur_font_height + CUR_BUTTON_MARGIN;
  cur_width_80 = XTextWidth(cur_font,"mmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmmm",80);
  XSetFont(cur_display,cur_gc,cur_font->fid);
  XSetForeground(cur_display,cur_gc,cur_foreground_color);
  XSetLineAttributes(cur_display,cur_gc,1,LineSolid,CapButt,JoinMiter);
  cur_started = YES;
  } 

#if defined(PROTOTYPES)
void cur_stop(void)
#else
void cur_stop()
#endif
  {
  XUnloadFont(cur_display,cur_font->fid);
  XFreeGC(cur_display,cur_gc);
  XCloseDisplay(cur_display);
  }

#if defined(PROTOTYPES)
char *cur_strd(char *question, char *default_answer, char *answer)
#else
char *cur_strd(question,default_answer,answer) 
char *question; char *default_answer; char *answer;
#endif
  {
  cur_mlist_t item;

  item.name = question;
  item.type = CUR_MENU_STRING;
  item.type_special = 0;
  if (answer)
    {
    item.s_answer = cur_mk_str(default_answer);
    item.s_answer_size = strlen(default_answer);
    }
  else
    {
    item.s_answer = NULL;
    item.s_answer_size = 0;
    }
  item.i_answer = 0;
  item.l_answer = NULL;
  item.default_value.value = answer;
  item.have_default = YES;
  item.enterable = YES;
  item.must_have = YES;
  item.edited= NO;
  item.list = NULL;
  item.next = NULL;
  item.last = NULL;

  cur_menu_ask_true("String Question",&item,NULL,NO);

  if (answer)
    {
    strcpy(answer,item.s_answer);
    free(item.s_answer);
    }
  else
    answer = item.s_answer;
  return answer;
  }

#if defined(PROTOTYPES)
void cur_text_dsp(char **text)
#else
void cur_text_dsp(text) char **text;
#endif
  {
  cur_wlist_t		*cptr_cancel;
  cur_wlist_t		*cptr_holder;
  cur_wlist_t		*cptr_scroller;
  cur_wlist_t		*cptr_text;
  int			 init_lines;
  int			 lines;
  int			 loop;
  int			 max_width;
  char			**tptr;
  int			 width;
  int			 winsize = 0;
  char			**local_text;

  for (max_width = 0,tptr=text,lines = 0;*tptr;lines++,tptr++)
    {
    width = XTextWidth(cur_font,*tptr,strlen(*tptr)) + 40;
    if (width > max_width)
      max_width = width;
    }

  local_text = (char **)calloc(lines + 1,sizeof(char *));
  for (loop = 0;loop < lines;loop++)
    {
    if (strcmp(text[loop],"<END OF WINDOW>") != 0)
      local_text[loop] = text[loop];
    else
      local_text[loop] = "";
    }
  local_text[lines] = NULL;
  if (cur_width_80 > max_width)
    winsize = max_width;
  else
    winsize = cur_width_80;

  init_lines = (40 > lines ? lines  + 1: 40);

  cptr_holder = cur_mk_holder("Displayed Text","Text",winsize + 24,init_lines * cur_font_height + CUR_BUTTON_HEIGHT + 4,cur_width_80 / 80,cur_font_height,cur_width_80 / 8,cur_font_height * 5 + 42,NO);

  cptr_cancel = cur_mk_button(cptr_holder,"Cancel",-cptr_holder->width,-cptr_holder->height,0,SouthEastGravity,0,NULL,NULL,NULL,NULL,NULL);

  cptr_scroller = cur_mk_scroller(cptr_holder,0,0,winsize + 22,init_lines * cur_font_height + 2,cur_width_80 / 80,cur_font_height,10,0);

  cptr_text = cur_mk_text(cptr_scroller,local_text,0,0,max_width + 20,lines * cur_font_height);
  cur_warp(cptr_cancel);

  cptr_holder->data.holder.child = cptr_scroller;
  cptr_scroller->data.scroller.child = cptr_text;
  cptr_scroller->data.scroller.child_width = cptr_text->width;
  cptr_scroller->data.scroller.child_height = cptr_text->height;

  cur_process_events();

  cur_rm_text(cptr_text);
  cur_rm_scroller(cptr_scroller);
  cur_rm_holder(cptr_holder);
  free(local_text);

  return;
  }

#if defined(PROTOTYPES)
void cur_warp(cur_wlist_t *cptr)
#else
void cur_warp(cptr) cur_wlist_t *cptr;
#endif
  {
  cptr->warp = YES;
  }
